
This is a patch file against 0.2.5.

Change to directory g10-0.2.5 (or however you renamed it)
and give this command:

     zcat somepath/g10-0.2.6.diff.gz | patch -p1

It is a good idea to rename your current directory to g10-0.2.6 now.



Prereq: 0.2.5

diff -urN g10-0.2.5/VERSION g10-0.2.6/VERSION
--- g10-0.2.5/VERSION	Thu Feb 12 14:26:04 1998
+++ g10-0.2.6/VERSION	Fri Feb 13 21:49:23 1998
@@ -1 +1 @@
-0.2.5
+0.2.6

diff -urN g10-0.2.5/ChangeLog g10-0.2.6/ChangeLog
--- g10-0.2.5/ChangeLog	Tue Feb 10 11:57:29 1998
+++ g10-0.2.6/ChangeLog	Fri Feb 13 19:44:43 1998
@@ -1,5 +1,5 @@
-Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
-
-	* ddd/hhhh:
+Fri Feb 13 19:43:41 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
+	* configure.in : Fixed zlib stuff
+	* Makefile.am: Likewise
 
diff -urN g10-0.2.5/INSTALL g10-0.2.6/INSTALL
--- g10-0.2.5/INSTALL	Mon Jan 12 10:52:53 1998
+++ g10-0.2.6/INSTALL	Fri Feb 13 12:47:01 1998
@@ -1,3 +1,50 @@
+
+Please read the Basic Installation section somewhere below.
+
+Configure options for G10
+=========================
+
+--with-zlib	    Forces usage of the local zlib sources. Default is
+		    to use the (sahred) library of the system.
+
+--without-nls	    Disable NLS support
+
+--enable-m-debug    Compile with the integrated malloc debugging stuff.
+		    This makes the program slower but is checks every
+		    free operation and can be used to create statistics
+		    of memory usage. If this option is used the program
+		    option "--debug 32" displays every call to a a malloc
+		    function (this makes the program *really* slow), the
+		    option "--debug 128" displays a memory statistic after
+		    the program run.
+
+Problems
+========
+
+If you have compile problems, use the configure options "--with-zlib" and
+"--without-nls".
+
+I cant check alls assembles files; so if you have problems assembling them
+(or the program crashes), simply delete the files in the mpi/<cpu> directory.
+The configure scripts may consider several subdirectories to get all
+available assembler files; be sure to delete the correct ones. The
+assembler replacements are in C and in mpi/generic; never delete udiv-qrnnd.S
+in any CPU directory, because there maybe no C substitute.
+Don't forget to delete "config.cache" and run "./config.status --recheck".
+
+
+
+
+Installation
+============
+G10 is not installed as suid:root; if you want to use it, do it manually
+(only g10, not g10maint).
+
+You have to create the ~/.g10 directory manually.  Your first action after
+this should be to create a key pair: "g10 --gen-key".
+
+
+
 Basic Installation
 ==================
 
diff -urN g10-0.2.5/Makefile.am g10-0.2.6/Makefile.am
--- g10-0.2.5/Makefile.am	Thu Feb 12 13:59:17 1998
+++ g10-0.2.6/Makefile.am	Fri Feb 13 12:13:21 1998
@@ -1,8 +1,7 @@
 ## Process this file with automake to produce Makefile.in
 
-SUBDIRS =  intl po util mpi cipher @ZLIB_SUBDIR@ tools g10
+SUBDIRS =  intl po zlib util mpi cipher tools g10
 EXTRA_DIST = VERSION
-
 
 
 tar:	clean
diff -urN g10-0.2.5/Makefile.in g10-0.2.6/Makefile.in
--- g10-0.2.5/Makefile.in	Thu Feb 12 14:34:32 1998
+++ g10-0.2.6/Makefile.in	Fri Feb 13 21:27:22 1998
@@ -85,9 +85,8 @@
 RANLIB = @RANLIB@
 VERSION = @VERSION@
 ZLIBS = @ZLIBS@
-ZLIB_SUBDIR = @ZLIB_SUBDIR@
 
-SUBDIRS =  intl po util mpi cipher @ZLIB_SUBDIR@ tools g10
+SUBDIRS =  intl po zlib util mpi cipher tools g10
 EXTRA_DIST = VERSION
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
diff -urN g10-0.2.5/NEWS g10-0.2.6/NEWS
--- g10-0.2.5/NEWS	Thu Feb 12 14:25:33 1998
+++ g10-0.2.6/NEWS	Fri Feb 13 21:12:21 1998
@@ -1,3 +1,9 @@
+Noteworthy changes in version 0.2.6
+-----------------------------------
+
+    * Option "--export" works.
+
+
 Noteworthy changes in version 0.2.5
 -----------------------------------
 
diff -urN g10-0.2.5/README g10-0.2.6/README
--- g10-0.2.5/README	Mon Feb  9 13:50:36 1998
+++ g10-0.2.6/README	Fri Feb 13 21:19:18 1998
@@ -2,13 +2,24 @@
 	     G10 - The GNU Encryption and Signing Tool
 	    ------------------------------------------
 
-
-    THIS IS VERSION IS ONLY A TEST VERSION !  YOU SHOULD NOT
-    USE IT FOR OTHER PURPOSES THAN EVALUATING THE CURRENT CODE.
-
-    * The data format may change in the next version!
-
-    * Some features are not yet implemented
+    THIS IS ALPHA SOFTWARE, EXPECT BUGS AND UNIMPLEMENTED STUFF.
+    IT MAY HAPPEN THAT SOME DATA FORMATS OR PROGRAMM OPTIONS
+    CHANGE WITH THE NEXT VERSION.
+
+    On a Linux box (version 2.x.x, alpha or x86 CPU) it should
+    work reliable. You may create your key on such a machine and
+    use it.  Please verify the tar file; there is a PGP and a G10
+    signature available. My PGP key is well known and published in
+    the "Global Trust Register for 1998", ISBN 0-9532397-0-5.
+
+    I have included my pubring as "g10/pubring.10", which contains
+    the key used to make G10 signatures:
+    "pub  1312G/FF3EAA0B 1998-02-09 Werner Koch <wk@isil.d.shuttle.de>"
+    "Key fingerprint = 8489 6CD0 1851 0E33 45DA  CD67 036F 11B8 FF3E AA0B"
+
+    You may add it to your G10 pubring and use it in the future to
+    verify new releases.  Because you verified the tar file containing
+    this file here, you can be sure that the above fingerprint is correct.
 
 
     Please subscribe to g10@net.lut.ac.uk by sending a mail with
@@ -42,11 +53,9 @@
     Installation
     ------------
 
-    1)	"./configure"
-
-       to enable the integrated malloc debugging stuff, use:
+    See the file INSTALL.  Here is a quick summary:
 
-	"./configure --enable-m-debug"
+    1)	"./configure"
 
     2) "make"
 
@@ -54,7 +63,10 @@
 
     4) You end up with a binary "g10" in /usr/local/bin
 
-    5) create a directory ".g10" under your hoem directory ("mkdir ~/.g10")
+    5) Optional, but suggested: install the program "g10" as suid root.
+
+    6) Create a directory ".g10" under your home directory ("mkdir ~/.g10")
+
 
 
 
@@ -241,20 +253,20 @@
     you are asked for the passphrase, so that G10 is able to look at the
     inner structure of a encrypted packet.
 
-	--quick-random
+	g10maint --quick-random
 
     Do not use the stroing random generator but a faster one.  This can be
     used to generate keys for tests; those are marked as insecure.
 
-	--list-trustdb
+	g10maint --list-trustdb
 
     List the contents of the trustdb in a human readable format
 
-	--list-trustdb	<usernames>
+	g10maint --list-trustdb  <usernames>
 
     List the tree of certificates for the given usernames
 
-	--list-trust-path  depth  username
+	g10maint --list-trust-path  depth  username
 
     List the possible trust paths for the given username, up to the specified
     depth.  If depth is negative, duplicate introducers are not listed,
@@ -263,25 +275,25 @@
      using a negative number). This option may create new entries in the
     trustdb.
 
-	--print-mds  filenames
+	g10maint --print-mds  filenames
 
     List all available message digest values for the fiven filenames
 
-	--gen-prime n
+	g10maint --gen-prime n
 
     Generate and print a simple prime number of size n
 
-	--gen-prime n q
+	g10maint --gen-prime n q
 
     Generate a prime number suitable for ElGamal signatures of size n with
     a q as largest primefactor of n-1.
 
-	--gen-prime n q 1
+	g10maint --gen-prime n q 1
 
     Ditto, but calculate a generator too.
 
 
-    For more options/commands see the file g10/OPTIONS.
+    For more options/commands see the file g10/OPTIONS, or use "g10 --help"
 
 
     Debug Flags
@@ -311,7 +323,10 @@
     but for now I stick to my own formatting rules.
 
     The primary FTP site is "ftp://ftp.guug.de/pub/gcrypt/"
-    The primary WWW page is "http://www.d.shuttle.de/isil/g10.html"
+    The primary WWW page is "http://www.d.shuttle.de/isil/crypt/g10.html"
+
+    If you like, send your keys to <g10-keys@isil.d.shuttle.de>; use
+    "g10 --export --armor | mail g10-keys@isil.d.shuttle.de" to do this.
 
     Please direct bug reports to <g10-bugs@isil.d.shuttle.de> or better
     post them to the mailing list <g10@net.lut.ac.uk>.
diff -urN g10-0.2.5/THANKS g10-0.2.6/THANKS
--- g10-0.2.5/THANKS	Tue Feb 10 14:22:16 1998
+++ g10-0.2.6/THANKS	Fri Feb 13 11:52:46 1998
@@ -9,7 +9,10 @@
 Detlef Lannert		lannert@lannert.rz.uni-duesseldorf.de
 Ernst Molitor		ernst.molitor@uni-bonn.de
 Hendrik Buschkamp	buschkamp@rheumanet.org
+Jean-loup Gailly	gzip@prep.ai.mit.edu
 Jens Bachem		bachem@rrz.uni-koeln.de
+Mark Adler		madler@alumni.caltech.edu
+Martin Schulte		schulte@thp.uni-koeln.de
 Peter Gutmann		pgut001@cs.auckland.ac.nz
 Ralph Gillen		gillen@theochem.uni-duesseldorf.de
 Thomas Roessler 	roessler@guug.de
diff -urN g10-0.2.5/TODO g10-0.2.6/TODO
--- g10-0.2.5/TODO	Wed Feb 11 23:13:23 1998
+++ g10-0.2.6/TODO	Fri Feb 13 12:44:55 1998
@@ -23,4 +23,15 @@
       we have a self-signature -> put this stuff into a kind of directory
       record, as it does not belong to the pubkey record?
 
+    * add an option to create a new user id and to reorder the sequence of
+      them, so that the preferred emal address comes first.  We need to
+      add some logic, which guarantees, that only one user-id can be signed by
+      others.  This prevents extensive growing of the public key certificate
+      due to the bad usage of signing every user id.  You get no extra
+      security by key signatures for every user id.  I consider this
+      behaviour of PGP a bug, introduced, becaus PGP does't require a
+      self-signature. New user ids will only have your self signature to bind
+      them to your key and because the user id which is signed by others has
+      also be signed by you, all user-ids are bound together.
+
 
diff -urN g10-0.2.5/aclocal.m4 g10-0.2.6/aclocal.m4
--- g10-0.2.5/aclocal.m4	Thu Feb 12 14:26:16 1998
+++ g10-0.2.6/aclocal.m4	Fri Feb 13 14:53:51 1998
@@ -406,3 +406,16 @@
 fi
 AC_SUBST($1)])
 
+# Define a conditional.
+
+AC_DEFUN(AM_CONDITIONAL,
+[AC_SUBST($1_TRUE)
+AC_SUBST($1_FALSE)
+if $2; then
+  $1_TRUE=
+  $1_FALSE='#'
+else
+  $1_TRUE='#'
+  $1_FALSE=
+fi])
+
diff -urN g10-0.2.5/checks/checkit g10-0.2.6/checks/checkit
--- g10-0.2.5/checks/checkit	Thu Feb 12 10:28:24 1998
+++ g10-0.2.6/checks/checkit	Thu Feb 12 22:30:55 1998
@@ -44,11 +44,9 @@
 
 
 run_g10 () {
-    eval HOME=. ../g10/g10 $*
-    if [ $? != 0 ] ; then
-	g10_err=$?
+    if ! eval HOME=. ../g10/g10 $* ; then
 	echo "(HOME=. ../g10/g10 $*) failed" >&2
-	error "g10 failed: $g10_err"
+	exit 1
     fi
 }
 
@@ -58,7 +56,7 @@
 
 set -e
 pgmname=$(basename $0)
-trap cleanup EXIT SIGHUP SIGINT SIGQUIT
+trap cleanup SIGHUP SIGINT SIGQUIT
 
 
 # some checks
@@ -79,7 +77,7 @@
 
 # print the G10 version
 run_g10 --version
-# intialize the trustdb
+
 
 info Checking decryption
 for i in $plain_files ; do
@@ -133,6 +131,7 @@
 
 info Checking armored encryption with a pipe
 for i in $plain_files $data_files ; do
+    info "file $i"
     run_g10 -ea --yes -r "$usrname2" < $i | tee x \
     | run_g10 -o y --yes
     cmp $i y || error "$i: mismatch"
diff -urN g10-0.2.5/cipher/ChangeLog g10-0.2.6/cipher/ChangeLog
--- g10-0.2.5/cipher/ChangeLog	Tue Feb 10 11:57:29 1998
+++ g10-0.2.6/cipher/ChangeLog	Fri Feb 13 13:18:51 1998
@@ -1,5 +0,0 @@
-Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
-
-	* ddd/hhhh:
-
-
diff -urN g10-0.2.5/cipher/Makefile.in g10-0.2.6/cipher/Makefile.in
--- g10-0.2.5/cipher/Makefile.in	Thu Feb 12 14:34:58 1998
+++ g10-0.2.6/cipher/Makefile.in	Fri Feb 13 21:27:36 1998
@@ -85,7 +85,6 @@
 RANLIB = @RANLIB@
 VERSION = @VERSION@
 ZLIBS = @ZLIBS@
-ZLIB_SUBDIR = @ZLIB_SUBDIR@
 
 INCLUDES =  -I$(top_srcdir)/include
 EXTRA_DIST = @CIPHER_EXTRA_DIST@
diff -urN g10-0.2.5/configure g10-0.2.6/configure
--- g10-0.2.5/configure	Thu Feb 12 14:26:41 1998
+++ g10-0.2.6/configure	Fri Feb 13 21:19:52 1998
@@ -3757,11 +3757,17 @@
 fi
 
 
-ZLIBS=
-ZLIB_SUBDIR=
 if test "$g10_force_zlib" = "yes"; then
-    ZLIBS="\${top_srcdir}/zlib/libzlib.a"
-    ZLIB_SUBDIR=zlib
+    ZLIBS="-L\${top_srcdir}/zlib -lzlib"
+    
+
+if true; then
+  ENABLE_LOCAL_ZLIB_TRUE=
+  ENABLE_LOCAL_ZLIB_FALSE='#'
+else
+  ENABLE_LOCAL_ZLIB_TRUE='#'
+  ENABLE_LOCAL_ZLIB_FALSE=
+fi
      if test "x$wk_link_files_src" = "x"; then
 	wk_link_files_src="zlib/zlib.h"
 	wk_link_files_dst="zlib.h "
@@ -3783,17 +3789,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:3787: checking for $ac_hdr" >&5
+echo "configure:3793: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3792 "configure"
+#line 3798 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3797: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3803: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -3821,9 +3827,27 @@
 
 if test "$ac_cv_header_zlib_h" = yes ; then
     LIBS="$LIBS -lz"
+    ZLIBS=
+    
+
+if false; then
+  ENABLE_LOCAL_ZLIB_TRUE=
+  ENABLE_LOCAL_ZLIB_FALSE='#'
 else
-    ZLIBS="\${top_srcdir}/zlib/libzlib.a"
-    ZLIB_SUBDIR=zlib
+  ENABLE_LOCAL_ZLIB_TRUE='#'
+  ENABLE_LOCAL_ZLIB_FALSE=
+fi
+else
+    ZLIBS="-L\${top_srcdir}/zlib -lzlib"
+    
+
+if true; then
+  ENABLE_LOCAL_ZLIB_TRUE=
+  ENABLE_LOCAL_ZLIB_FALSE='#'
+else
+  ENABLE_LOCAL_ZLIB_TRUE='#'
+  ENABLE_LOCAL_ZLIB_FALSE=
+fi
      if test "x$wk_link_files_src" = "x"; then
 	wk_link_files_src="zlib/zlib.h"
 	wk_link_files_dst="zlib.h "
@@ -3848,7 +3872,7 @@
 CIPHER_EXTRA_OBJS=""
 CIPHER_EXTRA_DIST=""
 echo $ac_n "checking for extra cipher modules""... $ac_c" 1>&6
-echo "configure:3852: checking for extra cipher modules" >&5
+echo "configure:3876: checking for extra cipher modules" >&5
 if eval "test \"`echo '$''{'ac_cv_have_rsa_cipher'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -4062,8 +4086,9 @@
 s%@POSUB@%$POSUB%g
 s%@G10_LOCALEDIR@%$G10_LOCALEDIR%g
 s%@MPI_EXTRA_ASM_OBJS@%$MPI_EXTRA_ASM_OBJS%g
+s%@ENABLE_LOCAL_ZLIB_TRUE@%$ENABLE_LOCAL_ZLIB_TRUE%g
+s%@ENABLE_LOCAL_ZLIB_FALSE@%$ENABLE_LOCAL_ZLIB_FALSE%g
 s%@ZLIBS@%$ZLIBS%g
-s%@ZLIB_SUBDIR@%$ZLIB_SUBDIR%g
 s%@CIPHER_EXTRA_OBJS@%$CIPHER_EXTRA_OBJS%g
 s%@CIPHER_EXTRA_DIST@%$CIPHER_EXTRA_DIST%g
 
diff -urN g10-0.2.5/configure.in g10-0.2.6/configure.in
--- g10-0.2.5/configure.in	Thu Feb 12 14:17:05 1998
+++ g10-0.2.6/configure.in	Fri Feb 13 14:19:27 1998
@@ -162,26 +162,26 @@
 
 dnl Do we have zlib? Must do it here because Solaris failed
 dnl when compiling a conftest (due to the "-lz" from LIBS).
-ZLIBS=
-ZLIB_SUBDIR=
 if test "$g10_force_zlib" = "yes"; then
-    ZLIBS="\${top_srcdir}/zlib/libzlib.a"
-    ZLIB_SUBDIR=zlib
+    ZLIBS="-L\${top_srcdir}/zlib -lzlib"
+    AM_CONDITIONAL(ENABLE_LOCAL_ZLIB, true)
     WK_LINK_FILES(zlib/zlib.h, zlib.h )
     WK_LINK_FILES(zlib/zconf.h, zconf.h )
 else
 AC_CHECK_HEADERS(zlib.h)
 if test "$ac_cv_header_zlib_h" = yes ; then
     LIBS="$LIBS -lz"
+    ZLIBS=
+    AM_CONDITIONAL(ENABLE_LOCAL_ZLIB, false)
 else
-    ZLIBS="\${top_srcdir}/zlib/libzlib.a"
-    ZLIB_SUBDIR=zlib
+    ZLIBS="-L\${top_srcdir}/zlib -lzlib"
+    AM_CONDITIONAL(ENABLE_LOCAL_ZLIB, true)
     WK_LINK_FILES(zlib/zlib.h, zlib.h )
     WK_LINK_FILES(zlib/zconf.h, zconf.h )
 fi
 fi
 AC_SUBST(ZLIBS)
-AC_SUBST(ZLIB_SUBDIR)
+
 
 dnl checking whether we have other cipher source files
 CIPHER_EXTRA_OBJS=""
diff -urN g10-0.2.5/doc/DETAILS g10-0.2.6/doc/DETAILS
--- g10-0.2.5/doc/DETAILS	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/doc/DETAILS	Sat Jan 31 22:25:36 1998
@@ -0,0 +1,177 @@
+
+
+    * For packet version 3 we calculate the keyids this way:
+	RSA	:= low 64 bits of n
+	ELGAMAL := build a v3 pubkey packet (with CTB 0x99) and calculate
+		   a rmd160 hash value from it. This is used as the
+		   fingerprint and the low 64 bits are the keyid.
+
+
+
+
+Layout of the TrustDB
+=====================
+FIXME: use a directory record as top node instead of the pubkey record
+
+The TrustDB is build from fixed length records, where the first bytes
+describes the record type.  All numeric values are stored in network
+byte order. The length of each record is 40 bytes. The first record of
+the DB is always of type 1 and this is the only record of this type.
+
+Record type 0:
+--------------
+    Unused record, can be reused for any purpose.
+
+Record type 1:
+--------------
+    Version information for this TrustDB.  This is always the first
+    record of the DB and the onyl one with type 1.
+     1 byte value 1
+     3 bytes 'g10'  magic value
+     1 byte Version of the TrustDB
+     3 byte reserved
+     1 u32  locked by (pid) 0 = not locked.
+     1 u32  timestamp of trustdb creation
+     1 u32  timestamp of last modification
+     1 u32  timestamp of last validation
+	    (Used to keep track of the time, when this TrustDB was checked
+	     against the pubring)
+     1 u32  reserved
+     1 byte marginals needed
+     1 byte completes needed
+     1 byte max. cert depth
+	    If any of this 3 values are changed, all cache records
+	    muts be invalidated.
+     9 bytes reserved
+
+
+Record type 2: (directory record)
+--------------
+    Informations about a public key certificate.
+    These are static values which are never changed without user interaction.
+
+     1 byte value 2
+     1 byte   reserved
+     8 bytes keyid (We keep it here to speed up searching by keyid)
+     1 u32   Local-Id.	This is simply the record number of this record.
+     1 u32   pubkey (record number of it)
+     1 u32   cache record
+     1 u32   sigrecord
+     1 byte  No signatures flag  (used to avoid duplicate building).
+     13 byte reserved
+
+
+Record type 3:
+--------------
+    Informations about a public key certificate.
+    These are static values which are never changed without user interaction.
+
+     1 byte value 3
+     1 byte   reserved
+     1 u32   owner  This is used to bind all records for
+	     a given certificate together. It is valid only in this TrustDB
+	     and usefull if we have duplicate keyids
+	     It points back to the directory node.
+     1 byte pubkey algorithm
+     1 byte reserved
+     20 bytes fingerprint of the public key
+     1 byte ownertrust:
+     3 byte reserved
+
+
+Record type 4:	(cache record)
+--------------
+    Used to bind the trustDB to the concrete instance of keyblock in
+    a pubring. This is used to cache informations.
+
+     1 byte   value 4
+     1 byte   reserved
+     1 u32    Local-Id.
+     8 bytes  keyid of the primary key (needed?)
+     1 byte   cache-is-valid the following stuff is only
+	      valid if this is set.
+     1 byte   reserved
+     20 bytes rmd160 hash value over the complete keyblock
+	      This is used to detect any changes of the keyblock with all
+	      CTBs and lengths headers. Calculation is easy if the keyblock
+	      is optained from a keyserved: simply create the hash from all
+	      received data bytes.
+
+     1 byte   number of untrusted signatures.
+     1 byte   number of marginal trusted signatures.
+     1 byte   number of fully trusted signatures.
+	      (255 is stored for all values greater than 254)
+     1 byte   Trustlevel
+		0 = undefined (not calculated)
+		1 = unknown
+		2 = not trusted
+		3 = marginally trusted
+		4 = fully trusted
+		5 = ultimately trusted (have secret key too).
+
+Record type 5  (sigrec)
+-------------
+    Used to keep track of valid key signatures. Self-signatures are not
+    stored.
+
+     1 byte   value 5
+     1 byte   reserved
+     1 u32    For Local-Id (points back to the directory record)
+     1 u32    chain: next sigrec of this owner or 0 to indicate the
+	      last sigrec.
+     6 times
+	1 u32  Local_id of signators pubkey record
+	1 byte reserved
+
+
+Record Type 6 (hash table)
+-------------
+    Due to the fact that we use the keyid to lookup keys, we can
+    implement quick access by some simple hash methods, and avoid
+    the overhead gdbm.	A property of keyids is that they can be
+    used directly as hash value (They can be considered as strong
+    random numbers.
+      What we use is a dynamic multilevel architecture, which combines
+    Hashtables, record lists, and linked list.
+
+    This record is a hashtable of 256 entries; a special property
+    is, that all these records are adjacent stored to make up one
+    big table. The hash value is simple the 1st, 2nd, ... byte of
+    the keyid (depending on the indirection level).
+
+     1 byte value 5
+     1 byte reserved
+     n u32  recnum; n depends on th record length:
+	    n = (reclen-2)/4  which yields 9 for the current record length
+	    of 40 bytes.
+
+    the total number of surch record which makes up the table is:
+	 m = (256+n-1) / n
+    which is 29 for a record length of 40.
+
+    To look up a key we use its lsb to get the recnum from this
+    hashtable and look up this addressed record:
+       - If this record is another hashtable, we use 2nd lsb
+	 to index this hast table and so on.
+       - if this record is of hashlist, we lwalk thru these
+	 reclist record until we found one whos hash fields
+	 matches the MSB of our keyid, and lookup this record
+       - if this record is a dir record, we compare the
+	 keyid and if this is correct, we get the keyrecod and compare
+	 the fingerprint to decide wether it is the requested key;
+	 if this is not the correct dir record, we look at the next
+	 dir record which is linked by the link field.
+
+Record type 7  (hast list)
+-------------
+    see hash table for an explanation.
+
+    1 byte value 6
+    1 byte reserved
+    1 u32  chain	 next hash list record
+    n times		 n = (reclen-6)/5
+	1 byte hash
+	1 u32  recnum
+
+    For the current record length of 40, n is 6
+
diff -urN g10-0.2.5/doc/distfiles g10-0.2.6/doc/distfiles
--- g10-0.2.5/doc/distfiles	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/doc/distfiles	Thu Feb 12 21:48:01 1998
@@ -0,0 +1,8 @@
+
+DETAILS
+rfc1423
+rfc1750
+rfc1991new
+rfc2015
+rfc2144
+
diff -urN g10-0.2.5/doc/rfc1423 g10-0.2.6/doc/rfc1423
--- g10-0.2.5/doc/rfc1423	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/doc/rfc1423	Fri Nov 28 10:20:40 1997
@@ -0,0 +1,787 @@
+
+
+
+
+
+
+Network Working Group                                        D. Balenson
+Request for Comments: 1423                                           TIS
+Obsoletes: 1115                               IAB IRTF PSRG, IETF PEM WG
+                                                           February 1993
+
+
+           Privacy Enhancement for Internet Electronic Mail:
+              Part III: Algorithms, Modes, and Identifiers
+
+Status of This Memo
+
+   This RFC specifies an IAB standards track protocol for the Internet
+   community, and requests discussion and suggestions for improvements.
+   Please refer to the current edition of the "IAB Official Protocol
+   Standards" for the standardization state and status of this protocol.
+   Distribution of this memo is unlimited.
+
+Abstract
+
+   This document provides definitions, formats, references, and
+   citations for cryptographic algorithms, usage modes, and associated
+   identifiers and parameters used in support of Privacy Enhanced Mail
+   (PEM) in the Internet community.  It is intended to become one member
+   of the set of related PEM RFCs.  This document is organized into four
+   primary sections, dealing with message encryption algorithms, message
+   integrity check algorithms, symmetric key management algorithms, and
+   asymmetric key management algorithms (including both asymmetric
+   encryption and asymmetric signature algorithms).
+
+   Some parts of this material are cited by other documents and it is
+   anticipated that some of the material herein may be changed, added,
+   or replaced without affecting the citing documents.  Therefore,
+   algorithm-specific material has been placed into this separate
+   document.
+
+   Use of other algorithms and/or modes will require case-by-case study
+   to determine applicability and constraints.  The use of additional
+   algorithms may be documented first in Prototype or Experimental RFCs.
+   As experience is gained, these protocols may be considered for
+   incorporation into the standard.  Additional algorithms and modes
+   approved for use in PEM in this context will be specified in
+   successors to this document.
+
+Acknowledgments
+
+   This specification was initially developed by the Internet Research
+   Task Force's Privacy and Security Research Group (IRTF PSRG) and
+   subsequently refined based on discussion in the Internet Engineering
+
+
+
+Balenson                                                        [Page 1]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+   Task Force's Privacy Enhanced Mail Working Group (IETF PEM WG).  John
+   Linn contributed significantly to the predecessor of this document
+   (RFC 1115).  I would like to thank the members of the PSRG and PEM
+   WG, as well as all participants in discussions on the "pem-
+   dev@tis.com" mailing list, for their contributions to this document.
+
+Table of Contents
+
+      1.  Message Encryption Algorithms ....................... 2
+      1.1  DES in CBC Mode (DES-CBC) .......................... 2
+      2.  Message Integrity Check Algorithms .................. 4
+      2.1  RSA-MD2 Message Digest Algorithm ................... 4
+      2.2  RSA-MD5 Message Digest Algorithm ................... 5
+      3.  Symmetric Key Management Algorithms ................. 6
+      3.1  DES in ECB mode (DES-ECB) .......................... 6
+      3.2  DES in EDE mode (DES-EDE) .......................... 7
+      4.  Asymmetric Key Management Algorithms ................ 7
+      4.1  Asymmetric Keys .................................... 7
+      4.1.1  RSA Keys ......................................... 7
+      4.2  Asymmetric Encryption Algorithms ..................  9
+      4.2.1  RSAEncryption ...................................  9
+      4.3  Asymmetric Signature Algorithms ................... 10
+      4.3.1  md2WithRSAEncryption ............................ 11
+      5.  Descriptive Grammar ................................ 11
+      References ............................................. 12
+      Patent Statement ....................................... 13
+      Security Considerations ................................ 14
+      Author's Address ....................................... 14
+
+1.  Message Encryption Algorithms
+
+   This section identifies the alternative message encryption algorithms
+   and modes that shall be used to encrypt message text and, when
+   asymmetric key management is employed in an ENCRYPTED PEM message, for
+   encryption of message signatures.  Character string identifiers are
+   assigned and any parameters required by the message encryption
+   algorithm are defined for incorporation in an encapsulated "DEK-
+   Info:" header field.
+
+   Only one alternative is currently defined in this category.
+
+1.1  DES in CBC Mode (DES-CBC)
+
+   Message text and, if required, message signatures are encrypted using
+   the Data Encryption Standard (DES) algorithm in the Cipher Block
+   Chaining (CBC) mode of operation.  The DES algorithm is defined in
+   FIPS PUB 46-1 [1], and is equivalent to the Data Encryption Algorithm
+   (DEA) provided in ANSI X3.92-1981 [2].  The CBC mode of operation of
+
+
+
+Balenson                                                        [Page 2]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+   DES is defined in FIPS PUB 81 [3], and is equivalent to those
+   provided in ANSI X3.106 [4] and in ISO IS 8372 [5].  The character
+   string "DES-CBC" within an encapsulated PEM header field indicates
+   the use of this algorithm/mode combination.
+
+   The input to the DES CBC encryption process shall be padded to a
+   multiple of 8 octets, in the following manner.  Let n be the length
+   in octets of the input.  Pad the input by appending 8-(n mod 8)
+   octets to the end of the message, each having the value 8-(n mod 8),
+   the number of octets being added.  In hexadecimal, the possible
+   paddings are:  01, 0202, 030303, 04040404, 0505050505, 060606060606,
+   07070707070707, and 0808080808080808.  All input is padded with 1 to
+   8 octets to produce a multiple of 8 octets in length.  The padding
+   can be removed unambiguously after decryption.
+
+   The DES CBC encryption process requires a 64-bit cryptographic key.
+   A new, pseudorandom key shall be generated for each ENCRYPTED PEM
+   message.  Of the 64 bits, 56 are used directly by the DES CBC
+   process, and 8 are odd parity bits, with one parity bit occupying the
+   right-most bit of each octet.  When symmetric key management is
+   employed, the setting and checking of odd parity bits is encouraged,
+   since these bits could detect an error in the decryption of a DES key
+   encrypted under a symmetric key management algorithm (e.g., DES ECB).
+   When asymmetric key management is employed, the setting of odd parity
+   bits is encouraged, but the checking of odd parity bits is
+   discouraged, in order to facilitate interoperability, and since an
+   error in the decryption of a DES key can be detected by other means
+   (e.g., an incorrect PKCS #1 encryption-block format).  In all cases,
+   the encrypted form of a DES key shall carry all 64 bits of the key,
+   including the 8 parity bits, though those bits may have no meaning.
+
+   The DES CBC encryption process also requires a 64-bit Initialization
+   Vector (IV).  A new, pseudorandom IV shall be generated for each
+   ENCRYPTED PEM message.  Section 4.3.1 of [7] provides rationale for
+   this requirement, even given the fact that individual DES keys are
+   generated for individual messages.  The IV is transmitted with the
+   message within an encapsulated PEM header field.
+
+   When this algorithm/mode combination is used for message text
+   encryption, the "DEK-Info:" header field carries exactly two
+   arguments.  The first argument identifies the DES CBC algorithm/mode
+   using the character string defined above.  The second argument
+   contains the IV, represented as a contiguous string of 16 ASCII
+   hexadecimal digits.
+
+   When symmetric key management is employed with this algorithm/mode
+   combination, a symmetrically encrypted DES key will be represented in
+   the third argument of a "Key-Info:" header field as a contiguous
+
+
+
+Balenson                                                        [Page 3]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+   string of 16 ASCII hexadecimal digits (corresponding to a 64-bit
+   key).
+
+   To avoid any potential ambiguity regarding the ordering of the octets
+   of a DES key that is input as a data value to another encryption
+   process (e.g., RSAEncryption), the following holds true.  The first
+   (or left-most displayed, if one thinks in terms of a key's "print"
+   representation) (For purposes of discussion in this document, data
+   values are normalized in terms of their "print" representation.  For a
+   octet stream, the "first" octet would appear as the one on the "left",
+   and the "last" octet would appear on the "right".) octet of the key
+   (i.e., bits 1-8 per FIPS PUB 46-1), when considered as a data value,
+   has numerical weight 2**56.  The last (or right-most displayed) octet
+   (i.e., bits 57-64 per FIPS PUB 46-1) has numerical weight 2**0.
+
+2.  Message Integrity Check Algorithms
+
+   This section identifies the alternative algorithms that shall be used
+   to compute Message Integrity Check (MIC) values for PEM messages.
+   Character string identifiers and ASN.1 object identifiers are
+   assigned for incorporation in encapsulated "MIC-Info:" and "Key-
+   Info:" header fields to indicate the choice of MIC algorithm
+   employed.
+
+   A compliant PEM implementation shall be able to process all of the
+   alternative MIC algorithms defined here on incoming messages.  It is
+   a sender option as to which alternative is employed on an outbound
+   message.
+
+2.1  RSA-MD2 Message Digest Algorithm
+
+   The RSA-MD2 message digest is computed using the algorithm defined in
+   RFC 1319 [9].  ( An error has been identified in RFC 1319.  The
+   statement in the text of Section 3.2 which reads "Set C[j] to S[c xor
+   L]" should read "Set C[j] to S[c xor L] xor C[j]".  Note that the C
+   source code in the appendix of RFC 1319 is correct.)  The character
+   string "RSA-MD2" within an encapsulated PEM header field indicates the
+   use of this algorithm.  Also, as defined in RFC 1319, the ASN.1 object
+   identifier
+
+     md2 OBJECT IDENTIFIER ::= {
+         iso(1) member-body(2) US(840) rsadsi(113549)
+         digestAlgorithm(2) 2
+     }
+
+   identifies this algorithm.  When this object identifier is used with
+   the ASN.1 type AlgorithmIdentifier, the parameters component of that
+   type is the ASN.1 type NULL.
+
+
+
+Balenson                                                        [Page 4]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+   The RSA-MD2 message digest algorithm accepts as input a message of
+   any length and produces as output a 16-octet quantity.  When
+   symmetric key management is employed, an RSA-MD2 MIC is encrypted by
+   splitting the MIC into two 8-octet halves, independently encrypting
+   each half, and concatenating the results.
+
+   When symmetric key management is employed with this MIC algorithm,
+   the symmetrically encrypted MD2 message digest is represented in a
+   the fourth argument of a "Key-Info:" header field as a contiguous
+   string of 32 ASCII hexadecimal digits (corresponding to a 128-bit MD2
+   message digest).
+
+   To avoid any potential ambiguity regarding the ordering of the octets
+   of an MD2 message digest that is input as a data value to another
+   encryption process (e.g., RSAEncryption), the following holds true.
+   The first (or left-most displayed, if one thinks in terms of a
+   digest's "print" representation) octet of the digest (i.e., digest[0]
+   as specified in RFC 1319), when considered as an RSA data value, has
+   numerical weight 2**120.  The last (or right-most displayed) octet
+   (i.e., digest[15] as specified in RFC 1319) has numerical weight
+   2**0.
+
+2.2  RSA-MD5 Message Digest Algorithm
+
+   The RSA-MD5 message digest is computed using the algorithm defined in
+   RFC 1321 [10].  The character string "RSA-MD5" within an encapsulated
+   PEM header field indicates the use of this algorithm.  Also, as
+   defined in RFC 1321, the object identifier
+
+     md5 OBJECT IDENTIFIER ::= {
+         iso(1) member-body(2) US(840) rsadsi(113549)
+         digestAlgorithm(2) 5
+     }
+
+   identifies this algorithm.  When this object identifier is used with
+   the ASN.1 type AlgorithmIdentifier, the parameters component of that
+   type is the ASN.1 type NULL.
+
+   The RSA-MD5 message digest algorithm accepts as input a message of
+   any length and produces as output a 16-octet quantity.  When
+   symmetric key management is employed, an RSA-MD5 MIC is encrypted by
+   splitting the MIC into two 8-octet halves, independently encrypting
+   each half, and concatenating the results.
+
+   When symmetric key management is employed with this MIC algorithm,
+   the symmetrically encrypted MD5 message digest is represented in the
+   fourth argument of a "Key-Info:" header field as a contiguous string
+   of 32 ASCII hexadecimal digits (corresponding to a 128-bit MD5
+
+
+
+Balenson                                                        [Page 5]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+   message digest).
+
+   To avoid any potential ambiguity regarding the ordering of the octets
+   of a MD5 message digest that is input as an RSA data value to the RSA
+   encryption process, the following holds true.  The first (or left-
+   most displayed, if one thinks in terms of a digest's "print"
+   representation) octet of the digest (i.e., the low-order octet of A
+   as specified in RFC 1321), when considered as an RSA data value, has
+   numerical weight 2**120.  The last (or right-most displayed) octet
+   (i.e., the high-order octet of D as specified in RFC 1321) has
+   numerical weight 2**0.
+
+3.  Symmetric Key Management Algorithms
+
+   This section identifies the alternative algorithms and modes that
+   shall be used when symmetric key management is employed, to encrypt
+   data encryption keys (DEKs) and message integrity check (MIC) values.
+   Character string identifiers are assigned for incorporation in
+   encapsulated "Key-Info:" header fields to indicate the choice of
+   algorithm employed.
+
+   All alternatives presently defined in this category correspond to
+   different usage modes of the DES algorithm, rather than to other
+   algorithms.
+
+   When symmetric key management is employed, the symmetrically
+   encrypted DEK and MIC, carried in the third and fourth arguments of a
+   "Key-Info:" header field, respectively, are each represented as a
+   string of contiguous ASCII hexadecimal digits.  The manner in which
+   to use the following symmetric encryption algorithms and the length
+   of the symmetrically encrypted DEK and MIC may vary depending on the
+   length of the underlying DEK and MIC.  Section 1, Message Encryption
+   Algorithms, and Section 2, Message Integrity Check Algorithms,
+   provide information on the proper manner in which a DEK and MIC,
+   respectively, are symmetrically encrypted when the size of the DEK or
+   MIC is not equal to the symmetric encryption algorithm's input block
+   size.  These sections also provide information on the proper format
+   and length of the symmetrically encrypted DEK and MIC, respectively.
+
+3.1  DES in ECB Mode (DES-ECB)
+
+   The DES algorithm in Electronic Codebook (ECB) mode [1][3] is used
+   for DEK and MIC encryption when symmetric key management is employed.
+   The character string "DES-ECB" within an encapsulated PEM header
+   field indicates use of this algorithm/mode combination.
+
+   A compliant PEM implementation supporting symmetric key management
+   shall support this algorithm/mode combination.
+
+
+
+Balenson                                                        [Page 6]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+3.2  DES in EDE Mode (DES-EDE)
+
+   The DES algorithm in Encrypt-Decrypt-Encrypt (EDE) multiple
+   encryption mode, as defined by ANSI X9.17 [6] for encryption and
+   decryption with pairs of 64-bit keys, may be used for DEK and MIC
+   encryption when symmetric key management is employed.  The character
+   string "DES-EDE" within an encapsulated a PEM header field indicates
+   use of this algorithm/mode combination.
+
+   A compliant PEM implementation supporting symmetric key management
+   may optionally support this algorithm/mode combination.
+
+4.  Asymmetric Key Management Algorithms
+
+   This section identifies the alternative asymmetric keys and the
+   alternative asymmetric key management algorithms with which those
+   keys shall be used, namely the asymmetric encryption algorithms with
+   which DEKs and MICs are encrypted, and the asymmetric signature
+   algorithms with which certificates and certificate revocation lists
+   (CRLs) are signed.
+
+4.1  Asymmetric Keys
+
+   This section describes the asymmetric keys that shall be used with
+   the asymmetric encryption algorithms and the signature algorithms
+   described later.  ASN.1 object identifiers are identified for
+   incorporation in a public-key certificate to identify the
+   algorithm(s) with which the accompanying public key is to be
+   employed.
+
+4.1.1  RSA Keys
+
+   An RSA asymmetric key pair is comprised of matching public and
+   private keys.
+
+   An RSA public key consists of an encryption exponent e and an
+   arithmetic modulus n, which are both public quantities typically
+   carried in a public-key certificate.  For the value of e, Annex C to
+   X.509 suggests the use of Fermat's Number F4 (65537 decimal, or
+   1+2**16) as a value "common to the whole environment in order to
+   reduce transmission capacity and complexity of transformation", i.e.,
+   the value can be transmitted as 3 octets and at most seventeen (17)
+   multiplications are required to effect exponentiation.  As an
+   alternative, the number three (3) can be employed as the value for e,
+   requiring even less octets for transmission and yielding even faster
+   exponentiation.  For purposes of PEM, the value of e shall be either
+   F4 or the number three (3).  The use of the number three (3) for the
+   value of e is encouraged, to permit rapid certificate validation.
+
+
+
+Balenson                                                        [Page 7]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+   An RSA private key consists of a decryption exponent d, which should
+   be kept secret, and the arithmetic modulus n.  Other values may be
+   stored with a private key to facilitate efficient private key
+   operations (see PKCS #1 [11]).
+
+   For purposes of PEM, the modulus n may vary in size from 508 to 1024
+   bits.
+
+   Two ASN.1 object identifiers have been defined to identify RSA public
+   keys.  In Annex H of X.509 [8], the object identifier
+
+     rsa OBJECT IDENTIFIER ::= {
+         joint-iso-ccitt(2) ds(5) algorithm(8)
+         encryptionAlgorithm(1) 1
+     }
+
+   is defined to identify an RSA public key.  A single parameter,
+   KeySize, the length of the public key modulus in bits, is defined for
+   use in conjunction with this object identifier.  When this object
+   identifier is used with the ASN.1 type AlgorithmIdentifier, the
+   parameters component of that type is the number of bits in the
+   modulus, ASN.1 encoded as an INTEGER.
+
+   Alternatively, in PKCS #1 [11], the ASN.1 object identifier
+
+     rsaEncryption OBJECT IDENTIFIER ::= {
+         iso(1) member-body(2) US(840) rsadsi(113549) pkcs(1)
+         pkcs-1(1) 1
+     }
+
+   is defined to identify both an RSA public key and the RSAEncryption
+   process.  There are no parameters defined in conjunction with this
+   object identifier, hence, when it is used with the ASN.1 type
+   AlgorithmIdentifier, the parameters component of that type is the
+   ASN.1 type NULL.
+
+   A compliant PEM implementation may optionally generate an RSA
+   public-key certificate that identifies the enclosed RSA public key
+   (within the SubjectPublicKeyInformation component) with either the
+   "rsa" or the "rsaEncryption" object identifier.  Use of the "rsa"
+   object identifier is encouraged, since it is, in some sense, more
+   generic in its identification of a key, without indicating how the
+   key will be used.  However, to facilitate interoperability, a
+   compliant PEM implementation shall accept RSA public-key certificates
+   that identify the enclosed RSA public key with either the "rsa" or
+   the "rsaEncryption" object identifier.  In all cases, an RSA public
+   key identified in an RSA public-key certificate with either the "rsa"
+   or "rsaEncryption" object identifier, shall be used according to the
+
+
+
+Balenson                                                        [Page 8]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+   procedures defined below for asymmetric encryption algorithms and
+   asymmetric signature algorithms.
+
+4.2  Asymmetric Encryption Algorithms
+
+   This section identifies the alternative algorithms that shall be used
+   when asymmetric key management is employed, to encrypt DEKs and MICs.
+   Character string identifiers are assigned for incorporation in "MIC-
+   Info:" and "Key-Info:" header fields to indicate the choice of
+   algorithm employed.
+
+   Only one alternative is presently defined in this category.
+
+4.2.1  RSAEncryption
+
+   The RSAEncryption public-key encryption algorithm, defined in PKCS #1
+   [11], is used for DEK and MIC encryption when asymmetric key
+   management is employed.  The character string "RSA" within a "MIC-
+   Info:" or "Key-Info:" header field indicates the use of this
+   algorithm.
+
+   All PEM implementations supporting asymmetric key management shall
+   support this algorithm.
+
+   As described in PKCS #1, all quantities input as data values to the
+   RSAEncryption process shall be properly justified and padded to the
+   length of the modulus prior to the encryption process.  In general,
+   an RSAEncryption input value is formed by concatenating a leading
+   NULL octet, a block type BT, a padding string PS, a NULL octet, and
+   the data quantity D, that is,
+
+     RSA input value = 0x00 || BT || PS || 0x00 || D.
+
+   To prepare a DEK for RSAEncryption, the PKCS #1 "block type 02"
+   encryption-block formatting scheme is employed.  The block type BT is
+   a single octet containing the value 0x02 and the padding string PS is
+   one or more octets (enough octets to make the length of the complete
+   RSA input value equal to the length of the modulus) each containing a
+   pseudorandomly generated, non-zero value.  For multiple recipient
+   messages, a different, pseudorandom padding string should be used for
+   each recipient.  The data quantity D is the DEK itself, which is
+   right-justified within the RSA input such that the last (or rightmost
+   displayed, if one thinks in terms of the "print" representation)
+   octet of the DEK is aligned with the right-most, or least-
+   significant, octet of the RSA input.  Proceeding to the left, each of
+   the remaining octets of the DEK, up through the first (or left-most
+   displayed) octet, are each aligned in the next more significant octet
+   of the RSA input.
+
+
+
+Balenson                                                        [Page 9]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+   To prepare a MIC for RSAEncryption, the PKCS #1 "block type 01"
+   encryption-block formatting scheme is employed.  The block type BT is
+   a single octet containing the value 0x01 and the padding string PS is
+   one or more octets (enough octets to make the length of the complete
+   RSA input value equal to the length of the modulus) each containing
+   the value 0xFF.  The data quantity D is comprised of the MIC and the
+   MIC algorithm identifier which are ASN.1 encoded as the following
+   sequence.
+
+     SEQUENCE {
+         digestAlgorithm   AlgorithmIdentifier,
+         digest            OCTET STRING
+     }
+
+   The ASN.1 type AlgorithmIdentifier is defined in X.509 as follows.
+
+     AlgorithmIdentifier ::= SEQUENCE {
+         algorithm         OBJECT IDENTIFIER,
+         parameters        ANY DEFINED BY algorithm OPTIONAL
+     }
+
+   An RSA input block is encrypted using the RSA algorithm with the
+   first (or left-most) octet taken as the most significant octet, and
+   the last (or right-most) octet taken as the least significant octet.
+   The resulting RSA output block is interpreted in a similar manner.
+
+   When RSAEncryption is used to encrypt a DEK, the second argument in a
+   "MIC-Info:" header field, an asymmetrically encrypted DEK, is
+   represented using the printable encoding technique defined in Section
+   4.3.2.4 of RFC 1421 [12].
+
+   When RSAEncryption is used to sign a MIC, the third argument in a
+   "MIC-Info:" header field, an asymmetrically signed MIC, is
+   represented using the printable encoding technique defined in Section
+   4.3.2.4 of RFC 1421.
+
+4.3  Asymmetric Signature Algorithms
+
+   This section identifies the alternative algorithms which shall be
+   used to asymmetrically sign certificates and certificate revocation
+   lists (CRLs) in accordance with the SIGNED macro defined in Annex G
+   of X.509.  ASN.1 object identifiers are identified for incorporation
+   in certificates and CRLs to indicate the choice of algorithm
+   employed.
+
+   Only one alternative is presently defined in this category.
+
+
+
+
+
+Balenson                                                       [Page 10]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+4.3.1  md2WithRSAEncryption
+
+   The md2WithRSAEncryption signature algorithm is used to sign
+   certificates and CRLs.  The algorithm is defined in PKCS #1 [11].  It
+   combines the RSA-MD2 message digest algorithm described here in
+   Section 2.2 with the RSAEncryption asymmetric encryption algorithm
+   described here in Section 4.2.1.  As defined in PKCS #1, the ASN.1
+   object identifier
+
+     md2WithRSAEncryption OBJECT IDENTIFIER ::= {
+         iso(1) member-body(2) US(840) rsadsi(113549) pkcs(1)
+         pkcs-1(1) 2
+     }
+
+   identifies this algorithm.  When this object identifier is used with
+   the ASN.1 type AlgorithmIdentifier, the parameters component of that
+   type is the ASN.1 type NULL.
+
+   There is some ambiguity in X.509 regarding the definition of the
+   SIGNED macro and, in particular, the representation of a signature in
+   a certificate or a CRL.  The interpretation selected for PEM requires
+   that the data to be signed (in our case, an MD2 message digest) is
+   first ASN.1 encoded as an OCTET STRING and the result is encrypted
+   (in our case, using RSAEncryption) to form the signed quantity, which
+   is then ASN.1 encoded as a BIT STRING.
+
+5.  Descriptive Grammar
+
+   ; Addendum to PEM BNF representation, using RFC 822 notation
+   ; Provides specification for official PEM cryptographic algorithms,
+   ; modes, identifiers and formats.
+
+   ; Imports <hexchar> and <encbin> from RFC [1421]
+
+       <dekalgid> ::= "DES-CBC"
+       <ikalgid>  ::= "DES-EDE" / "DES-ECB" / "RSA"
+       <sigalgid> ::= "RSA"
+       <micalgid> ::= "RSA-MD2" / "RSA-MD5"
+
+       <dekparameters> ::= <DESCBCparameters>
+       <DESCBCparameters> ::= <IV>
+       <IV> ::= <hexchar16>
+
+       <symencdek> ::= <DESECBencDESCBC> / <DESEDEencDESCBC>
+       <DESECBencDESCBC> ::= <hexchar16>
+       <DESEDEencDESCBC> ::= <hexchar16>
+
+       <symencmic> ::= <DESECBencRSAMD2> / <DESECBencRSAMD5>
+
+
+
+Balenson                                                       [Page 11]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+       <DESECBencRSAMD2> ::= 2*2<hexchar16>
+       <DESECBencRSAMD5> ::= 2*2<hexchar16>
+
+       <asymsignmic> ::= <RSAsignmic>
+       <RSAsignmic> ::= <encbin>
+
+       <asymencdek> ::= <RSAencdek>
+       <RSAencdek> ::= <encbin>
+
+       <hexchar16> ::= 16*16<hexchar>
+
+References
+
+   [1] Federal Information Processing Standards Publication (FIPS PUB)
+       46-1, Data Encryption Standard, Reaffirmed 1988 January 22
+       (supersedes FIPS PUB 46, 1977 January 15).
+
+   [2] ANSI X3.92-1981, American National Standard Data Encryption
+       Algorithm, American National Standards Institute, Approved 30
+       December 1980.
+
+   [3] Federal Information Processing Standards Publication (FIPS PUB)
+       81, DES Modes of Operation, 1980 December 2.
+
+   [4] ANSI X3.106-1983, American National Standard for Information
+       Systems - Data Encryption Algorithm - Modes of Operation,
+       American National Standards Institute, Approved 16 May 1983.
+
+   [5] ISO 8372, Information Processing Systems: Data Encipherment:
+       Modes of Operation of a 64-bit Block Cipher.
+
+   [6] ANSI X9.17-1985, American National Standard, Financial
+       Institution Key Management (Wholesale), American Bankers
+       Association, April 4, 1985, Section 7.2.
+
+   [7] Voydock, V. L. and Kent, S. T., "Security Mechanisms in High-
+       Level Network Protocols", ACM Computing Surveys, Vol. 15, No. 2,
+       June 1983, pp. 135-171.
+
+   [8] CCITT Recommendation X.509, "The Directory - Authentication
+       Framework", November 1988, (Developed in collaboration, and
+       technically aligned, with ISO 9594-8).
+
+   [9] Kaliski, B., "The MD2 Message-Digest Algorithm", RFC 1319, RSA
+       Laboratories, April 1992.
+
+  [10] Rivest, R., "The MD5 Message-Digest Algorithm", RFC 1321, MIT
+       Laboratory for Computer Science and RSA Data Security, Inc.,
+
+
+
+Balenson                                                       [Page 12]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+       April 1992.
+
+  [11] PKCS #1: RSA Encryption Standard, Version 1.4, RSA Data Security,
+       Inc., June 3, 1991.
+
+  [12] Linn, J., "Privacy Enhancement for Internet Electronic Mail: Part
+       I: Message Encryption and Authentication Procedures", RFC 1421,
+       DEC, February 1993.
+
+  [13] Kent, S., "Privacy Enhancement for Internet Electronic Mail: Part
+       II: Certificate-Based Key Management", RFC 1422, BBN, February
+       1993.
+
+  [14] Kaliski, B., "Privacy Enhancement for Internet Electronic Mail:
+       Part IV: Key Certification and Related Services", RFC 1424, RSA
+       Laboratories, February 1993.
+
+Patent Statement
+
+   This version of Privacy Enhanced Mail (PEM) relies on the use of
+   patented public key encryption technology for authentication and
+   encryption.  The Internet Standards Process as defined in RFC 1310
+   requires a written statement from the Patent holder that a license
+   will be made available to applicants under reasonable terms and
+   conditions prior to approving a specification as a Proposed, Draft or
+   Internet Standard.
+
+   The Massachusetts Institute of Technology and the Board of Trustees
+   of the Leland Stanford Junior University have granted Public Key
+   Partners (PKP) exclusive sub-licensing rights to the following
+   patents issued in the United States, and all of their corresponding
+   foreign patents:
+
+      Cryptographic Apparatus and Method
+      ("Diffie-Hellman")............................... No. 4,200,770
+
+      Public Key Cryptographic Apparatus
+      and Method ("Hellman-Merkle").................... No. 4,218,582
+
+      Cryptographic Communications System and
+      Method ("RSA")................................... No. 4,405,829
+
+      Exponential Cryptographic Apparatus
+      and Method ("Hellman-Pohlig").................... No. 4,424,414
+
+   These patents are stated by PKP to cover all known methods of
+   practicing the art of Public Key encryption, including the variations
+   collectively known as El Gamal.
+
+
+
+Balenson                                                       [Page 13]
+
+RFC 1423         PEM: Algorithms, Modes and Identifiers    February 1993
+
+
+   Public Key Partners has provided written assurance to the Internet
+   Society that parties will be able to obtain, under reasonable,
+   nondiscriminatory terms, the right to use the technology covered by
+   these patents.  This assurance is documented in RFC 1170 titled
+   "Public Key Standards and Licenses".  A copy of the written assurance
+   dated April 20, 1990, may be obtained from the Internet Assigned
+   Number Authority (IANA).
+
+   The Internet Society, Internet Architecture Board, Internet
+   Engineering Steering Group and the Corporation for National Research
+   Initiatives take no position on the validity or scope of the patents
+   and patent applications, nor on the appropriateness of the terms of
+   the assurance.  The Internet Society and other groups mentioned above
+   have not made any determination as to any other intellectual property
+   rights which may apply to the practice of this standard. Any further
+   consideration of these matters is the user's own responsibility.
+
+Security Considerations
+
+   This entire document is about security.
+
+Author's Address
+
+   David Balenson
+   Trusted Information Systems
+   3060 Washington Road
+   Glenwood, Maryland 21738
+
+   Phone: 301-854-6889
+   EMail: balenson@tis.com
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+Balenson                                                       [Page 14]
+
\ No newline at end of file
diff -urN g10-0.2.5/doc/rfc1750 g10-0.2.6/doc/rfc1750
--- g10-0.2.5/doc/rfc1750	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/doc/rfc1750	Thu Feb 12 21:46:07 1998
@@ -0,0 +1,1683 @@
+
+
+
+
+
+
+Network Working Group					D. Eastlake, 3rd
+Request for Comments: 1750					     DEC
+Category: Informational 				      S. Crocker
+							       Cybercash
+							     J. Schiller
+								     MIT
+							   December 1994
+
+
+		Randomness Recommendations for Security
+
+Status of this Memo
+
+   This memo provides information for the Internet community.  This memo
+   does not specify an Internet standard of any kind.  Distribution of
+   this memo is unlimited.
+
+Abstract
+
+   Security systems today are built on increasingly strong cryptographic
+   algorithms that foil pattern analysis attempts. However, the security
+   of these systems is dependent on generating secret quantities for
+   passwords, cryptographic keys, and similar quantities.  The use of
+   pseudo-random processes to generate secret quantities can result in
+   pseudo-security.  The sophisticated attacker of these security
+   systems may find it easier to reproduce the environment that produced
+   the secret quantities, searching the resulting small set of
+   possibilities, than to locate the quantities in the whole of the
+   number space.
+
+   Choosing random quantities to foil a resourceful and motivated
+   adversary is surprisingly difficult.  This paper points out many
+   pitfalls in using traditional pseudo-random number generation
+   techniques for choosing such quantities.  It recommends the use of
+   truly random hardware techniques and shows that the existing hardware
+   on many systems can be used for this purpose.  It provides
+   suggestions to ameliorate the problem when a hardware solution is not
+   available.  And it gives examples of how large such quantities need
+   to be for some particular applications.
+
+
+
+
+
+
+
+
+
+
+
+
+Eastlake, Crocker & Schiller					[Page 1]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+Acknowledgements
+
+   Comments on this document that have been incorporated were received
+   from (in alphabetic order) the following:
+
+	David M. Balenson (TIS)
+	Don Coppersmith (IBM)
+	Don T. Davis (consultant)
+	Carl Ellison (Stratus)
+	Marc Horowitz (MIT)
+	Christian Huitema (INRIA)
+	Charlie Kaufman (IRIS)
+	Steve Kent (BBN)
+	Hal Murray (DEC)
+	Neil Haller (Bellcore)
+	Richard Pitkin (DEC)
+	Tim Redmond (TIS)
+	Doug Tygar (CMU)
+
+Table of Contents
+
+   1. Introduction........................................... 3
+   2. Requirements........................................... 4
+   3. Traditional Pseudo-Random Sequences.................... 5
+   4. Unpredictability....................................... 7
+   4.1 Problems with Clocks and Serial Numbers............... 7
+   4.2 Timing and Content of External Events................  8
+   4.3 The Fallacy of Complex Manipulation..................  8
+   4.4 The Fallacy of Selection from a Large Database.......  9
+   5. Hardware for Randomness............................... 10
+   5.1 Volume Required...................................... 10
+   5.2 Sensitivity to Skew.................................. 10
+   5.2.1 Using Stream Parity to De-Skew..................... 11
+   5.2.2 Using Transition Mappings to De-Skew............... 12
+   5.2.3 Using FFT to De-Skew............................... 13
+   5.2.4 Using Compression to De-Skew....................... 13
+   5.3 Existing Hardware Can Be Used For Randomness......... 14
+   5.3.1 Using Existing Sound/Video Input................... 14
+   5.3.2 Using Existing Disk Drives......................... 14
+   6. Recommended Non-Hardware Strategy..................... 14
+   6.1 Mixing Functions..................................... 15
+   6.1.1 A Trivial Mixing Function.......................... 15
+   6.1.2 Stronger Mixing Functions.......................... 16
+   6.1.3 Diff-Hellman as a Mixing Function.................. 17
+   6.1.4 Using a Mixing Function to Stretch Random Bits..... 17
+   6.1.5 Other Factors in Choosing a Mixing Function........ 18
+   6.2 Non-Hardware Sources of Randomness................... 19
+   6.3 Cryptographically Strong Sequences................... 19
+
+
+
+Eastlake, Crocker & Schiller					[Page 2]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   6.3.1 Traditional Strong Sequences....................... 20
+   6.3.2 The Blum Blum Shub Sequence Generator.............. 21
+   7. Key Generation Standards.............................. 22
+   7.1 US DoD Recommendations for Password Generation....... 23
+   7.2 X9.17 Key Generation................................. 23
+   8. Examples of Randomness Required....................... 24
+   8.1	Password Generation................................. 24
+   8.2 A Very High Security Cryptographic Key............... 25
+   8.2.1 Effort per Key Trial............................... 25
+   8.2.2 Meet in the Middle Attacks......................... 26
+   8.2.3 Other Considerations............................... 26
+   9. Conclusion............................................ 27
+   10. Security Considerations.............................. 27
+   References............................................... 28
+   Authors' Addresses....................................... 30
+
+1. Introduction
+
+   Software cryptography is coming into wider use.  Systems like
+   Kerberos, PEM, PGP, etc. are maturing and becoming a part of the
+   network landscape [PEM].  These systems provide substantial
+   protection against snooping and spoofing.  However, there is a
+   potential flaw.  At the heart of all cryptographic systems is the
+   generation of secret, unguessable (i.e., random) numbers.
+
+   For the present, the lack of generally available facilities for
+   generating such unpredictable numbers is an open wound in the design
+   of cryptographic software.  For the software developer who wants to
+   build a key or password generation procedure that runs on a wide
+   range of hardware, the only safe strategy so far has been to force
+   the local installation to supply a suitable routine to generate
+   random numbers.  To say the least, this is an awkward, error-prone
+   and unpalatable solution.
+
+   It is important to keep in mind that the requirement is for data that
+   an adversary has a very low probability of guessing or determining.
+   This will fail if pseudo-random data is used which only meets
+   traditional statistical tests for randomness or which is based on
+   limited range sources, such as clocks.  Frequently such random
+   quantities are determinable by an adversary searching through an
+   embarrassingly small space of possibilities.
+
+   This informational document suggests techniques for producing random
+   quantities that will be resistant to such attack.  It recommends that
+   future systems include hardware random number generation or provide
+   access to existing hardware that can be used for this purpose.  It
+   suggests methods for use if such hardware is not available.	And it
+   gives some estimates of the number of random bits required for sample
+
+
+
+Eastlake, Crocker & Schiller					[Page 3]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   applications.
+
+2. Requirements
+
+   Probably the most commonly encountered randomness requirement today
+   is the user password. This is usually a simple character string.
+   Obviously, if a password can be guessed, it does not provide
+   security.  (For re-usable passwords, it is desirable that users be
+   able to remember the password.  This may make it advisable to use
+   pronounceable character strings or phrases composed on ordinary
+   words.  But this only affects the format of the password information,
+   not the requirement that the password be very hard to guess.)
+
+   Many other requirements come from the cryptographic arena.
+   Cryptographic techniques can be used to provide a variety of services
+   including confidentiality and authentication.  Such services are
+   based on quantities, traditionally called "keys", that are unknown to
+   and unguessable by an adversary.
+
+   In some cases, such as the use of symmetric encryption with the one
+   time pads [CRYPTO*] or the US Data Encryption Standard [DES], the
+   parties who wish to communicate confidentially and/or with
+   authentication must all know the same secret key.  In other cases,
+   using what are called asymmetric or "public key" cryptographic
+   techniques, keys come in pairs.  One key of the pair is private and
+   must be kept secret by one party, the other is public and can be
+   published to the world.  It is computationally infeasible to
+   determine the private key from the public key [ASYMMETRIC, CRYPTO*].
+
+   The frequency and volume of the requirement for random quantities
+   differs greatly for different cryptographic systems.  Using pure RSA
+   [CRYPTO*], random quantities are required when the key pair is
+   generated, but thereafter any number of messages can be signed
+   without any further need for randomness.  The public key Digital
+   Signature Algorithm that has been proposed by the US National
+   Institute of Standards and Technology (NIST) requires good random
+   numbers for each signature.	And encrypting with a one time pad, in
+   principle the strongest possible encryption technique, requires a
+   volume of randomness equal to all the messages to be processed.
+
+   In most of these cases, an adversary can try to determine the
+   "secret" key by trial and error.  (This is possible as long as the
+   key is enough smaller than the message that the correct key can be
+   uniquely identified.)  The probability of an adversary succeeding at
+   this must be made acceptably low, depending on the particular
+   application.  The size of the space the adversary must search is
+   related to the amount of key "information" present in the information
+   theoretic sense [SHANNON].  This depends on the number of different
+
+
+
+Eastlake, Crocker & Schiller					[Page 4]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   secret values possible and the probability of each value as follows:
+
+		      -----
+		       \
+	Bits-of-info =	\  - p	 * log	( p  )
+			/     i       2    i
+		       /
+		      -----
+
+   where i varies from 1 to the number of possible secret values and p
+   sub i is the probability of the value numbered i.  (Since p sub i is
+   less than one, the log will be negative so each term in the sum will
+   be non-negative.)
+
+   If there are 2^n different values of equal probability, then n bits
+   of information are present and an adversary would, on the average,
+   have to try half of the values, or 2^(n-1) , before guessing the
+   secret quantity.  If the probability of different values is unequal,
+   then there is less information present and fewer guesses will, on
+   average, be required by an adversary.  In particular, any values that
+   the adversary can know are impossible, or are of low probability, can
+   be initially ignored by an adversary, who will search through the
+   more probable values first.
+
+   For example, consider a cryptographic system that uses 56 bit keys.
+   If these 56 bit keys are derived by using a fixed pseudo-random
+   number generator that is seeded with an 8 bit seed, then an adversary
+   needs to search through only 256 keys (by running the pseudo-random
+   number generator with every possible seed), not the 2^56 keys that
+   may at first appear to be the case. Only 8 bits of "information" are
+   in these 56 bit keys.
+
+3. Traditional Pseudo-Random Sequences
+
+   Most traditional sources of random numbers use deterministic sources
+   of "pseudo-random" numbers.  These typically start with a "seed"
+   quantity and use numeric or logical operations to produce a sequence
+   of values.
+
+   [KNUTH] has a classic exposition on pseudo-random numbers.
+   Applications he mentions are simulation of natural phenomena,
+   sampling, numerical analysis, testing computer programs, decision
+   making, and games.  None of these have the same characteristics as
+   the sort of security uses we are talking about.  Only in the last two
+   could there be an adversary trying to find the random quantity.
+   However, in these cases, the adversary normally has only a single
+   chance to use a guessed value.  In guessing passwords or attempting
+   to break an encryption scheme, the adversary normally has many,
+
+
+
+Eastlake, Crocker & Schiller					[Page 5]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   perhaps unlimited, chances at guessing the correct value and should
+   be assumed to be aided by a computer.
+
+   For testing the "randomness" of numbers, Knuth suggests a variety of
+   measures including statistical and spectral.  These tests check
+   things like autocorrelation between different parts of a "random"
+   sequence or distribution of its values.  They could be met by a
+   constant stored random sequence, such as the "random" sequence
+   printed in the CRC Standard Mathematical Tables [CRC].
+
+   A typical pseudo-random number generation technique, known as a
+   linear congruence pseudo-random number generator, is modular
+   arithmetic where the N+1th value is calculated from the Nth value by
+
+	V    = ( V  * a + b )(Mod c)
+	 N+1	  N
+
+   The above technique has a strong relationship to linear shift
+   register pseudo-random number generators, which are well understood
+   cryptographically [SHIFT*].	In such generators bits are introduced
+   at one end of a shift register as the Exclusive Or (binary sum
+   without carry) of bits from selected fixed taps into the register.
+
+   For example:
+
+      +----+	 +----+     +----+			+----+
+      | B  | <-- | B  | <-- | B  | <--	. . . . . . <-- | B  | <-+
+      |  0 |	 |  1 |     |  2 |			|  n |	 |
+      +----+	 +----+     +----+			+----+	 |
+	|		      | 	   |			 |
+	|		      | 	   V		      +-----+
+	|		      V 	   +----------------> |     |
+	V		      +-----------------------------> | XOR |
+	+---------------------------------------------------> |     |
+							      +-----+
+
+
+       V    = ( ( V  * 2 ) + B .xor. B ... )(Mod 2^n)
+	N+1	    N	      0       2
+
+   The goodness of traditional pseudo-random number generator algorithms
+   is measured by statistical tests on such sequences.	Carefully chosen
+   values of the initial V and a, b, and c or the placement of shift
+   register tap in the above simple processes can produce excellent
+   statistics.
+
+
+
+
+
+
+Eastlake, Crocker & Schiller					[Page 6]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   These sequences may be adequate in simulations (Monte Carlo
+   experiments) as long as the sequence is orthogonal to the structure
+   of the space being explored.  Even there, subtle patterns may cause
+   problems.  However, such sequences are clearly bad for use in
+   security applications.  They are fully predictable if the initial
+   state is known.  Depending on the form of the pseudo-random number
+   generator, the sequence may be determinable from observation of a
+   short portion of the sequence [CRYPTO*, STERN].  For example, with
+   the generators above, one can determine V(n+1) given knowledge of
+   V(n).  In fact, it has been shown that with these techniques, even if
+   only one bit of the pseudo-random values is released, the seed can be
+   determined from short sequences.
+
+   Not only have linear congruent generators been broken, but techniques
+   are now known for breaking all polynomial congruent generators
+   [KRAWCZYK].
+
+4. Unpredictability
+
+   Randomness in the traditional sense described in section 3 is NOT the
+   same as the unpredictability required for security use.
+
+   For example, use of a widely available constant sequence, such as
+   that from the CRC tables, is very weak against an adversary. Once
+   they learn of or guess it, they can easily break all security, future
+   and past, based on the sequence [CRC].  Yet the statistical
+   properties of these tables are good.
+
+   The following sections describe the limitations of some randomness
+   generation techniques and sources.
+
+4.1 Problems with Clocks and Serial Numbers
+
+   Computer clocks, or similar operating system or hardware values,
+   provide significantly fewer real bits of unpredictability than might
+   appear from their specifications.
+
+   Tests have been done on clocks on numerous systems and it was found
+   that their behavior can vary widely and in unexpected ways.	One
+   version of an operating system running on one set of hardware may
+   actually provide, say, microsecond resolution in a clock while a
+   different configuration of the "same" system may always provide the
+   same lower bits and only count in the upper bits at much lower
+   resolution.	This means that successive reads on the clock may
+   produce identical values even if enough time has passed that the
+   value "should" change based on the nominal clock resolution. There
+   are also cases where frequently reading a clock can produce
+   artificial sequential values because of extra code that checks for
+
+
+
+Eastlake, Crocker & Schiller					[Page 7]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   the clock being unchanged between two reads and increases it by one!
+   Designing portable application code to generate unpredictable numbers
+   based on such system clocks is particularly challenging because the
+   system designer does not always know the properties of the system
+   clocks that the code will execute on.
+
+   Use of a hardware serial number such as an Ethernet address may also
+   provide fewer bits of uniqueness than one would guess.  Such
+   quantities are usually heavily structured and subfields may have only
+   a limited range of possible values or values easily guessable based
+   on approximate date of manufacture or other data.  For example, it is
+   likely that most of the Ethernet cards installed on Digital Equipment
+   Corporation (DEC) hardware within DEC were manufactured by DEC
+   itself, which significantly limits the range of built in addresses.
+
+   Problems such as those described above related to clocks and serial
+   numbers make code to produce unpredictable quantities difficult if
+   the code is to be ported across a variety of computer platforms and
+   systems.
+
+4.2 Timing and Content of External Events
+
+   It is possible to measure the timing and content of mouse movement,
+   key strokes, and similar user events.  This is a reasonable source of
+   unguessable data with some qualifications.  On some machines, inputs
+   such as key strokes are buffered.  Even though the user's inter-
+   keystroke timing may have sufficient variation and unpredictability,
+   there might not be an easy way to access that variation.  Another
+   problem is that no standard method exists to sample timing details.
+   This makes it hard to build standard software intended for
+   distribution to a large range of machines based on this technique.
+
+   The amount of mouse movement or the keys actually hit are usually
+   easier to access than timings but may yield less unpredictability as
+   the user may provide highly repetitive input.
+
+   Other external events, such as network packet arrival times, can also
+   be used with care.  In particular, the possibility of manipulation of
+   such times by an adversary must be considered.
+
+4.3 The Fallacy of Complex Manipulation
+
+   One strategy which may give a misleading appearance of
+   unpredictability is to take a very complex algorithm (or an excellent
+   traditional pseudo-random number generator with good statistical
+   properties) and calculate a cryptographic key by starting with the
+   current value of a computer system clock as the seed.  An adversary
+   who knew roughly when the generator was started would have a
+
+
+
+Eastlake, Crocker & Schiller					[Page 8]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   relatively small number of seed values to test as they would know
+   likely values of the system clock.  Large numbers of pseudo-random
+   bits could be generated but the search space an adversary would need
+   to check could be quite small.
+
+   Thus very strong and/or complex manipulation of data will not help if
+   the adversary can learn what the manipulation is and there is not
+   enough unpredictability in the starting seed value.	Even if they can
+   not learn what the manipulation is, they may be able to use the
+   limited number of results stemming from a limited number of seed
+   values to defeat security.
+
+   Another serious strategy error is to assume that a very complex
+   pseudo-random number generation algorithm will produce strong random
+   numbers when there has been no theory behind or analysis of the
+   algorithm.  There is a excellent example of this fallacy right near
+   the beginning of chapter 3 in [KNUTH] where the author describes a
+   complex algorithm.  It was intended that the machine language program
+   corresponding to the algorithm would be so complicated that a person
+   trying to read the code without comments wouldn't know what the
+   program was doing.  Unfortunately, actual use of this algorithm
+   showed that it almost immediately converged to a single repeated
+   value in one case and a small cycle of values in another case.
+
+   Not only does complex manipulation not help you if you have a limited
+   range of seeds but blindly chosen complex manipulation can destroy
+   the randomness in a good seed!
+
+4.4 The Fallacy of Selection from a Large Database
+
+   Another strategy that can give a misleading appearance of
+   unpredictability is selection of a quantity randomly from a database
+   and assume that its strength is related to the total number of bits
+   in the database.  For example, typical USENET servers as of this date
+   process over 35 megabytes of information per day.  Assume a random
+   quantity was selected by fetching 32 bytes of data from a random
+   starting point in this data.  This does not yield 32*8 = 256 bits
+   worth of unguessability.  Even after allowing that much of the data
+   is human language and probably has more like 2 or 3 bits of
+   information per byte, it doesn't yield 32*2.5 = 80 bits of
+   unguessability.  For an adversary with access to the same 35
+   megabytes the unguessability rests only on the starting point of the
+   selection.  That is, at best, about 25 bits of unguessability in this
+   case.
+
+   The same argument applies to selecting sequences from the data on a
+   CD ROM or Audio CD recording or any other large public database.  If
+   the adversary has access to the same database, this "selection from a
+
+
+
+Eastlake, Crocker & Schiller					[Page 9]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   large volume of data" step buys very little.  However, if a selection
+   can be made from data to which the adversary has no access, such as
+   system buffers on an active multi-user system, it may be of some
+   help.
+
+5. Hardware for Randomness
+
+   Is there any hope for strong portable randomness in the future?
+   There might be.  All that's needed is a physical source of
+   unpredictable numbers.
+
+   A thermal noise or radioactive decay source and a fast, free-running
+   oscillator would do the trick directly [GIFFORD].  This is a trivial
+   amount of hardware, and could easily be included as a standard part
+   of a computer system's architecture.  Furthermore, any system with a
+   spinning disk or the like has an adequate source of randomness
+   [DAVIS].  All that's needed is the common perception among computer
+   vendors that this small additional hardware and the software to
+   access it is necessary and useful.
+
+5.1 Volume Required
+
+   How much unpredictability is needed?  Is it possible to quantify the
+   requirement in, say, number of random bits per second?
+
+   The answer is not very much is needed.  For DES, the key is 56 bits
+   and, as we show in an example in Section 8, even the highest security
+   system is unlikely to require a keying material of over 200 bits.  If
+   a series of keys are needed, it can be generated from a strong random
+   seed using a cryptographically strong sequence as explained in
+   Section 6.3.  A few hundred random bits generated once a day would be
+   enough using such techniques.  Even if the random bits are generated
+   as slowly as one per second and it is not possible to overlap the
+   generation process, it should be tolerable in high security
+   applications to wait 200 seconds occasionally.
+
+   These numbers are trivial to achieve.  It could be done by a person
+   repeatedly tossing a coin.  Almost any hardware process is likely to
+   be much faster.
+
+5.2 Sensitivity to Skew
+
+   Is there any specific requirement on the shape of the distribution of
+   the random numbers?	The good news is the distribution need not be
+   uniform.  All that is needed is a conservative estimate of how non-
+   uniform it is to bound performance.	Two simple techniques to de-skew
+   the bit stream are given below and stronger techniques are mentioned
+   in Section 6.1.2 below.
+
+
+
+Eastlake, Crocker & Schiller				       [Page 10]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+5.2.1 Using Stream Parity to De-Skew
+
+   Consider taking a sufficiently long string of bits and map the string
+   to "zero" or "one".  The mapping will not yield a perfectly uniform
+   distribution, but it can be as close as desired.  One mapping that
+   serves the purpose is to take the parity of the string.  This has the
+   advantages that it is robust across all degrees of skew up to the
+   estimated maximum skew and is absolutely trivial to implement in
+   hardware.
+
+   The following analysis gives the number of bits that must be sampled:
+
+   Suppose the ratio of ones to zeros is 0.5 + e : 0.5 - e, where e is
+   between 0 and 0.5 and is a measure of the "eccentricity" of the
+   distribution.  Consider the distribution of the parity function of N
+   bit samples.  The probabilities that the parity will be one or zero
+   will be the sum of the odd or even terms in the binomial expansion of
+   (p + q)^N, where p = 0.5 + e, the probability of a one, and q = 0.5 -
+   e, the probability of a zero.
+
+   These sums can be computed easily as
+
+			 N	      N
+	1/2 * ( ( p + q )  + ( p - q )	)
+   and
+			 N	      N
+	1/2 * ( ( p + q )  - ( p - q )	).
+
+   (Which one corresponds to the probability the parity will be 1
+   depends on whether N is odd or even.)
+
+   Since p + q = 1 and p - q = 2e, these expressions reduce to
+
+		       N
+	1/2 * [1 + (2e) ]
+   and
+		       N
+	1/2 * [1 - (2e) ].
+
+   Neither of these will ever be exactly 0.5 unless e is zero, but we
+   can bring them arbitrarily close to 0.5.  If we want the
+   probabilities to be within some delta d of 0.5, i.e. then
+
+			    N
+	( 0.5 + ( 0.5 * (2e)  ) )  <  0.5 + d.
+
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 11]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   Solving for N yields N > log(2d)/log(2e).  (Note that 2e is less than
+   1, so its log is negative.  Division by a negative number reverses
+   the sense of an inequality.)
+
+   The following table gives the length of the string which must be
+   sampled for various degrees of skew in order to come within 0.001 of
+   a 50/50 distribution.
+
+		       +---------+--------+-------+
+		       | Prob(1) |    e   |    N  |
+		       +---------+--------+-------+
+		       |   0.5	 |  0.00  |    1  |
+		       |   0.6	 |  0.10  |    4  |
+		       |   0.7	 |  0.20  |    7  |
+		       |   0.8	 |  0.30  |   13  |
+		       |   0.9	 |  0.40  |   28  |
+		       |   0.95  |  0.45  |   59  |
+		       |   0.99  |  0.49  |  308  |
+		       +---------+--------+-------+
+
+   The last entry shows that even if the distribution is skewed 99% in
+   favor of ones, the parity of a string of 308 samples will be within
+   0.001 of a 50/50 distribution.
+
+5.2.2 Using Transition Mappings to De-Skew
+
+   Another technique, originally due to von Neumann [VON NEUMANN], is to
+   examine a bit stream as a sequence of non-overlapping pairs. You
+   could then discard any 00 or 11 pairs found, interpret 01 as a 0 and
+   10 as a 1.  Assume the probability of a 1 is 0.5+e and the
+   probability of a 0 is 0.5-e where e is the eccentricity of the source
+   and described in the previous section.  Then the probability of each
+   pair is as follows:
+
+	    +------+-----------------------------------------+
+	    | pair |		probability		     |
+	    +------+-----------------------------------------+
+	    |  00  | (0.5 - e)^2	  =  0.25 - e + e^2  |
+	    |  01  | (0.5 - e)*(0.5 + e)  =  0.25     - e^2  |
+	    |  10  | (0.5 + e)*(0.5 - e)  =  0.25     - e^2  |
+	    |  11  | (0.5 + e)^2	  =  0.25 + e + e^2  |
+	    +------+-----------------------------------------+
+
+   This technique will completely eliminate any bias but at the expense
+   of taking an indeterminate number of input bits for any particular
+   desired number of output bits.  The probability of any particular
+   pair being discarded is 0.5 + 2e^2 so the expected number of input
+   bits to produce X output bits is X/(0.25 - e^2).
+
+
+
+Eastlake, Crocker & Schiller				       [Page 12]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   This technique assumes that the bits are from a stream where each bit
+   has the same probability of being a 0 or 1 as any other bit in the
+   stream and that bits are not correlated, i.e., that the bits are
+   identical independent distributions.  If alternate bits were from two
+   correlated sources, for example, the above analysis breaks down.
+
+   The above technique also provides another illustration of how a
+   simple statistical analysis can mislead if one is not always on the
+   lookout for patterns that could be exploited by an adversary.  If the
+   algorithm were mis-read slightly so that overlapping successive bits
+   pairs were used instead of non-overlapping pairs, the statistical
+   analysis given is the same; however, instead of provided an unbiased
+   uncorrelated series of random 1's and 0's, it instead produces a
+   totally predictable sequence of exactly alternating 1's and 0's.
+
+5.2.3 Using FFT to De-Skew
+
+   When real world data consists of strongly biased or correlated bits,
+   it may still contain useful amounts of randomness.  This randomness
+   can be extracted through use of the discrete Fourier transform or its
+   optimized variant, the FFT.
+
+   Using the Fourier transform of the data, strong correlations can be
+   discarded.  If adequate data is processed and remaining correlations
+   decay, spectral lines approaching statistical independence and
+   normally distributed randomness can be produced [BRILLINGER].
+
+5.2.4 Using Compression to De-Skew
+
+   Reversible compression techniques also provide a crude method of de-
+   skewing a skewed bit stream.  This follows directly from the
+   definition of reversible compression and the formula in Section 2
+   above for the amount of information in a sequence.  Since the
+   compression is reversible, the same amount of information must be
+   present in the shorter output than was present in the longer input.
+   By the Shannon information equation, this is only possible if, on
+   average, the probabilities of the different shorter sequences are
+   more uniformly distributed than were the probabilities of the longer
+   sequences.  Thus the shorter sequences are de-skewed relative to the
+   input.
+
+   However, many compression techniques add a somewhat predicatable
+   preface to their output stream and may insert such a sequence again
+   periodically in their output or otherwise introduce subtle patterns
+   of their own.  They should be considered only a rough technique
+   compared with those described above or in Section 6.1.2.  At a
+   minimum, the beginning of the compressed sequence should be skipped
+   and only later bits used for applications requiring random bits.
+
+
+
+Eastlake, Crocker & Schiller				       [Page 13]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+5.3 Existing Hardware Can Be Used For Randomness
+
+   As described below, many computers come with hardware that can, with
+   care, be used to generate truly random quantities.
+
+5.3.1 Using Existing Sound/Video Input
+
+   Increasingly computers are being built with inputs that digitize some
+   real world analog source, such as sound from a microphone or video
+   input from a camera.  Under appropriate circumstances, such input can
+   provide reasonably high quality random bits.  The "input" from a
+   sound digitizer with no source plugged in or a camera with the lens
+   cap on, if the system has enough gain to detect anything, is
+   essentially thermal noise.
+
+   For example, on a SPARCstation, one can read from the /dev/audio
+   device with nothing plugged into the microphone jack.  Such data is
+   essentially random noise although it should not be trusted without
+   some checking in case of hardware failure.  It will, in any case,
+   need to be de-skewed as described elsewhere.
+
+   Combining this with compression to de-skew one can, in UNIXese,
+   generate a huge amount of medium quality random data by doing
+
+	cat /dev/audio | compress - >random-bits-file
+
+5.3.2 Using Existing Disk Drives
+
+   Disk drives have small random fluctuations in their rotational speed
+   due to chaotic air turbulence [DAVIS].  By adding low level disk seek
+   time instrumentation to a system, a series of measurements can be
+   obtained that include this randomness. Such data is usually highly
+   correlated so that significant processing is needed, including FFT
+   (see section 5.2.3).  Nevertheless experimentation has shown that,
+   with such processing, disk drives easily produce 100 bits a minute or
+   more of excellent random data.
+
+   Partly offsetting this need for processing is the fact that disk
+   drive failure will normally be rapidly noticed.  Thus, problems with
+   this method of random number generation due to hardware failure are
+   very unlikely.
+
+6. Recommended Non-Hardware Strategy
+
+   What is the best overall strategy for meeting the requirement for
+   unguessable random numbers in the absence of a reliable hardware
+   source?  It is to obtain random input from a large number of
+   uncorrelated sources and to mix them with a strong mixing function.
+
+
+
+Eastlake, Crocker & Schiller				       [Page 14]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   Such a function will preserve the randomness present in any of the
+   sources even if other quantities being combined are fixed or easily
+   guessable.  This may be advisable even with a good hardware source as
+   hardware can also fail, though this should be weighed against any
+   increase in the chance of overall failure due to added software
+   complexity.
+
+6.1 Mixing Functions
+
+   A strong mixing function is one which combines two or more inputs and
+   produces an output where each output bit is a different complex non-
+   linear function of all the input bits.  On average, changing any
+   input bit will change about half the output bits.  But because the
+   relationship is complex and non-linear, no particular output bit is
+   guaranteed to change when any particular input bit is changed.
+
+   Consider the problem of converting a stream of bits that is skewed
+   towards 0 or 1 to a shorter stream which is more random, as discussed
+   in Section 5.2 above.  This is simply another case where a strong
+   mixing function is desired, mixing the input bits to produce a
+   smaller number of output bits.  The technique given in Section 5.2.1
+   of using the parity of a number of bits is simply the result of
+   successively Exclusive Or'ing them which is examined as a trivial
+   mixing function immediately below.  Use of stronger mixing functions
+   to extract more of the randomness in a stream of skewed bits is
+   examined in Section 6.1.2.
+
+6.1.1 A Trivial Mixing Function
+
+   A trivial example for single bit inputs is the Exclusive Or function,
+   which is equivalent to addition without carry, as show in the table
+   below.  This is a degenerate case in which the one output bit always
+   changes for a change in either input bit.  But, despite its
+   simplicity, it will still provide a useful illustration.
+
+		   +-----------+-----------+----------+
+		   |  input 1  |  input 2  |  output  |
+		   +-----------+-----------+----------+
+		   |	 0     |     0	   |	 0    |
+		   |	 0     |     1	   |	 1    |
+		   |	 1     |     0	   |	 1    |
+		   |	 1     |     1	   |	 0    |
+		   +-----------+-----------+----------+
+
+   If inputs 1 and 2 are uncorrelated and combined in this fashion then
+   the output will be an even better (less skewed) random bit than the
+   inputs.  If we assume an "eccentricity" e as defined in Section 5.2
+   above, then the output eccentricity relates to the input eccentricity
+
+
+
+Eastlake, Crocker & Schiller				       [Page 15]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   as follows:
+
+	e	= 2 * e        * e
+	 output        input 1	  input 2
+
+   Since e is never greater than 1/2, the eccentricity is always
+   improved except in the case where at least one input is a totally
+   skewed constant.  This is illustrated in the following table where
+   the top and left side values are the two input eccentricities and the
+   entries are the output eccentricity:
+
+     +--------+--------+--------+--------+--------+--------+--------+
+     |	  e   |  0.00  |  0.10	|  0.20  |  0.30  |  0.40  |  0.50  |
+     +--------+--------+--------+--------+--------+--------+--------+
+     |	0.00  |  0.00  |  0.00	|  0.00  |  0.00  |  0.00  |  0.00  |
+     |	0.10  |  0.00  |  0.02	|  0.04  |  0.06  |  0.08  |  0.10  |
+     |	0.20  |  0.00  |  0.04	|  0.08  |  0.12  |  0.16  |  0.20  |
+     |	0.30  |  0.00  |  0.06	|  0.12  |  0.18  |  0.24  |  0.30  |
+     |	0.40  |  0.00  |  0.08	|  0.16  |  0.24  |  0.32  |  0.40  |
+     |	0.50  |  0.00  |  0.10	|  0.20  |  0.30  |  0.40  |  0.50  |
+     +--------+--------+--------+--------+--------+--------+--------+
+
+   However, keep in mind that the above calculations assume that the
+   inputs are not correlated.  If the inputs were, say, the parity of
+   the number of minutes from midnight on two clocks accurate to a few
+   seconds, then each might appear random if sampled at random intervals
+   much longer than a minute.  Yet if they were both sampled and
+   combined with xor, the result would be zero most of the time.
+
+6.1.2 Stronger Mixing Functions
+
+   The US Government Data Encryption Standard [DES] is an example of a
+   strong mixing function for multiple bit quantities.	It takes up to
+   120 bits of input (64 bits of "data" and 56 bits of "key") and
+   produces 64 bits of output each of which is dependent on a complex
+   non-linear function of all input bits.  Other strong encryption
+   functions with this characteristic can also be used by considering
+   them to mix all of their key and data input bits.
+
+   Another good family of mixing functions are the "message digest" or
+   hashing functions such as The US Government Secure Hash Standard
+   [SHS] and the MD2, MD4, MD5 [MD2, MD4, MD5] series.	These functions
+   all take an arbitrary amount of input and produce an output mixing
+   all the input bits. The MD* series produce 128 bits of output and SHS
+   produces 160 bits.
+
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 16]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   Although the message digest functions are designed for variable
+   amounts of input, DES and other encryption functions can also be used
+   to combine any number of inputs.  If 64 bits of output is adequate,
+   the inputs can be packed into a 64 bit data quantity and successive
+   56 bit keys, padding with zeros if needed, which are then used to
+   successively encrypt using DES in Electronic Codebook Mode [DES
+   MODES].  If more than 64 bits of output are needed, use more complex
+   mixing.  For example, if inputs are packed into three quantities, A,
+   B, and C, use DES to encrypt A with B as a key and then with C as a
+   key to produce the 1st part of the output, then encrypt B with C and
+   then A for more output and, if necessary, encrypt C with A and then B
+   for yet more output.  Still more output can be produced by reversing
+   the order of the keys given above to stretch things. The same can be
+   done with the hash functions by hashing various subsets of the input
+   data to produce multiple outputs.  But keep in mind that it is
+   impossible to get more bits of "randomness" out than are put in.
+
+   An example of using a strong mixing function would be to reconsider
+   the case of a string of 308 bits each of which is biased 99% towards
+   zero.  The parity technique given in Section 5.2.1 above reduced this
+   to one bit with only a 1/1000 deviance from being equally likely a
+   zero or one.  But, applying the equation for information given in
+   Section 2, this 308 bit sequence has 5 bits of information in it.
+   Thus hashing it with SHS or MD5 and taking the bottom 5 bits of the
+   result would yield 5 unbiased random bits as opposed to the single
+   bit given by calculating the parity of the string.
+
+6.1.3 Diffie-Hellman as a Mixing Function
+
+   Diffie-Hellman exponential key exchange is a technique that yields a
+   shared secret between two parties that can be made computationally
+   infeasible for a third party to determine even if they can observe
+   all the messages between the two communicating parties.  This shared
+   secret is a mixture of initial quantities generated by each of them
+   [D-H].  If these initial quantities are random, then the shared
+   secret contains the combined randomness of them both, assuming they
+   are uncorrelated.
+
+6.1.4 Using a Mixing Function to Stretch Random Bits
+
+   While it is not necessary for a mixing function to produce the same
+   or fewer bits than its inputs, mixing bits cannot "stretch" the
+   amount of random unpredictability present in the inputs.  Thus four
+   inputs of 32 bits each where there is 12 bits worth of
+   unpredicatability (such as 4,096 equally probable values) in each
+   input cannot produce more than 48 bits worth of unpredictable output.
+   The output can be expanded to hundreds or thousands of bits by, for
+   example, mixing with successive integers, but the clever adversary's
+
+
+
+Eastlake, Crocker & Schiller				       [Page 17]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   search space is still 2^48 possibilities.  Furthermore, mixing to
+   fewer bits than are input will tend to strengthen the randomness of
+   the output the way using Exclusive Or to produce one bit from two did
+   above.
+
+   The last table in Section 6.1.1 shows that mixing a random bit with a
+   constant bit with Exclusive Or will produce a random bit.  While this
+   is true, it does not provide a way to "stretch" one random bit into
+   more than one.  If, for example, a random bit is mixed with a 0 and
+   then with a 1, this produces a two bit sequence but it will always be
+   either 01 or 10.  Since there are only two possible values, there is
+   still only the one bit of original randomness.
+
+6.1.5 Other Factors in Choosing a Mixing Function
+
+   For local use, DES has the advantages that it has been widely tested
+   for flaws, is widely documented, and is widely implemented with
+   hardware and software implementations available all over the world
+   including source code available by anonymous FTP.  The SHS and MD*
+   family are younger algorithms which have been less tested but there
+   is no particular reason to believe they are flawed.	Both MD5 and SHS
+   were derived from the earlier MD4 algorithm.  They all have source
+   code available by anonymous FTP [SHS, MD2, MD4, MD5].
+
+   DES and SHS have been vouched for the the US National Security Agency
+   (NSA) on the basis of criteria that primarily remain secret.  While
+   this is the cause of much speculation and doubt, investigation of DES
+   over the years has indicated that NSA involvement in modifications to
+   its design, which originated with IBM, was primarily to strengthen
+   it.	No concealed or special weakness has been found in DES.  It is
+   almost certain that the NSA modification to MD4 to produce the SHS
+   similarly strengthened the algorithm, possibly against threats not
+   yet known in the public cryptographic community.
+
+   DES, SHS, MD4, and MD5 are royalty free for all purposes.  MD2 has
+   been freely licensed only for non-profit use in connection with
+   Privacy Enhanced Mail [PEM].  Between the MD* algorithms, some people
+   believe that, as with "Goldilocks and the Three Bears", MD2 is strong
+   but too slow, MD4 is fast but too weak, and MD5 is just right.
+
+   Another advantage of the MD* or similar hashing algorithms over
+   encryption algorithms is that they are not subject to the same
+   regulations imposed by the US Government prohibiting the unlicensed
+   export or import of encryption/decryption software and hardware.  The
+   same should be true of DES rigged to produce an irreversible hash
+   code but most DES packages are oriented to reversible encryption.
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 18]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+6.2 Non-Hardware Sources of Randomness
+
+   The best source of input for mixing would be a hardware randomness
+   such as disk drive timing affected by air turbulence, audio input
+   with thermal noise, or radioactive decay.  However, if that is not
+   available there are other possibilities.  These include system
+   clocks, system or input/output buffers, user/system/hardware/network
+   serial numbers and/or addresses and timing, and user input.
+   Unfortunately, any of these sources can produce limited or
+   predicatable values under some circumstances.
+
+   Some of the sources listed above would be quite strong on multi-user
+   systems where, in essence, each user of the system is a source of
+   randomness.	However, on a small single user system, such as a
+   typical IBM PC or Apple Macintosh, it might be possible for an
+   adversary to assemble a similar configuration.  This could give the
+   adversary inputs to the mixing process that were sufficiently
+   correlated to those used originally as to make exhaustive search
+   practical.
+
+   The use of multiple random inputs with a strong mixing function is
+   recommended and can overcome weakness in any particular input.  For
+   example, the timing and content of requested "random" user keystrokes
+   can yield hundreds of random bits but conservative assumptions need
+   to be made.	For example, assuming a few bits of randomness if the
+   inter-keystroke interval is unique in the sequence up to that point
+   and a similar assumption if the key hit is unique but assuming that
+   no bits of randomness are present in the initial key value or if the
+   timing or key value duplicate previous values.  The results of mixing
+   these timings and characters typed could be further combined with
+   clock values and other inputs.
+
+   This strategy may make practical portable code to produce good random
+   numbers for security even if some of the inputs are very weak on some
+   of the target systems.  However, it may still fail against a high
+   grade attack on small single user systems, especially if the
+   adversary has ever been able to observe the generation process in the
+   past.  A hardware based random source is still preferable.
+
+6.3 Cryptographically Strong Sequences
+
+   In cases where a series of random quantities must be generated, an
+   adversary may learn some values in the sequence.  In general, they
+   should not be able to predict other values from the ones that they
+   know.
+
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 19]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   The correct technique is to start with a strong random seed, take
+   cryptographically strong steps from that seed [CRYPTO2, CRYPTO3], and
+   do not reveal the complete state of the generator in the sequence
+   elements.  If each value in the sequence can be calculated in a fixed
+   way from the previous value, then when any value is compromised, all
+   future values can be determined.  This would be the case, for
+   example, if each value were a constant function of the previously
+   used values, even if the function were a very strong, non-invertible
+   message digest function.
+
+   It should be noted that if your technique for generating a sequence
+   of key values is fast enough, it can trivially be used as the basis
+   for a confidentiality system.  If two parties use the same sequence
+   generating technique and start with the same seed material, they will
+   generate identical sequences.  These could, for example, be xor'ed at
+   one end with data being send, encrypting it, and xor'ed with this
+   data as received, decrypting it due to the reversible properties of
+   the xor operation.
+
+6.3.1 Traditional Strong Sequences
+
+   A traditional way to achieve a strong sequence has been to have the
+   values be produced by hashing the quantities produced by
+   concatenating the seed with successive integers or the like and then
+   mask the values obtained so as to limit the amount of generator state
+   available to the adversary.
+
+   It may also be possible to use an "encryption" algorithm with a
+   random key and seed value to encrypt and feedback some or all of the
+   output encrypted value into the value to be encrypted for the next
+   iteration.  Appropriate feedback techniques will usually be
+   recommended with the encryption algorithm.  An example is shown below
+   where shifting and masking are used to combine the cypher output
+   feedback.  This type of feedback is recommended by the US Government
+   in connection with DES [DES MODES].
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 20]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+      +---------------+
+      |       V       |
+      |  |     n      |
+      +--+------------+
+	    |	   |	       +---------+
+	    |	   +---------> |	 |	+-----+
+	 +--+		       | Encrypt | <--- | Key |
+	 |	     +-------- |	 |	+-----+
+	 |	     |	       +---------+
+	 V	     V
+      +------------+--+
+      |      V	   |  |
+      |       n+1     |
+      +---------------+
+
+   Note that if a shift of one is used, this is the same as the shift
+   register technique described in Section 3 above but with the all
+   important difference that the feedback is determined by a complex
+   non-linear function of all bits rather than a simple linear or
+   polynomial combination of output from a few bit position taps.
+
+   It has been shown by Donald W. Davies that this sort of shifted
+   partial output feedback significantly weakens an algorithm compared
+   will feeding all of the output bits back as input.  In particular,
+   for DES, repeated encrypting a full 64 bit quantity will give an
+   expected repeat in about 2^63 iterations.  Feeding back anything less
+   than 64 (and more than 0) bits will give an expected repeat in
+   between 2**31 and 2**32 iterations!
+
+   To predict values of a sequence from others when the sequence was
+   generated by these techniques is equivalent to breaking the
+   cryptosystem or inverting the "non-invertible" hashing involved with
+   only partial information available.	The less information revealed
+   each iteration, the harder it will be for an adversary to predict the
+   sequence.  Thus it is best to use only one bit from each value.  It
+   has been shown that in some cases this makes it impossible to break a
+   system even when the cryptographic system is invertible and can be
+   broken if all of each generated value was revealed.
+
+6.3.2 The Blum Blum Shub Sequence Generator
+
+   Currently the generator which has the strongest public proof of
+   strength is called the Blum Blum Shub generator after its inventors
+   [BBS].  It is also very simple and is based on quadratic residues.
+   It's only disadvantage is that is is computationally intensive
+   compared with the traditional techniques give in 6.3.1 above.  This
+   is not a serious draw back if it is used for moderately infrequent
+   purposes, such as generating session keys.
+
+
+
+Eastlake, Crocker & Schiller				       [Page 21]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   Simply choose two large prime numbers, say p and q, which both have
+   the property that you get a remainder of 3 if you divide them by 4.
+   Let n = p * q.  Then you choose a random number x relatively prime to
+   n.  The initial seed for the generator and the method for calculating
+   subsequent values are then
+
+		   2
+	s    =	( x  )(Mod n)
+	 0
+
+		   2
+	s    = ( s   )(Mod n)
+	 i+1	  i
+
+   You must be careful to use only a few bits from the bottom of each s.
+   It is always safe to use only the lowest order bit.	If you use no
+   more than the
+
+		  log  ( log  ( s  ) )
+		     2	    2	 i
+
+   low order bits, then predicting any additional bits from a sequence
+   generated in this manner is provable as hard as factoring n.  As long
+   as the initial x is secret, you can even make n public if you want.
+
+   An intersting characteristic of this generator is that you can
+   directly calculate any of the s values.  In particular
+
+		     i
+	       ( ( 2  )(Mod (( p - 1 ) * ( q - 1 )) ) )
+      s  = ( s						)(Mod n)
+       i      0
+
+   This means that in applications where many keys are generated in this
+   fashion, it is not necessary to save them all.  Each key can be
+   effectively indexed and recovered from that small index and the
+   initial s and n.
+
+7. Key Generation Standards
+
+   Several public standards are now in place for the generation of keys.
+   Two of these are described below.  Both use DES but any equally
+   strong or stronger mixing function could be substituted.
+
+
+
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 22]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+7.1 US DoD Recommendations for Password Generation
+
+   The United States Department of Defense has specific recommendations
+   for password generation [DoD].  They suggest using the US Data
+   Encryption Standard [DES] in Output Feedback Mode [DES MODES] as
+   follows:
+
+	use an initialization vector determined from
+	     the system clock,
+	     system ID,
+	     user ID, and
+	     date and time;
+	use a key determined from
+	     system interrupt registers,
+	     system status registers, and
+	     system counters; and,
+	as plain text, use an external randomly generated 64 bit
+	quantity such as 8 characters typed in by a system
+	administrator.
+
+   The password can then be calculated from the 64 bit "cipher text"
+   generated in 64-bit Output Feedback Mode.  As many bits as are needed
+   can be taken from these 64 bits and expanded into a pronounceable
+   word, phrase, or other format if a human being needs to remember the
+   password.
+
+7.2 X9.17 Key Generation
+
+   The American National Standards Institute has specified a method for
+   generating a sequence of keys as follows:
+
+	s  is the initial 64 bit seed
+	 0
+
+	g  is the sequence of generated 64 bit key quantities
+	 n
+
+	k is a random key reserved for generating this key sequence
+
+	t is the time at which a key is generated to as fine a resolution
+	    as is available (up to 64 bits).
+
+	DES ( K, Q ) is the DES encryption of quantity Q with key K
+
+
+
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 23]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+	g    = DES ( k, DES ( k, t ) .xor. s  )
+	 n				    n
+
+	s    = DES ( k, DES ( k, t ) .xor. g  )
+	 n+1				    n
+
+   If g sub n is to be used as a DES key, then every eighth bit should
+   be adjusted for parity for that use but the entire 64 bit unmodified
+   g should be used in calculating the next s.
+
+8. Examples of Randomness Required
+
+   Below are two examples showing rough calculations of needed
+   randomness for security.  The first is for moderate security
+   passwords while the second assumes a need for a very high security
+   cryptographic key.
+
+8.1  Password Generation
+
+   Assume that user passwords change once a year and it is desired that
+   the probability that an adversary could guess the password for a
+   particular account be less than one in a thousand.  Further assume
+   that sending a password to the system is the only way to try a
+   password.  Then the crucial question is how often an adversary can
+   try possibilities.  Assume that delays have been introduced into a
+   system so that, at most, an adversary can make one password try every
+   six seconds.  That's 600 per hour or about 15,000 per day or about
+   5,000,000 tries in a year.  Assuming any sort of monitoring, it is
+   unlikely someone could actually try continuously for a year.  In
+   fact, even if log files are only checked monthly, 500,000 tries is
+   more plausible before the attack is noticed and steps taken to change
+   passwords and make it harder to try more passwords.
+
+   To have a one in a thousand chance of guessing the password in
+   500,000 tries implies a universe of at least 500,000,000 passwords or
+   about 2^29.	Thus 29 bits of randomness are needed. This can probably
+   be achieved using the US DoD recommended inputs for password
+   generation as it has 8 inputs which probably average over 5 bits of
+   randomness each (see section 7.1).  Using a list of 1000 words, the
+   password could be expressed as a three word phrase (1,000,000,000
+   possibilities) or, using case insensitive letters and digits, six
+   would suffice ((26+10)^6 = 2,176,782,336 possibilities).
+
+   For a higher security password, the number of bits required goes up.
+   To decrease the probability by 1,000 requires increasing the universe
+   of passwords by the same factor which adds about 10 bits.  Thus to
+   have only a one in a million chance of a password being guessed under
+   the above scenario would require 39 bits of randomness and a password
+
+
+
+Eastlake, Crocker & Schiller				       [Page 24]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   that was a four word phrase from a 1000 word list or eight
+   letters/digits.  To go to a one in 10^9 chance, 49 bits of randomness
+   are needed implying a five word phrase or ten letter/digit password.
+
+   In a real system, of course, there are also other factors.  For
+   example, the larger and harder to remember passwords are, the more
+   likely users are to write them down resulting in an additional risk
+   of compromise.
+
+8.2 A Very High Security Cryptographic Key
+
+   Assume that a very high security key is needed for symmetric
+   encryption / decryption between two parties.  Assume an adversary can
+   observe communications and knows the algorithm being used.  Within
+   the field of random possibilities, the adversary can try key values
+   in hopes of finding the one in use.	Assume further that brute force
+   trial of keys is the best the adversary can do.
+
+8.2.1 Effort per Key Trial
+
+   How much effort will it take to try each key?  For very high security
+   applications it is best to assume a low value of effort.  Even if it
+   would clearly take tens of thousands of computer cycles or more to
+   try a single key, there may be some pattern that enables huge blocks
+   of key values to be tested with much less effort per key.  Thus it is
+   probably best to assume no more than a couple hundred cycles per key.
+   (There is no clear lower bound on this as computers operate in
+   parallel on a number of bits and a poor encryption algorithm could
+   allow many keys or even groups of keys to be tested in parallel.
+   However, we need to assume some value and can hope that a reasonably
+   strong algorithm has been chosen for our hypothetical high security
+   task.)
+
+   If the adversary can command a highly parallel processor or a large
+   network of work stations, 2*10^10 cycles per second is probably a
+   minimum assumption for availability today.  Looking forward just a
+   couple years, there should be at least an order of magnitude
+   improvement.  Thus assuming 10^9 keys could be checked per second or
+   3.6*10^11 per hour or 6*10^13 per week or 2.4*10^14 per month is
+   reasonable.	This implies a need for a minimum of 51 bits of
+   randomness in keys to be sure they cannot be found in a month.  Even
+   then it is possible that, a few years from now, a highly determined
+   and resourceful adversary could break the key in 2 weeks (on average
+   they need try only half the keys).
+
+
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 25]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+8.2.2 Meet in the Middle Attacks
+
+   If chosen or known plain text and the resulting encrypted text are
+   available, a "meet in the middle" attack is possible if the structure
+   of the encryption algorithm allows it.  (In a known plain text
+   attack, the adversary knows all or part of the messages being
+   encrypted, possibly some standard header or trailer fields.	In a
+   chosen plain text attack, the adversary can force some chosen plain
+   text to be encrypted, possibly by "leaking" an exciting text that
+   would then be sent by the adversary over an encrypted channel.)
+
+   An oversimplified explanation of the meet in the middle attack is as
+   follows: the adversary can half-encrypt the known or chosen plain
+   text with all possible first half-keys, sort the output, then half-
+   decrypt the encoded text with all the second half-keys.  If a match
+   is found, the full key can be assembled from the halves and used to
+   decrypt other parts of the message or other messages.  At its best,
+   this type of attack can halve the exponent of the work required by
+   the adversary while adding a large but roughly constant factor of
+   effort.  To be assured of safety against this, a doubling of the
+   amount of randomness in the key to a minimum of 102 bits is required.
+
+   The meet in the middle attack assumes that the cryptographic
+   algorithm can be decomposed in this way but we can not rule that out
+   without a deep knowledge of the algorithm.  Even if a basic algorithm
+   is not subject to a meet in the middle attack, an attempt to produce
+   a stronger algorithm by applying the basic algorithm twice (or two
+   different algorithms sequentially) with different keys may gain less
+   added security than would be expected.  Such a composite algorithm
+   would be subject to a meet in the middle attack.
+
+   Enormous resources may be required to mount a meet in the middle
+   attack but they are probably within the range of the national
+   security services of a major nation.  Essentially all nations spy on
+   other nations government traffic and several nations are believed to
+   spy on commercial traffic for economic advantage.
+
+8.2.3 Other Considerations
+
+   Since we have not even considered the possibilities of special
+   purpose code breaking hardware or just how much of a safety margin we
+   want beyond our assumptions above, probably a good minimum for a very
+   high security cryptographic key is 128 bits of randomness which
+   implies a minimum key length of 128 bits.  If the two parties agree
+   on a key by Diffie-Hellman exchange [D-H], then in principle only
+   half of this randomness would have to be supplied by each party.
+   However, there is probably some correlation between their random
+   inputs so it is probably best to assume that each party needs to
+
+
+
+Eastlake, Crocker & Schiller				       [Page 26]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   provide at least 96 bits worth of randomness for very high security
+   if Diffie-Hellman is used.
+
+   This amount of randomness is beyond the limit of that in the inputs
+   recommended by the US DoD for password generation and could require
+   user typing timing, hardware random number generation, or other
+   sources.
+
+   It should be noted that key length calculations such at those above
+   are controversial and depend on various assumptions about the
+   cryptographic algorithms in use.  In some cases, a professional with
+   a deep knowledge of code breaking techniques and of the strength of
+   the algorithm in use could be satisfied with less than half of the
+   key size derived above.
+
+9. Conclusion
+
+   Generation of unguessable "random" secret quantities for security use
+   is an essential but difficult task.
+
+   We have shown that hardware techniques to produce such randomness
+   would be relatively simple.	In particular, the volume and quality
+   would not need to be high and existing computer hardware, such as
+   disk drives, can be used.  Computational techniques are available to
+   process low quality random quantities from multiple sources or a
+   larger quantity of such low quality input from one source and produce
+   a smaller quantity of higher quality, less predictable key material.
+   In the absence of hardware sources of randomness, a variety of user
+   and software sources can frequently be used instead with care;
+   however, most modern systems already have hardware, such as disk
+   drives or audio input, that could be used to produce high quality
+   randomness.
+
+   Once a sufficient quantity of high quality seed key material (a few
+   hundred bits) is available, strong computational techniques are
+   available to produce cryptographically strong sequences of
+   unpredicatable quantities from this seed material.
+
+10. Security Considerations
+
+   The entirety of this document concerns techniques and recommendations
+   for generating unguessable "random" quantities for use as passwords,
+   cryptographic keys, and similar security uses.
+
+
+
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 27]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+References
+
+   [ASYMMETRIC] - Secure Communications and Asymmetric Cryptosystems,
+   edited by Gustavus J. Simmons, AAAS Selected Symposium 69, Westview
+   Press, Inc.
+
+   [BBS] - A Simple Unpredictable Pseudo-Random Number Generator, SIAM
+   Journal on Computing, v. 15, n. 2, 1986, L. Blum, M. Blum, & M. Shub.
+
+   [BRILLINGER] - Time Series: Data Analysis and Theory, Holden-Day,
+   1981, David Brillinger.
+
+   [CRC] - C.R.C. Standard Mathematical Tables, Chemical Rubber
+   Publishing Company.
+
+   [CRYPTO1] - Cryptography: A Primer, A Wiley-Interscience Publication,
+   John Wiley & Sons, 1981, Alan G. Konheim.
+
+   [CRYPTO2] - Cryptography:  A New Dimension in Computer Data Security,
+   A Wiley-Interscience Publication, John Wiley & Sons, 1982, Carl H.
+   Meyer & Stephen M. Matyas.
+
+   [CRYPTO3] - Applied Cryptography: Protocols, Algorithms, and Source
+   Code in C, John Wiley & Sons, 1994, Bruce Schneier.
+
+   [DAVIS] - Cryptographic Randomness from Air Turbulence in Disk
+   Drives, Advances in Cryptology - Crypto '94, Springer-Verlag Lecture
+   Notes in Computer Science #839, 1984, Don Davis, Ross Ihaka, and
+   Philip Fenstermacher.
+
+   [DES] -  Data Encryption Standard, United States of America,
+   Department of Commerce, National Institute of Standards and
+   Technology, Federal Information Processing Standard (FIPS) 46-1.
+   - Data Encryption Algorithm, American National Standards Institute,
+   ANSI X3.92-1981.
+   (See also FIPS 112, Password Usage, which includes FORTRAN code for
+   performing DES.)
+
+   [DES MODES] - DES Modes of Operation, United States of America,
+   Department of Commerce, National Institute of Standards and
+   Technology, Federal Information Processing Standard (FIPS) 81.
+   - Data Encryption Algorithm - Modes of Operation, American National
+   Standards Institute, ANSI X3.106-1983.
+
+   [D-H] - New Directions in Cryptography, IEEE Transactions on
+   Information Technology, November, 1976, Whitfield Diffie and Martin
+   E. Hellman.
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 28]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   [DoD] - Password Management Guideline, United States of America,
+   Department of Defense, Computer Security Center, CSC-STD-002-85.
+   (See also FIPS 112, Password Usage, which incorporates CSC-STD-002-85
+   as one of its appendices.)
+
+   [GIFFORD] - Natural Random Number, MIT/LCS/TM-371, September 1988,
+   David K. Gifford
+
+   [KNUTH] - The Art of Computer Programming, Volume 2: Seminumerical
+   Algorithms, Chapter 3: Random Numbers. Addison Wesley Publishing
+   Company, Second Edition 1982, Donald E. Knuth.
+
+   [KRAWCZYK] - How to Predict Congruential Generators, Journal of
+   Algorithms, V. 13, N. 4, December 1992, H. Krawczyk
+
+   [MD2] - The MD2 Message-Digest Algorithm, RFC1319, April 1992, B.
+   Kaliski
+   [MD4] - The MD4 Message-Digest Algorithm, RFC1320, April 1992, R.
+   Rivest
+   [MD5] - The MD5 Message-Digest Algorithm, RFC1321, April 1992, R.
+   Rivest
+
+   [PEM] - RFCs 1421 through 1424:
+   - RFC 1424, Privacy Enhancement for Internet Electronic Mail: Part
+   IV: Key Certification and Related Services, 02/10/1993, B. Kaliski
+   - RFC 1423, Privacy Enhancement for Internet Electronic Mail: Part
+   III: Algorithms, Modes, and Identifiers, 02/10/1993, D. Balenson
+   - RFC 1422, Privacy Enhancement for Internet Electronic Mail: Part
+   II: Certificate-Based Key Management, 02/10/1993, S. Kent
+   - RFC 1421, Privacy Enhancement for Internet Electronic Mail: Part I:
+   Message Encryption and Authentication Procedures, 02/10/1993, J. Linn
+
+   [SHANNON] - The Mathematical Theory of Communication, University of
+   Illinois Press, 1963, Claude E. Shannon.  (originally from:	Bell
+   System Technical Journal, July and October 1948)
+
+   [SHIFT1] - Shift Register Sequences, Aegean Park Press, Revised
+   Edition 1982, Solomon W. Golomb.
+
+   [SHIFT2] - Cryptanalysis of Shift-Register Generated Stream Cypher
+   Systems, Aegean Park Press, 1984, Wayne G. Barker.
+
+   [SHS] - Secure Hash Standard, United States of American, National
+   Institute of Science and Technology, Federal Information Processing
+   Standard (FIPS) 180, April 1993.
+
+   [STERN] - Secret Linear Congruential Generators are not
+   Cryptograhically Secure, Proceedings of IEEE STOC, 1987, J. Stern.
+
+
+
+Eastlake, Crocker & Schiller				       [Page 29]
+
+RFC 1750	Randomness Recommendations for Security    December 1994
+
+
+   [VON NEUMANN] - Various techniques used in connection with random
+   digits, von Neumann's Collected Works, Vol. 5, Pergamon Press, 1963,
+   J. von Neumann.
+
+Authors' Addresses
+
+   Donald E. Eastlake 3rd
+   Digital Equipment Corporation
+   550 King Street, LKG2-1/BB3
+   Littleton, MA 01460
+
+   Phone:   +1 508 486 6577(w)	+1 508 287 4877(h)
+   EMail:   dee@lkg.dec.com
+
+
+   Stephen D. Crocker
+   CyberCash Inc.
+   2086 Hunters Crest Way
+   Vienna, VA 22181
+
+   Phone:   +1 703-620-1222(w)	+1 703-391-2651 (fax)
+   EMail:   crocker@cybercash.com
+
+
+   Jeffrey I. Schiller
+   Massachusetts Institute of Technology
+   77 Massachusetts Avenue
+   Cambridge, MA 02139
+
+   Phone:   +1 617 253 0161(w)
+   EMail:   jis@mit.edu
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+Eastlake, Crocker & Schiller				       [Page 30]
+
diff -urN g10-0.2.5/doc/rfc1991new g10-0.2.6/doc/rfc1991new
--- g10-0.2.5/doc/rfc1991new	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/doc/rfc1991new	Wed Nov 19 12:09:45 1997
@@ -0,0 +1,1224 @@
+
+	Enhanced by wk 28.10.97
+       --------------------------
+
+
+
+Network Working Group					       D. Atkins
+Request for Comments: 1991-new					     MIT
+Category: Informational 				    W. Stallings
+						    Comp-Comm Consulting
+							   P. Zimmermann
+					    Boulder Software Engineering
+							     August 1996
+								 W. Koch
+							     October 197
+
+
+		      PGP Message Exchange Formats
+
+Status of This Memo
+
+   This memo provides information for the Internet community.  This memo
+   does not specify an Internet standard of any kind.  Distribution of
+   this memo is unlimited.
+
+Table of Contents
+
+   1.	 Introduction............................................2
+   2.	 PGP Services............................................2
+   2.1	 Digital signature.......................................3
+   2.2	 Confidentiality.........................................3
+   2.3	 Compression.............................................4
+   2.4	 Radix-64 conversion.....................................4
+   2.4.1 ASCII Armor Formats.....................................5
+   3.	 Data Element Formats....................................6
+   3.1	 Byte strings............................................6
+   3.2	 Whole number fields.....................................7
+   3.3	 Multiprecision fields...................................7
+   3.4	 String fields...........................................8
+   3.5	 Time fields.............................................8
+   4.	 Common Fields...........................................8
+   4.1	 Packet structure fields.................................8
+   4.2	 Number ID fields.......................................10
+   4.3	 Version fields.........................................10
+   5.	 Packets................................................10
+   5.1	 Overview...............................................10
+   5.2	 General Packet Structure...............................11
+   5.2.1 Message component......................................11
+   5.2.2 Signature component....................................11
+   5.2.3 Session key component..................................11
+   6.	 PGP Packet Types.......................................12
+   6.1	 Literal data packets...................................12
+   6.2	 Signature packets......................................13
+   6.2.1 Message-digest-related fields..........................14
+   6.2.2 Public-key-related fields..............................15
+   6.2.3 RSA signatures.........................................16
+
+
+
+Atkins, et. al. 	     Informational			[Page 1]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+   6.2.4 Miscellaneous fields...................................16
+   6.3	 Compressed data packets................................17
+   6.4	 Conventional-key-encrypted data packets................17
+   6.4.1 Conventional-encryption type byte......................18
+   6.5	 Public-key-encrypted packets...........................18
+   6.5.1 RSA-encrypted data encryption key (DEK)................19
+   6.6	 Public-key Packets.....................................19
+   6.7	 User ID packets........................................20
+   7.	 Transferable Public Keys...............................20
+   8.	 Acknowledgments........................................20
+   9.	 Security Considerations................................21
+   10.	 Authors' Addresses.....................................21
+
+1. Introduction
+
+   PGP (Pretty Good Privacy) uses a combination of public-key and
+   conventional encryption to provide security services for electronic
+   mail messages and data files.  These services include confidentiality
+   and digital signature.  PGP is widely used throughout the global
+   computer community.	This document describes the format of "PGP
+   files", i.e., messages that have been encrypted and/or signed with
+   PGP.
+
+   PGP was created by Philip Zimmermann and first released, in Version
+   1.0, in 1991. Subsequent versions have been designed and implemented
+   by an all-volunteer collaborative effort under the design guidance of
+   Philip Zimmermann.  PGP and Pretty Good Privacy are trademarks of
+   Philip Zimmermann.
+
+   This document describes versions 2.x of PGP.  Specifically, versions
+   2.6 and 2.7 conform to this specification.  Version 2.3 conforms to
+   this specification with minor differences.
+
+   A new release of PGP, known as PGP 3.0, is anticipated in 1995. To
+   the maximum extent possible, this version will be upwardly compatible
+   with version 2.x. At a minimum, PGP 3.0 will be able to read messages
+   and signatures produced by version 2.x.
+
+2. PGP Services
+
+   PGP provides four services related to the format of messages and data
+   files: digital signature, confidentiality, compression, and radix-64
+   conversion.
+
+
+
+
+
+
+
+
+Atkins, et. al. 	     Informational			[Page 2]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+2.1 Digital signature
+
+   The digital signature service involves the use of a hash code, or
+   message digest, algorithm, and a public-key encryption algorithm. The
+   sequence is as follows:
+
+     -the sender creates a message
+     -the sending PGP generates a hash code of the message
+     -the sending PGP encrypts the hash code using the sender's private
+      key
+     -the encrypted hash code is prepended to the message
+     -the receiving PGP decrypts the hash code using the sender's public
+      key
+     -the receiving PGP generates a new hash code for the received
+      message and compares it to the decrypted hash code. If the two
+      match, the message is accepted as authentic
+
+   Although signatures normally are found attached to the message or
+   file that they sign, this is not always the case: detached signatures
+   are supported. A detached signature may be stored and transmitted
+   separately from the message it signs.  This is useful in several
+   contexts. A user may wish to maintain a separate signature log of all
+   messages sent or received.  A detached signature of an executable
+   program can detect subsequent virus infection. Finally, detached
+   signatures can be used when more than one party must sign a document,
+   such as a legal contract.  Each person's signature is independent and
+   therefore is applied only to the document. Otherwise, signatures
+   would have to be nested, with the second signer signing both the
+   document and the first signature, and so on.
+
+2.2 Confidentiality
+
+   PGP provides confidentiality by encrypting messages to be transmitted
+   or data files to be stored locally using conventional encryption. In
+   PGP, each conventional key is used only once. That is, a new key is
+   generated as a random 128-bit number for each message. Since it is to
+   be used only once, the session key is bound to the message and
+   transmitted with it.  To protect the key, it is encrypted with the
+   receiver's public key. The sequence is as follows:
+
+     -the sender creates a message
+     -the sending PGP generates a random number to be used as a session
+      key for this message only
+     -the sending PGP encrypts the message using the session key
+     -the session key is encrypted using the recipient's public key and
+      prepended to the encrypted message
+     -the receiving PGP decrypts the session key using the recipient's
+      private key
+
+
+
+Atkins, et. al. 	     Informational			[Page 3]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+     -the receiving PGP decrypts the message using the session key
+
+   Both digital signature and confidentiality services may be applied to
+   the same message. First, a signature is generated for the message and
+   prepended to the message.  Then, the message plus signature is
+   encrypted using a conventional session key. Finally, the session key
+   is encrypted using public-key encryption and prepended to the
+   encrypted block.
+
+2.3 Compression
+
+   As a default, PGP compresses the message after applying the signature
+   but before encryption.
+
+2.4 Radix-64 conversion
+
+   When PGP is used, usually part of the block to be transmitted is
+   encrypted. If only the signature service is used, then the message
+   digest is encrypted (with the sender's private key). If the
+   confidentiality service is used, the message plus signature (if
+   present) are encrypted (with a one-time conventional key). Thus, part
+   or all of the resulting block consists of a stream of arbitrary 8-bit
+   bytes.  However, many electronic mail systems only permit the use of
+   blocks consisting of ASCII text. To accommodate this restriction, PGP
+   provides the service of converting the raw 8-bit binary stream to a
+   stream of printable ASCII characters, called ASCII Armor.
+
+   The scheme used for this purpose is radix-64 conversion. Each group
+   of three bytes of binary data is mapped into 4 ASCII characters. This
+   format also appends a CRC to detect transmission errors.  This
+   radix-64 conversion, also called Ascii Armor, is a wrapper around the
+   binary PGP messages, and is used to protect the binary messages
+   during transmission over non-binary channels, such as Internet Email.
+
+   The following table defines the mapping.  The characters used are the
+   upper- and lower-case letters, the digits 0 through 9, and the
+   characters + and /.	The carriage-return and linefeed characters
+   aren't used in the conversion, nor is the tab or any other character
+   that might be altered by the mail system. The result is a text file
+   that is "immune" to the modifications inflicted by mail systems.
+
+
+
+
+
+
+
+
+
+
+
+Atkins, et. al. 	     Informational			[Page 4]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+   6-bit character   6-bit character   6-bit character	 6-bit character
+   value encoding  value  encoding    value   encoding	  value encoding
+   0	    A	     16        Q	32	  g	   48	     w
+   1	    B	     17        R	33	  h	   49	     x
+   2	    C	     18        S	34	  i	   50	     y
+   3	    D	     19        T	35	  j	   51	     z
+   4	    E	     20        U	36	  k	   52	     0
+   5	    F	     21        V	37	  l	   53	     1
+   6	    G	     22        W	38	  m	   54	     2
+   7	    H	     23        X	39	  n	   55	     3
+   8	    I	     24        Y	40	  o	   56	     4
+   9	    J	     25        Z	41	  p	   57	     5
+   1	    K	     26        a	42	  q	   58	     6
+   11	    L	     27        b	43	  r	   59	     7
+   12	    M	     28        c	44	  s	   60	     8
+   13	    N	     29        d	45	  t	   61	     9
+   14	    O	     30        e	46	  u	   62	     +
+   15	    P	     31        f	47	  v	   63	     /
+							 (pad)	     =
+
+   It is possible to use PGP to convert any arbitrary file to ASCII
+   Armor.  When this is done, PGP tries to compress the data before it
+   is converted to Radix-64.
+
+2.4.1 ASCII Armor Formats
+
+   When PGP encodes data into ASCII Armor, it puts specific headers
+   around the data, so PGP can reconstruct the data at a future time.
+   PGP tries to inform the user what kind of data is encoded in the
+   ASCII armor through the use of the headers.
+
+   ASCII Armor is created by concatenating the following data:
+
+	- An Armor Headerline, appropriate for the type of data
+	- Armor Headers
+	- A blank line
+	- The ASCII-Armored data
+	- An Armor Checksum
+	- The Armor Tail (which depends on the Armor Headerline).
+
+   An Armor Headerline is composed by taking the appropriate headerline
+   text surrounded by five (5) dashes (-) on either side of the
+   headerline text.  The headerline text is chosen based upon the type
+   of data that is being encoded in Armor, and how it is being encoded.
+   Headerline texts include the following strings:
+
+    BEGIN PGP MESSAGE -- used for signed, encrypted, or compressed files
+    BEGIN PGP PUBLIC KEY BLOCK -- used for transferring public keys
+
+
+
+Atkins, et. al. 	     Informational			[Page 5]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+    BEGIN PGP MESSAGE, PART X/Y -- used for multi-part messages, where
+				    the armor is split amongst Y files,
+				    and this is the Xth file out of Y.
+
+   The Armor Headers are pairs of strings that can give the user or the
+   receiving PGP program some information about how to decode or use the
+   message.  The Armor Headers are a part of the armor, not a part of
+   the message, and hence should not be used to convey any important
+   information, since they can be changed in transport.
+
+   The format of an Armor Header is that of a key-value pair, the
+   encoding of RFC-822 headers.  PGP should consider improperly
+   formatted Armor Headers to be corruption of the ASCII Armor.  Unknown
+   Keys should be reported to the user, but so long as the RFC-822
+   formatting is correct, PGP should continue to process the message.
+   Currently defined Armor Header Keys include "Version" and "Comment",
+   which define the PGP Version used to encode the message and a user-
+   defined comment.
+
+   The Armor Checksum is a 24-bit CRC converted to four bytes of radix-
+   64 encoding, prepending an equal-sign (=) to the four-byte code.  The
+   CRC is computed by using the generator 0x864CFB and an initialization
+   of 0xB704CE.  The accumulation is done on the data before it is
+   converted to radix-64, rather than on the converted data.  For more
+   information on CRC functions, the reader is asked to look at chapter
+   19 of the book "C Programmer's Guide to Serial Communications," by
+   Joe Campbell.
+
+   The Armor Tail is composed in the same manner as the Armor
+   Headerline, except the string "BEGIN" is replaced by the string
+   "END".
+
+3. Data Element Formats
+
+3.1 Byte strings
+
+   The objects considered in this document are all "byte strings."  A
+   byte string is a finite sequence of bytes.  The concatenation of byte
+   string X of length M with byte string Y of length N is a byte string
+   Z of length M + N; the first M bytes of Z are the bytes of X in the
+   same order, and the remaining N bytes of Z are the bytes of Y in the
+   same order.
+
+   Literal byte strings are written from left to right, with pairs of
+   hex nibbles separated by spaces, enclosed by angle brackets: for
+   instance, <05 ff 07> is a byte string of length 3 whose bytes have
+   numeric values 5, 255, and 7 in that order.	All numbers in this
+   document outside angle brackets are written in decimal.
+
+
+
+Atkins, et. al. 	     Informational			[Page 6]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+   The byte string of length 0 is called "empty" and written <>.
+
+3.2 Whole number fields
+
+   Purpose.  A whole number field can represent any nonnegative integer,
+   in a format where the field length is known in advance.
+
+   Definition.	A whole number field is any byte string.  It is stored
+   in radix-256 MSB-first format.  This means that a whole number field
+   of length N with bytes b_0 b_1 ...  b_{N-2} b_{N-1} in that order has
+   value
+
+      b_0 * 256^{N-1} + b_1 * 256^{N-2} + ... + b_{N-2} * 256 + b_{N-1}.
+
+   Examples.  The byte string <00 0D 64 11 00 00> is a valid whole
+   number field with value 57513410560.  The byte string <FF> is a valid
+   whole number field with value 255.  The byte string <00 00> is a
+   valid whole number field with value 0.  The empty byte string <> is a
+   valid whole number field with value 0.
+
+3.3 Multiprecision fields
+
+   Purpose.  A multiprecision field can represent any nonnegative
+   integer which is not too large.  The field length need not be known
+   in advance.	Multiprecision fields are designed to waste very little
+   space: a small integer uses a short field.
+
+   Definition.	A multiprecision field is the concatenation of two
+   fields:
+
+      (a) a whole number field of length 2, with value B;
+      (b) a whole number field, with value V.
+
+   Field (b) is of length [(B+7)/8], i.e., the greatest integer which is
+   no larger than (B+7)/8.  The value of the multiprecision field is
+   defined to be V.  V must be between 2^{B-1} and 2^B - 1 inclusive.
+   In other words B must be exactly the number of significant bits in V.
+
+   Some implementations may limit the possible range of B.  The
+   implementor must document which values of B are allowed by an
+   implementation.
+
+   Examples.  The byte string <00 00> is a valid multiprecision integer
+   with value 0.  The byte string <00 03 05> is a valid multiprecision
+   field with value 5.	The byte strings <00 03 85> and <00 00 00> are
+   not valid multiprecision fields.  The former is invalild because <85>
+   has 8 significant bits, not 3; the latter is invalid because the
+   second field has too many bytes of data given the value of the first
+
+
+
+Atkins, et. al. 	     Informational			[Page 7]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+   field.  The byte string <00 09 01 ff> is a valid multiprecision field
+   with value 511.  The byte string <01 00 80 00 00 00 00 00 00 00 00 00
+   00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 07> is
+   a valid multiprecision field with value 2^255 + 7.
+
+3.4  String fields
+
+   Purpose.  A string field represents any sequence of bytes of length
+   between 0 and 255 inclusive.  The length need not be known in
+   advance.  By convention, the content of a string field is normally
+   interpreted as ASCII codes when it is displayed.
+
+   Definition.	A string field is the concatenation of the following:
+
+     (a) a whole number field of length 1, with value L;
+     (b) a byte string of length L.
+
+   The content of the string field is defined to be field (b).
+
+   Examples: <05 48 45 4c 4c 4f> is a valid string field which would
+   normally be displayed as the string HELLO.  <00> is a valid string
+   field which would normally be displayed as the empty string.  <01 00>
+   is a valid string field.
+
+3.5  Time fields
+
+   Purpose.  A time field represents the number of seconds elapsed since
+   1970 Jan 1 00:00:00 GMT.  It is compatible with the usual
+   representation of times under UNIX.
+
+   Definition.	A time field is a whole number field of length 4, with
+   value V.  The time represented by the time field is the one-second
+   interval beginning V seconds after 1970 Jan 1 00:00:00 GMT.
+
+4. Common Fields
+
+   This section defines fields found in more than one packet format.
+
+4.1  Packet structure fields
+
+   Purpose.  The packet structure field distinguishes between different
+   types of packets, and indicates the length of packets.
+
+   Definition.	A packet structure field is a byte string of length 1,
+   2, 3, or 5.	Its first byte is the cipher type byte (CTB), with bits
+   labeled 76543210, 7 the most significant bit and 0 the least
+   significant bit.  As indicated below the length of the packet
+   structure field is determined by the CTB.
+
+
+
+Atkins, et. al. 	     Informational			[Page 8]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+      CTB bits 76 have values listed in the following table:
+
+      10 - normal CTB
+      11 - reserved for future experimental work
+      all others - reserved
+
+   CTB bits 5432, the "packet type bits", have values listed in the
+   following table:
+
+      0001 - public-key-encrypted packet
+      0010 - signature packet
+      0101 - secret-key certificate packet
+      0110 - public-key certificate packet
+      1000 - compressed data packet
+      1001 - conventional-key-encrypted packet
+      1011 - literal data packet
+      1100 - keyring trust packet
+      1101 - user id packet
+      1110 - comment packet	(*)
+      all others - reserved
+
+   CTB bits 10, the "packet-length length bits", have values listed in
+   the following table:
+
+      00 - 1-byte packet-length field
+      01 - 2-byte packet-length field
+      10 - 4-byte packet-length field
+      11 - no packet length supplied, unknown packet length
+
+   As indicated in this table, depending on the packet-length length
+   bits, the remaining 1, 2, 4, or 0 bytes of the packet structure field
+   are a "packet-length field".  The packet-length field is a whole
+   number field.  The value of the packet-length field is defined to be
+   the value of the whole number field.
+
+   A value of 11 is currently used in one place: on compressed data.
+   That is, a compressed data block currently looks like <A3 01 . .  .>,
+   where <A3>, binary 10 1000 11, is an indefinite-length packet. The
+   proper interpretation is "until the end of the enclosing structure",
+   although it should never appear outermost (where the enclosing
+   structure is a file).
+
++  This will be changed with another version, where the new meaning of
++  the value 11 (see below) will also take place.
++
++  A value of 11 for other packets enables a special length encoding,
++  which is used in case, where the length of the following packet can
++  not be determined prior to writing the packet; especially this will
++  be used if large amounts of data are processed in filter mode.
++
++  It works like this: After the CTB (with a length field of 11) a
++  marker field is used, which gives the length of the following datablock.
++  This is a simple 2 byte field (MSB first) containig the amount of data
++  following this field, not including this length field. After this datablock
++  another length field follows, which gives the size of the next datablock.
++  A value of 0 indicates the end of the packet. The maximum size of a
++  data block is limited to 65534, thereby reserving a value of 0xffff for
++  future extensions. These length markers must be insereted into the data
++  stream just before writing the data out.
++
++  This 2 byte filed is large enough, because the application must buffer
++  this amount of data to prepend the length marker before writing it out.
++  Data block sizes larger than about 32k doesn't make any sense. Note
++  that this may also be used for compressed data streams, but we must use
++  another packet version to tell the application that it can not assume,
++  that this is the last packet.
+
+   Options marked with an asterisk (*) are not implemented yet; PGP
+   2.6.2 will never output this packet type.
+
+
+
+
+
+
+
+Atkins, et. al. 	     Informational			[Page 9]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+4.2  Number ID fields
+
+   Purpose.  The ID of a whole number is its 64 least significant bits.
+   The ID is a convenient way to distinguish between large numbers such
+   as keys, without having to transmit the number itself. Thus, a number
+   that may be hundreds or thousands of decimal digits in length can be
+   identified with a 64-bit identifier. Two keys may have the same ID by
+   chance or by malice; although the probability that two large keys
+   chosen at random would have the same ID is extremely small.
+
+   Definition.	A number ID field is a whole number field of length 8.
+   The value of the number ID field is defined to be the value of the
+   whole number field.
+
+4.3  Version fields
+
+   Many packet types include a version number as the first byte of the
+   body.  The format and meaning of the body depend on the version
+   number.  More versions of packets, with new version numbers, may be
+   defined in the future.  An implementation need not support every
+   version of each packet type.  However, the implementor must document
+   which versions of each packet type are supported by the
+   implementation.
+
+   A version number of 2 or 3 is currently allowed for each packet
+   format.  New versions will probably be numbered sequentially up from
+   3.  For backwards compatibility, implementations will usually be
+   expected to support version N of a packet whenever they support
+   version N+1.  Version 255 may be used for experimental purposes.
+
++ What version numbering should we use for G10?
++ My be it's a good idea to prepend a comment record, telling us that
++ this packet ring was prodused by G10
+
+5. Packets
+
+5.1 Overview
+
+   A packet is a digital envelope with data inside.  A PGP file, by
+   definition, is the concatenation of one or more packets. In addition,
+   one or more of the packets in a file may be subject to a
+   transformation using encryption, compression, or radix-64 conversion.
+
+   A packet is the concatenation of the following:
+
+      (a) a packet structure field;
+      (b) a byte string of some length N.
+
+   Byte string (b) is called the "body" of the packet.  The value of the
+   packet-length field inside the packet structure field (a) must equal
+   N, the length of the body.
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 10]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+   Other characteristics of the packet are determined by the type of the
+   packet.  See the definitions of particular packet types for further
+   details.  The CTB packet-type bits inside the packet structure always
+   indicate the packet type.
+
+   Note that packets may be nested: one digital envelope may be placed
+   inside another.  For example, a conventional-key-encrypted packet
+   contains a disguised packet, which in turn might be a compressed data
+   packet.
+
+5.2  General packet structure
+
+   A pgp file consists of three components: a message component, a
+   signature (optional), and a session key component (optional).
+
+5.2.1 Message component
+
+   The message component includes the actual data to be stored or
+   transmitted as well as a header that includes control information
+   generated by PGP. The message component consists of a single literal
+   data packet.
+
+5.2.2 Signature component
+
+   The signature component is the signature of the message component,
+   formed using a hash code of the message component and the public key
+   of the sending PGP entity.  The signature component consists of a
+   single signature packet.
+
+   If the default option of compression is chosen, then the block
+   consisting of the literal data packet and the signature packet is
+   compressed to form a compressed data packet.
+
+5.2.3 Session key component
+
+   The session key component includes the encrypted session key and the
+   identifier of the recipients public key used by the sender to encrypt
+   the session key.  The session key component consists of a single
+   public-key-encrypted packet for each recipient of the message.
+
+   If compression has been used, then conventional encryption is applied
+   to the compressed data packet formed from the compression of the
+   signature packet and the literal data packet. Otherwise, conventional
+   encryption is applied to the block consisting of the signature packet
+   and the literal data packet.  In either case, the cyphertext is
+   referred to as a conventional-key-encrypted data packet.
+
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 11]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+6.  PGP Packet Types
+
+   PGP includes the following types of packets:
+
+       -literal data packet
+       -signature packet
+       -compressed data packet
+       -conventional-key-encrypted data packet
+       -public-key-encrypted packet
+       -public-key packet
+       -User ID packet
+
+6.1 Literal data packets
+
+   Purpose.  A literal data packet is the lowest level of contents of a
+   digital envelope.  The data inside a literal data packet is not
+   subject to any further interpretation by PGP.
+
+   Definition.	A literal data packet is the concatenation of the
+   following fields:
+
+      (a) a packet structure field;
+      (b) a byte, giving a mode;
+      (c) a string field, giving a filename;
+      (d) a time field;
+      (e) a byte string of literal data.
+
+
+   Fields (b), (c), and (d) suggest how the data should be written to a
+   file. Byte (b) is either ASCII b <62>, for binary, or ASCII t <74>,
+   for text. Byte (b) may also take on the value ASCII 1, indicating a
+   machine-local conversion. It is not defined how PGP will convert this
+   across platforms.
+
+   Field (c) suggests a filename. Field (d) should be the time at which
+   the file was last modified, or the time at which the data packet was
+   created, or 0.
+
+   Note that only field (e) of a literal data packet is fed to a
+   message-digest function for the formation of a signature. The
+   exclusion of the other fields ensures that detached signatures are
+   exactly the same as attached signatures prefixed to the message.
+   Detached signatures are calculated on a separate file that has none
+   of the literal data packet header fields.
+
+
+
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 12]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+6.2 Signature packet
+
+   Purpose.  Signatures are attached to data, in such a way that only
+   one entity, called the "writer," can create the signature.  The
+   writer must first create a "public key" K and distribute it.  The
+   writer keeps certain private data related to K.  Only someone
+   cooperating with the writer can sign data using K, enveloping the
+   data in a signature packet (also known as a private-key-encrypted
+   packet).  Anyone can look through the glass in the envelope and
+   verify that the signature was attached to the data using K.	If the
+   data is altered in any way then the verification will fail.
+
+   Signatures have different meanings.	For example, a signature might
+   mean "I wrote this document," or "I received this document."  A
+   signature packet includes a "classification" which expresses its
+   meaning.
+
+   Definition.	A signature packet, version 2 or 3, is the concatenation
+   of the following fields:
+
+      (a) packet structure field (2, 3, or 5 bytes);
+      (b) version number = 2 or 3 (1 byte);
+      (c) length of following material included in MD calculation
+	  (1 byte, always the value 5);
+      (d1) signature classification (1 byte);
+      (d2) signature time stamp (4 bytes);
+      (e) key ID for key used for singing (8 bytes);
+      (f) public-key-cryptosystem (PKC) type (1 byte);
+      (g) message digest algorithm type (1 byte);
+      (h) first two bytes of the MD output, used as a checksum
+	  (2 bytes);
+      (i) a byte string of encrypted data holding the RSA-signed digest.
+
+   The message digest is taken of the bytes of the file, followed by the
+   bytes of field (d). It was originally intended that the length (c)
+   could vary, but now it seems that it will alwaye remain a constant
+   value of 5, and that is the only value that will be accepted.  Thus,
+   only the fields (d1) and (d2) will be hashed into the signature along
+   with the main message.
+
+
+
+
+
+
+
+
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 13]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+6.2.1 Message-digest-related fields
+
+   The message digest algorithm is specified by the message digest (MD)
+   number of field (g). The following MD numbers are currently defined:
+
+      1 - MD5 (output length 16)
+      42 - RIPE MD 160 (output length 20)
+      255 - experimental
+
+   More MD numbers may be defined in the future.  An implementation need
+   not support every MD number.  The implementor must document the MD
+   numbers understood by an implementation.
+
+   A message digest algorithm reads a byte string of any length, and
+   writes a byte string of some fixed length, as indicated in the table
+   above.
+
+   The input to the message digest algorithm is the concatenation of
+   some "primary input" and some "appended input."
+
+   The appended input is specified by field (c), which gives a number of
+   bytes to be taken from the following fields: (d1), (d2), and so on.
+   The current implementation uses the value 5 for this number, for
+   fields (d1) and (d2).  Any field not included in the appended input
+   is not "signed" by field (i).
+
+   The primary input is determined by the signature classification byte
+   (d1).  Byte (d1) is one of the following hex numbers, with these
+   meanings:
+
+     <00> - document signature, binary image ("I wrote this document")
+     <01> - document signature, canonical text ("I wrote this document")
+     <10> - public key packet and user ID packet, generic certification
+	  ("I think this key was created by this user, but I won't say
+	  how sure I am")
+     <11> - public key packet and user ID packet, persona certification
+	  ("This key was created by someone who has told me that he is
+	  this user") (#)
+     <12> - public key packet and user ID packet, casual certification
+	  ("This key was created by someone who I believe, after casual
+	  verification, to be this user")  (#)
+     <13> - public key packet and user ID packet, positive certification
+	  ("This key was created by someone who I believe, after
+	  heavy-duty identification such as picture ID, to be this
+	  user")  (#)
+     <20> - public key packet, key compromise ("This is my key, and I
+	  have revoked it")
+
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 14]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+     <30> - public key packet and user ID packet, revocation ("I retract
+	  all my previous statements that this key is related to this
+	  user")  (*)
+     <40> - time stamping ("I saw this document") (*)
+
+   More classification numbers may be defined in the future to handle
+   other meanings of signatures, but only the above numbers may be used
+   with version 2 or version 3 of a signature packet.  It should be
+   noted that PGP 2.6.2 has not implemented the packets marked with an
+   asterisk (*), and the packets marked with a hash (#) are not output
+   by PGP 2.6.2.
+
+   Signature packets are used in two different contexts. One (signature
+   type <00> or <01>) is of text (either the contents of a literal
+   packet or a separate file), while types <10> through <1F> appear only
+   in key files, after the keys and user IDs that they sign.  Type <20>
+   appears in key files, after the keys that it signs, and type <30>
+   also appears after a key/userid combination. Type <40> is intended to
+   be a signature of a signature, as a notary seal on a signed document.
+
+   The output of the message digest algorithm is a message digest, or
+   hash code. Field i contains the cyphertext produced by encrypting the
+   message digest with the signer's private key.  Field h contains the
+   first two bytes of the unencrypted message digest. This enables the
+   recipient to determine if the correct public key was used to decrypt
+   the message digest for authentication, by comparing this plaintext
+   copy of the first two byes with the first two bytes of the decrypted
+   digest. These two bytes also serve as a 16-bit frame check sequence
+   for the message.
+
+6.2.2 Public-key-related fields
+
+   The message digest is signed by encrypting it using the writer's
+   private key. Field (e) is the ID of the corresponding public key.
+
+   The public-key-encryption algorithm is specified by the public-key
+   cryptosystem (PKC) number of field (f). The following PKC numbers are
+   currently defined:
+
+      1   - RSA
+      42  - ElGamal
+      255 - experimental
+
+   More PKC numbers may be defined in the future.  An implementation
+   need not support every PKC number.  The implementor must document the
+   PKC numbers understood by an implementation.
+
+
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 15]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+   A PKC number identifies both a public-key encryption method and a
+   signature method.  Both of these methods are fully defined as part of
+   the definition of the PKC number.  Some cryptosystems are usable only
+   for encryption, or only for signatures; if any such PKC numbers are
+   defined in the future, they will be marked appropriately.
+
+6.2.3 RSA signatures
+
+   An RSA-signed byte string is a multiprecision field that is formed by
+   taking the message digest and filling in an ASN structure, and then
+   encrypting the whole byte string in the RSA key of the signer.
+
+   PGP versions 2.3 and later encode the MD into a PKCS-format signature
+   string, which has the following format:
+
+	  MSB		    .	.   .			 LSB
+	  0   1   <FF>(n bytes)   0   ASN(18 bytes)   MD(16 bytes)
+
++ or for RIPE-MD-160
++
++	  MSB		    .	.   .			 LSB
++	  0   42  <FF>(n bytes)   0   ASN(18 bytes)   MD(20 bytes)
++
++ FIXME: figure out the ASN object identifier
+
+   See RFC1423 for an explanation of the meaning of the ASN string.  It
+   is the following 18 byte long hex value:
+
+	  <30 20 30 0C 06 08 2A 86 48 86 F7 0D 02 05 05 00 04 10>
+
+   Enough bytes of <FF> padding are added to make the length of this
+   whole string equal to the number of bytes in the modulus.
+
+6.2.4 Miscellaneous fields
+
+   The timestamp field (d2) is analogous to the date box next to a
+   signature box on a form.  It represents a time which is typically
+   close to the moment that the signature packet was created.  However,
+   this is not a requirement.  Users may choose to date their signatures
+   as they wish, just as they do now in handwritten signatures.
+
+   If an application requires the creation of trusted timestamps on
+   signatures, a detached signature certificate with an untrusted
+   timestamp may be submitted to a trusted timestamp notary service to
+   sign the signature packet with another signature packet, creating a
+   signature of a signature.  The notary's signature's timestamp could
+   be used as the trusted "legal" time of the original signature.
+
+
+
+
+
+
+
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 16]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+6.3 Compressed data packets
+
+   Purpose.  A compressed data packet is an envelope which safely
+   squeezes its contents into a small space.
+
+   Definition.	A compressed data packet is the concatenation of the
+   following fields:
+
+      (a) a packet structure field;
+      (b) a byte, giving a compression type;
+      (c) a byte string of compressed data.
+
+   Byte string (c) is a packet which may be decompressed using the
+   algorithm identified in byte (b).  Typically, the data that are
+   compressed consist of a literal data packet or a signature packet
+   concatenated to a literal data packet.
+
+   A compression type selects a compression algorithm for use in
+   compressed data packets.  The following compression numbers are
+   currently defined.
+
+      1 - ZIP
+      2 - zlib format
+      255 - experimental
+
+   More compression numbers may be defined in the future.  An
+   implementation need not support every MD number.  The implementor
+   must document the compression numbers understood by an
+   implementation.
+
+6.4 Conventional-key-encrypted data packets
+
+   Purpose.  A conventional-key-encrypted data packet is formed by
+   encrypting a block of data with a conventional encryption algorithm
+   using a one-time session key. Typically, the block to be encrypted is
+   a compressed data packet.
+
+   Definition.	A conventional-key-encrypted data packet is the
+   concatenation of the following fields:
+
+      (a) a packet structure field;
+      (b) a byte string of encrypted data.
+
+   The plaintext or compressed plaintext that is encrypted to form field
+   (b) is first prepended with 64 bits of random data plus 16 "key
+   check" bits.  The random prefix serves to start off the cipher
+   feedback chaining process with 64 bits of random material; this
+   serves the same function as an initialization vector (IV) for a
+   cipher-block-chaining encryption scheme.  The key check prefix is
+
+
+
+Atkins, et. al. 	     Informational		       [Page 17]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+   equal to the last 16 bits of the random prefix. During decryption, a
+   comparison is made to see if the 7th and 8th byte of the decrypted
+   material match the 9th and 10th bytes.  If so, then the conventional
+   session key used for decryption is assumed to be correct.
+
+6.4.1 Conventional-encryption type byte
+
+   Purpose.  The conventional-encryption type byte is used to determine
+   what conventional encryption algorithm is in use.  The algorithm type
+   byte will also define how long the conventional encryption key is,
+   based upon the algorithm in use.
+
+   Definition.	A conventional-encryption type byte is a single byte
+   which defines the algorithm in use.	It is possible that the
+   algorithm in use may require further definition, such as key-length.
+   It is up to the implementor to document the supported key-length in
+   such a situation.
+
+      1 - IDEA (16-byte key)
+      42 - Blowfish
+      43 - GOST
+      255 - experimental
+
+6.5 Public-key-encrypted packets
+
+   Purpose.  The public-key-encrypted packet is the format for the
+   session key component of a message. The purpose of this packet is to
+   convey the one-time session key used to encrypt the message to the
+   recipient in a secure manner. This is done by encrypting the session
+   key with the recipient's public key, so that only the recipient can
+   recover the session key.
+
+   Definition.	A public-key-encrypted packet, version 2 or 3, is the
+   concatenation of the following fields:
+
+      (a) a packet structure field;
+      (b) a byte, giving the version number, 2 or 3;
+      (c) a number ID field, giving the ID of a key;
+      (d) a byte, giving a PKC number;
+      (e) a byte string of encrypted data (DEK).
+
+   Byte string (e) represents the value of the session key, encrypted
+   using the reader's public key K, under the cryptosystem identified in
+   byte (d).
+
+   The value of field (c) is the ID of K.
+
+   Note that the packet does not actually identify K: two keys may have
+   the same ID, by chance or by malice.  Normally it will be obvious
+   from the context which key K was used to create the packet.	But
+
+
+
+Atkins, et. al. 	     Informational		       [Page 18]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+   sometimes it is not obvious.  In this case field (c) is useful.  If,
+   for example, a reader has created several keys, and receives a
+   message, then he should attempt to decrypt the message only with the
+   key whose ID matches the value of field (c).  If he has accidentally
+   generated two keys with the same ID, then he must attempt to decrypt
+   the message with both keys, but this case is highly unlikely to occur
+   by chance.
+
+6.5.1 RSA-encrypted data encryption key (DEK)
+
+   The Data Encryption Key (DEK) is a multiprecision field which stores
+   an RSA encrypted byte string.  The byte string is a PKCS encoding of
+   the secret key used the encrypt the message, with random padding for
+   each Public-Key encrypted packet.
+
+   PGP version 2.3 and later encode the DEK into an MPI using the
+   following format:
+
+     MSB		       .   .   .		       LSB
+      0   2   RND(n bytes)   0	ALG(1 byte)  DEK(k bytes)  CSUM(2 bytes)
+
+   ALG refers to the algorithm byte for the secret key algorithm used to
+   encrypt the data packet.  The DEK is the actual Data Encryption Key,
+   and its size is dependent upon the encryption algorithm defined by
+   ALG.  For the IDEA encryption algorithm, type byte 1, the DEK is 16
+   bytes long.	CSUM is a 16-bit checksum of the DEK, used to determine
+   that the correct Private key was used to decrypt this packet.  The
+   checksum is computed by the 16-bit sum of the bytes in the DEK.  RND
+   is random padding to expand the byte to fill the size of the RSA
+   Public Key that is used to encrypt the whole byte.
+
+6.6 Public Key Packet
+
+   Purpose.  A public key packet defines an RSA public key.
+
+   Definition.	A public key packet is the concatenation of the
+   following fields:
+
+      (a) packet structure field (2 or 3 bytes);
+      (b) version number = 2 or 3 (1 byte);;
+      (c) time stamp of key creation (4 bytes);
+      (d) validity period in days (0 means forever) (2 bytes);
+      (e) public-key-cryptosystem (PKC) type (1 byte);
+      (f) MPI of RSA public modulus n;
+      (g) MPI of RSA public encryption exponent e.
+
+    The validity period is always set to 0.
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 19]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+6.7 User ID Packet
+
+   Purpose.  A user ID packet identifies a user and is associated with a
+   public or private key.
+
+   Definition.	A user ID packet is the concatenation of the following
+   fields:
+
+      (a) packet structure field (2 bytes);
+      (b) User ID string.
+
+   The User ID string may be any string of printable ASCII characters.
+   However, since the purpose of this packet is to uniquely identify an
+   individual, the usual practice is for the User ID string to consist
+   of the user's name followed by an e-mail address for that user, the
+   latter enclosed in angle brackets.
+
+7. Transferable Public Keys
+
+   Public keys may transferred between PGP users. The essential elements
+   of a transferable public key are
+
+      (a) One public key packet;
+      (b) One or more user ID packets;
+      (c) Zero or more signature packets
+
+   The public key packet occurs first.	Each of the following user ID
+   packets provides the identity of the owner of this public key.  If
+   there are multiple user ID packets, this corresponds to multiple
+   means of identifying the same unique individual user; for example, a
+   user may enjoy the use of more than one e-mail address, and construct
+   a user ID packet for each one.  Immediately following each user ID
+   packet, there are zero or more signature packets. Each signature
+   packet is calculated on the immediately preceding user ID packet and
+   the initial public key packet.  The signature serves to certify the
+   corresponding public key and user ID.  In effect, the signer is
+   testifying to his or her belief that this public key belongs to the
+   user identified by this user ID.
+
+8. Acknowledgments
+
+   Philip Zimmermann is the creator of PGP 1.0, which is the precursor
+   of PGP 2.x.	Major parts of later versions of PGP have been
+   implemented by an international collaborative effort involving a
+   large number of contributors, under the design guidance of Philip
+   Zimmermann.
+
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 20]
+
+RFC 1991	      PGP Message Exchange Formats	     August 1996
+
+
+9. Security Considerations
+
+   Security issues are discussed throughout this memo.
+
+10. Authors' Addresses
+
+   Derek Atkins
+   12 Rindge Ave. #1R
+   Cambridge, MA
+
+   Phone: +1 617 868-4469
+   EMail: warlord@MIT.EDU
+
+
+   William Stallings
+   Comp-Comm Consulting
+   P. O. Box 2405
+   Brewster, MA 02631
+
+   EMail: stallings@ACM.org
+
+
+   Philip Zimmermann
+   Boulder Software Engineering
+   3021 Eleventh Street
+   Boulder, Colorado 80304  USA
+
+   Phone: +1-303-541-0140
+   EMail: prz@acm.org
+
+
+
+   Werner Koch
+   Werner Koch Softwaresysteme
+   Remscheider Str. 22
+   40215 Dsseldorf
+   Germany
+
+   Phone: +49 211 3180023
+   EMail: werner.koch@guug.de
+
+
+
+
+
+
+
+
+
+
+
+
+
+Atkins, et. al. 	     Informational		       [Page 21]
+
diff -urN g10-0.2.5/doc/rfc2015 g10-0.2.6/doc/rfc2015
--- g10-0.2.5/doc/rfc2015	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/doc/rfc2015	Thu Feb 12 21:46:24 1998
@@ -0,0 +1,451 @@
+
+
+
+
+
+
+Network Working Group					       M. Elkins
+Request for Comments: 2015		       The Aerospace Corporation
+Category: Standards Track				    October 1996
+
+
+	      MIME Security with Pretty Good Privacy (PGP)
+
+Status of this Memo
+
+   This document specifies an Internet standards track protocol for the
+   Internet community, and requests discussion and suggestions for
+   improvements.  Please refer to the current edition of the "Internet
+   Official Protocol Standards" (STD 1) for the standardization state
+   and status of this protocol.  Distribution of this memo is unlimited.
+
+Abstract
+
+   This document describes how Pretty Good Privacy (PGP) can be used to
+   provide privacy and authentication using the Multipurpose Internet
+   Mail Extensions (MIME) security content types described in RFC1847.
+
+1.  Introduction
+
+   Previous work on integrating PGP with MIME (including the since
+   withdrawn application/pgp content type) has suffered from a number of
+   problems, the most significant of which is the inability to recover
+   signed message bodies without parsing data structures specific to
+   PGP.  This work makes use of the elegant solution proposed in
+   RFC1847, which defines security multipart formats for MIME. The
+   security multiparts clearly separate the signed message body from the
+   signature, and have a number of other desirable properties. This
+   document is styled after RFC 1848, which defines MIME Object Security
+   Services (MOSS) for providing security and authentication.
+
+   This document defines three new content types for implementing
+   security and privacy with PGP: application/pgp-encrypted,
+   application/pgp-signature and application/pgp-keys.
+
+1.1  Compliance
+
+   In order for an implementation to be compliant with this
+   specification, is it absolutely necessary for it to obey all items
+   labeled as MUST or REQUIRED.
+
+
+
+
+
+
+
+
+Elkins			    Standards Track			[Page 1]
+
+RFC 2015		 MIME Security with PGP 	    October 1996
+
+
+2.  PGP data formats
+
+   PGP can generate either ASCII armor (described in [3]) or 8-bit
+   binary output when encrypting data, generating a digital signature,
+   or extracting public key data.  The ASCII armor output is the
+   REQUIRED method for data transfer.  This allows those users who do
+   not have the means to interpret the formats described in this
+   document to be able extract and use the PGP information in the
+   message.
+
+   When the amount of data to be transmitted requires that it be sent in
+   many parts, the MIME message/partial mechanism should be used rather
+   than the multipart ASCII armor PGP format.
+
+3.  Content-Transfer-Encoding restrictions
+
+   Multipart/signed and multipart/encrypted are to be treated by agents
+   as opaque, meaning that the data is not to be altered in any way [1].
+   However, many existing mail gateways will detect if the next hop does
+   not support MIME or 8-bit data and perform conversion to either
+   Quoted-Printable or Base64.	This presents serious problems for
+   multipart/signed, in particular, where the signature is invalidated
+   when such an operation occurs.  For this reason all data signed
+   according to this protocol MUST be constrained to 7 bits (8- bit data
+   should be encoded using either Quoted-Printable or Base64).	Note
+   that this also includes the case where a signed object is also
+   encrypted (see section 6).  This restriction will increase the
+   likelihood that the signature will be valid upon receipt.
+
+   Data that is ONLY to be encrypted is allowed to contain 8-bit
+   characters and therefore need not be converted to a 7-bit format.
+
+     Implementor's note: It cannot be stressed enough that applications
+     using this standard should follow MIME's suggestion that you "be
+     conservative in what you generate, and liberal in what you accept."
+     In this particular case it means it would be wise for an
+     implementation to accept messages with any content-transfer-
+     encoding, but restrict generation to the 7-bit format required by
+     this memo.  This will allow future compatibility in the event the
+     Internet SMTP framework becomes 8-bit friendly.
+
+4.  PGP encrypted data
+
+   Before encryption with PGP, the data should be written in MIME
+   canonical format (body and headers).
+
+   PGP encrypted data is denoted by the "multipart/encrypted" content
+   type, described in [1], and MUST have a "protocol" parameter value of
+
+
+
+Elkins			    Standards Track			[Page 2]
+
+RFC 2015		 MIME Security with PGP 	    October 1996
+
+
+   "application/pgp-encrypted".  Note that the value of the parameter
+   MUST be enclosed in quotes.
+
+   The multipart/encrypted MUST consist of exactly two parts.  The first
+   MIME body part must have a content type of "application/pgp-
+   encrypted".  This body contains the control information.  A message
+   complying with this standard MUST contain a "Version: 1" field in
+   this body.  Since the PGP packet format contains all other
+   information necessary for decrypting, no other information is
+   required here.
+
+   The second MIME body part MUST contain the actual encrypted data.  It
+   must be labeled with a content type of "application/octet- stream".
+
+   Example message:
+
+     From: Michael Elkins <elkins@aero.org>
+     To: Michael Elkins <elkins@aero.org>
+     Mime-Version: 1.0
+     Content-Type: multipart/encrypted; boundary=foo;
+	protocol="application/pgp-encrypted"
+
+     --foo
+     Content-Type: application/pgp-encrypted
+
+     Version: 1
+
+     --foo
+     Content-Type: application/octet-stream
+
+     -----BEGIN PGP MESSAGE-----
+     Version: 2.6.2
+
+     hIwDY32hYGCE8MkBA/wOu7d45aUxF4Q0RKJprD3v5Z9K1YcRJ2fve87lMlDlx4Oj
+     eW4GDdBfLbJE7VUpp13N19GL8e/AqbyyjHH4aS0YoTk10QQ9nnRvjY8nZL3MPXSZ
+     g9VGQxFeGqzykzmykU6A26MSMexR4ApeeON6xzZWfo+0yOqAq6lb46wsvldZ96YA
+     AABH78hyX7YX4uT1tNCWEIIBoqqvCeIMpp7UQ2IzBrXg6GtukS8NxbukLeamqVW3
+     1yt21DYOjuLzcMNe/JNsD9vDVCvOOG3OCi8=
+     =zzaA
+     -----END PGP MESSAGE-----
+
+     --foo--
+
+5.  PGP signed data
+
+   PGP signed messages are denoted by the "multipart/signed" content
+   type, described in [1], with a "protocol" parameter which MUST have a
+   value of "application/pgp-signature" (MUST be quoted).  The "micalg"
+
+
+
+Elkins			    Standards Track			[Page 3]
+
+RFC 2015		 MIME Security with PGP 	    October 1996
+
+
+   parameter MUST have a value of "pgp-<hash-symbol>", where <hash-
+   symbol> identifies the message integrity check (MIC) used to generate
+   the signature.  The currently defined values for <hash-symbol> are
+   "md5" for the MD5 checksum, and "sha1" for the SHA.1 algorithm.
+
+   The multipart/signed body MUST consist of exactly two parts.  The
+   first part contains the signed data in MIME canonical format,
+   including a set of appropriate content headers describing the data.
+
+   The second body MUST contain the PGP digital signature.  It MUST be
+   labeled with a content type of "application/pgp-signature".
+
+   When the PGP digital signature is generated:
+
+   (1)	The data to be signed must first be converted to its
+	type/subtype specific canonical form.  For text/plain, this
+	means conversion to an appropriate character set and conversion
+	of line endings to the canonical <CR><LF> sequence.
+
+   (2)	An appropriate Content-Transfer-Encoding is then applied. Each
+	line of the encoded data MUST end with the canonical <CR><LF>
+	sequence.
+
+   (3)	MIME content headers are then added to the body, each ending
+	with the canonical <CR><LF> sequence.
+
+   (4)	As described in [1], the digital signature MUST be calculated
+	over both the data to be signed and its set of content headers.
+
+   (5)	The signature MUST be generated detached from the signed data
+	so that the process does not alter the signed data in any way.
+
+   Example message:
+
+     From: Michael Elkins <elkins@aero.org>
+     To: Michael Elkins <elkins@aero.org>
+     Mime-Version: 1.0
+     Content-Type: multipart/signed; boundary=bar; micalg=pgp-md5;
+     protocol="application/pgp-signature"
+
+     --bar
+     & Content-Type: text/plain; charset=iso-8859-1
+     & Content-Transfer-Encoding: quoted-printable
+     &
+     & =A1Hola!
+     &
+     & Did you know that talking to yourself is a sign of senility?
+     &
+
+
+
+Elkins			    Standards Track			[Page 4]
+
+RFC 2015		 MIME Security with PGP 	    October 1996
+
+
+     & It's generally a good idea to encode lines that begin with
+     & From=20because some mail transport agents will insert a greater-
+     & than (>) sign, thus invalidating the signature.
+     &
+     & Also, in some cases it might be desirable to encode any	 =20
+     &railing whitespace that occurs on lines in order to ensure  =20
+     & that the message signature is not invalidated when passing =20
+     & a gateway that modifies such whitespace (like BITNET). =20
+     &
+     & me
+
+     --bar
+     Content-Type: application/pgp-signature
+
+    -----BEGIN PGP MESSAGE-----
+   Version: 2.6.2
+
+   iQCVAwUBMJrRF2N9oWBghPDJAQE9UQQAtl7LuRVndBjrk4EqYBIb3h5QXIX/LC//
+   jJV5bNvkZIGPIcEmI5iFd9boEgvpirHtIREEqLQRkYNoBActFBZmh9GC3C041WGq
+   uMbrbxc+nIs1TIKlA08rVi9ig/2Yh7LFrK5Ein57U/W72vgSxLhe/zhdfolT9Brn
+   HOxEa44b+EI=
+   =ndaj
+   -----END PGP MESSAGE-----
+
+   --bar--
+
+   The "&"s in the previous example indicate the portion of the data
+   over which the signature was calculated.
+
+   Though not required, it is generally a good idea to use Quoted-
+   Printable encoding in the first step (writing out the data to be
+   signed in MIME canonical format) if any of the lines in the data
+   begin with "From ", and encode the "F".  This will avoid an MTA
+   inserting a ">" in front of the line, thus invalidating the
+   signature!
+
+   Upon receipt of a signed message, an application MUST:
+
+   (1)	Convert line endings to the canonical <CR><LF> sequence before
+	the signature can be verified.	This is necessary since the
+	local MTA may have converted to a local end of line convention.
+
+   (2)	Pass both the signed data and its associated content headers
+	along with the PGP signature to the signature verification
+	service.
+
+
+
+
+
+
+Elkins			    Standards Track			[Page 5]
+
+RFC 2015		 MIME Security with PGP 	    October 1996
+
+
+6.  Encrypted and Signed Data
+
+   Sometimes it is desirable to both digitally sign and then encrypt a
+   message to be sent.	This protocol allows for two methods of
+   accomplishing this task.
+
+6.1  RFC1847 Encapsulation
+
+   [1], it is stated that the data should first be signed as a
+   multipart/signature body, and then encrypted to form the final
+   multipart/encrypted body, i.e.,
+
+    Content-Type: multipart/encrypted;
+       protocol="application/pgp-encrypted"; boundary=foo
+
+    --foo
+    Content-Type: application/pgp-encrypted
+
+    Version: 1
+
+    --foo
+    Content-Type: application/octet-stream
+
+    -----BEGIN PGP MESSAGE-----
+    & Content-Type: multipart/signed; micalg=pgp-md5
+    &	  protocol="application/pgp-signature"; boundary=bar
+    &
+    & --bar
+    & Content-Type: text/plain; charset=us-ascii
+    &
+    & This message was first signed, and then encrypted.
+    &
+    & --bar
+    & Content-Type: application/pgp-signature
+    &
+    & -----BEGIN PGP MESSAGE-----
+    & Version: 2.6.2
+    &
+    & iQCVAwUBMJrRF2N9oWBghPDJAQE9UQQAtl7LuRVndBjrk4EqYBIb3h5QXIX/LC//
+    & jJV5bNvkZIGPIcEmI5iFd9boEgvpirHtIREEqLQRkYNoBActFBZmh9GC3C041WGq
+    & uMbrbxc+nIs1TIKlA08rVi9ig/2Yh7LFrK5Ein57U/W72vgSxLhe/zhdfolT9Brn
+    & HOxEa44b+EI=
+    & =ndaj
+    & -----END PGP MESSAGE-----
+    &
+    & --bar--
+    -----END PGP MESSAGE-----
+
+
+
+
+Elkins			    Standards Track			[Page 6]
+
+RFC 2015		 MIME Security with PGP 	    October 1996
+
+
+    --foo--
+
+    (The text preceded by '&' indicates that it is really
+    encrypted, but presented as text for clarity.)
+
+6.2  Combined method
+
+   Versions 2.x of PGP also allow data to be signed and encrypted in one
+   operation.  This method is an acceptable shortcut, and has the
+   benefit of less overhead.  The resulting data should be formed as a
+   "multipart/encrypted" object as described above.
+
+   Messages which are encrypted and signed in this combined fashion are
+   REQUIRED to follow the same canonicalization rules as for
+   multipart/signed objects.
+
+   It is explicitly allowed for an agent to decrypt a combined message
+   and rewrite it as a multipart/signed object using the signature data
+   embedded in the encrypted version.
+
+7.  Distribution of PGP public keys
+
+   Content-Type: application/pgp-keys
+   Required parameters: none
+   Optional parameters: none
+
+   This is the content type which should be used for relaying public key
+   blocks.
+
+8.  Notes
+
+   PGP and Pretty Good Privacy are trademarks of Philip Zimmermann.
+
+9.  Security Considerations
+
+   Use of this protocol has the same security considerations as PGP, and
+   is not known to either increase or decrease the security of messages
+   using it; see [3] for more information.
+
+10.  Author's Address
+
+	Michael Elkins
+	P.O. Box 92957 - M1/102
+	Los Angeles, CA 90009-2957
+
+	Phone: +1 310 336 8040
+	Fax: +1 310 336 4402
+
+
+
+
+Elkins			    Standards Track			[Page 7]
+
+RFC 2015		 MIME Security with PGP 	    October 1996
+
+
+References
+
+   [1]	Galvin, J., Murphy, G., Crocker, S., and N. Freed, "Security
+	Multiparts for MIME: Multipart/Signed and Multipart/Encrypted",
+	RFC 1847, October 1995.
+
+   [2]	Galvin, J., Murphy, G., Crocker, S., and N. Freed, "MIME Object
+	Security Services", RFC 1848, October 1995.
+
+   [3]	Atkins, D., Stallings, W., and P. Zimmermann, "PGP Message
+	Exchange Formats", RFC 1991, August 1996.
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+Elkins			    Standards Track			[Page 8]
+
diff -urN g10-0.2.5/doc/rfc2144 g10-0.2.6/doc/rfc2144
--- g10-0.2.5/doc/rfc2144	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/doc/rfc2144	Thu Feb 12 21:37:59 1998
@@ -0,0 +1,843 @@
+
+
+
+
+
+
+Network Working Group					      C. Adams
+Request for Comments: 2144			  Entrust Technologies
+Category: Informational 				      May 1997
+
+
+		   The CAST-128 Encryption Algorithm
+
+Status of this Memo
+
+   This memo provides information for the Internet community.  This memo
+   does not specify an Internet standard of any kind.  Distribution of
+   this memo is unlimited.
+
+Abstract
+
+   There is a need in the Internet community for an unencumbered
+   encryption algorithm with a range of key sizes that can provide
+   security for a variety of cryptographic applications and protocols.
+
+   This document describes an existing algorithm that can be used to
+   satisfy this requirement.  Included are a description of the cipher
+   and the key scheduling algorithm (Section 2), the s-boxes (Appendix
+   A), and a set of test vectors (Appendix B).
+
+TABLE OF CONTENTS
+
+   STATUS OF THIS MEMO.............................................1
+   ABSTRACT........................................................1
+   1. INTRODUCTION.................................................1
+   2. DESCRIPTION OF ALGORITHM.....................................2
+   3. INTELLECTUAL PROPERTY CONSIDERATIONS.........................8
+   4. SECURITY CONSIDERATIONS......................................8
+   5. REFERENCES...................................................8
+   6. AUTHOR'S ADDRESS.............................................8
+   APPENDICES
+   A. S-BOXES......................................................9
+   B. TEST VECTORS................................................15
+
+1. Introduction
+
+   This document describes the CAST-128 encryption algorithm, a DES-like
+   Substitution-Permutation Network (SPN) cryptosystem which appears to
+   have good resistance to differential cryptanalysis, linear
+   cryptanalysis, and related-key cryptanalysis.  This cipher also
+   possesses a number of other desirable cryptographic properties,
+   including avalanche, Strict Avalanche Criterion (SAC), Bit
+   Independence Criterion (BIC), no complementation property, and an
+   absence of weak and semi-weak keys.	It thus appears to be a good
+
+
+
+Adams			     Informational			[Page 1]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+   candidate for general-purpose use throughout the Internet community
+   wherever a cryptographically-strong, freely-available encryption
+   algorithm is required.
+
+   Adams [Adams] discusses the CAST design procedure in some detail;
+   analyses can also be obtained on-line (see, for example, [Web1] or
+   [Web2]).
+
+2. Description of Algorithm
+
+   CAST-128 belongs to the class of encryption algorithms known as
+   Feistel ciphers; overall operation is thus similar to the Data
+   Encryption Standard (DES).  The full encryption algorithm is given in
+   the following four steps.
+
+   INPUT:  plaintext m1...m64; key K = k1...k128.
+   OUTPUT: ciphertext c1...c64.
+
+   1. (key schedule) Compute 16 pairs of subkeys {Kmi, Kri} from K
+      (see Sections 2.1 and 2.4).
+   2. (L0,R0) <-- (m1...m64).  (Split the plaintext into left and
+      right 32-bit halves L0 = m1...m32 and R0 = m33...m64.)
+   3. (16 rounds) for i from 1 to 16, compute Li and Ri as follows:
+      Li = Ri-1;
+      Ri = Li-1 ^ f(Ri-1,Kmi,Kri), where f is defined in Section 2.2
+       (f is of Type 1, Type 2, or Type 3, depending on i).
+   4. c1...c64 <-- (R16,L16).  (Exchange final blocks L16, R16 and
+      concatenate to form the ciphertext.)
+
+   Decryption is identical to the encryption algorithm given above,
+   except that the rounds (and therefore the subkey pairs) are used in
+   reverse order to compute (L0,R0) from (R16,L16).
+
+   See Appendix B for test vectors which can be used to verify
+   correctness of an implementation of this algorithm.
+
+2.1. Pairs of Round Keys
+
+   CAST-128 uses a pair of subkeys per round:  a 32-bit quantity Km is
+   used as a "masking" key and a 5-bit quantity Kr is used as a
+   "rotation" key.
+
+
+
+
+
+
+
+
+
+
+Adams			     Informational			[Page 2]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+2.2. Non-Identical Rounds
+
+   Three different round functions are used in CAST-128.  The rounds are
+   as follows (where "D" is the data input to the f function and "Ia" -
+   "Id" are the most significant byte through least significant byte of
+   I, respectively).  Note that "+" and "-" are addition and subtraction
+   modulo 2**32, "^" is bitwise XOR, and "<<<" is the circular left-
+   shift operation.
+
+       Type 1:	I = ((Kmi + D) <<< Kri)
+		f = ((S1[Ia] ^ S2[Ib]) - S3[Ic]) + S4[Id]
+
+       Type 2:	I = ((Kmi ^ D) <<< Kri)
+		f = ((S1[Ia] - S2[Ib]) + S3[Ic]) ^ S4[Id]
+
+       Type 3:	I = ((Kmi - D) <<< Kri)
+		f = ((S1[Ia] + S2[Ib]) ^ S3[Ic]) - S4[Id]
+
+   Rounds 1, 4, 7, 10, 13, and 16 use f function Type 1.
+   Rounds 2, 5, 8, 11, and 14 use f function Type 2.
+   Rounds 3, 6, 9, 12, and 15 use f function Type 3.
+
+
+2.3. Substitution Boxes
+
+   CAST-128 uses eight substitution boxes:  s-boxes S1, S2, S3, and S4
+   are round function s-boxes; S5, S6, S7, and S8 are key schedule s-
+   boxes.  Although 8 s-boxes require a total of 8 KBytes of storage,
+   note that only 4 KBytes are required during actual encryption /
+   decryption since subkey generation is typically done prior to any
+   data input.
+
+   See Appendix A for the contents of s-boxes S1 - S8.
+
+2.4. Key Schedule
+
+   Let the 128-bit key be x0x1x2x3x4x5x6x7x8x9xAxBxCxDxExF, where x0
+   represents the most significant byte and xF represents the least
+   significant byte.
+
+   Let z0..zF be intermediate (temporary) bytes.
+   Let Si[] represent s-box i and let "^" represent XOR addition.
+
+
+
+
+
+
+
+
+
+Adams			     Informational			[Page 3]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+   The subkeys are formed from the key x0x1x2x3x4x5x6x7x8x9xAxBxCxDxExF
+   as follows.
+
+   z0z1z2z3 = x0x1x2x3 ^ S5[xD] ^ S6[xF] ^ S7[xC] ^ S8[xE] ^ S7[x8]
+   z4z5z6z7 = x8x9xAxB ^ S5[z0] ^ S6[z2] ^ S7[z1] ^ S8[z3] ^ S8[xA]
+   z8z9zAzB = xCxDxExF ^ S5[z7] ^ S6[z6] ^ S7[z5] ^ S8[z4] ^ S5[x9]
+   zCzDzEzF = x4x5x6x7 ^ S5[zA] ^ S6[z9] ^ S7[zB] ^ S8[z8] ^ S6[xB]
+   K1  = S5[z8] ^ S6[z9] ^ S7[z7] ^ S8[z6] ^ S5[z2]
+   K2  = S5[zA] ^ S6[zB] ^ S7[z5] ^ S8[z4] ^ S6[z6]
+   K3  = S5[zC] ^ S6[zD] ^ S7[z3] ^ S8[z2] ^ S7[z9]
+   K4  = S5[zE] ^ S6[zF] ^ S7[z1] ^ S8[z0] ^ S8[zC]
+   x0x1x2x3 = z8z9zAzB ^ S5[z5] ^ S6[z7] ^ S7[z4] ^ S8[z6] ^ S7[z0]
+   x4x5x6x7 = z0z1z2z3 ^ S5[x0] ^ S6[x2] ^ S7[x1] ^ S8[x3] ^ S8[z2]
+   x8x9xAxB = z4z5z6z7 ^ S5[x7] ^ S6[x6] ^ S7[x5] ^ S8[x4] ^ S5[z1]
+   xCxDxExF = zCzDzEzF ^ S5[xA] ^ S6[x9] ^ S7[xB] ^ S8[x8] ^ S6[z3]
+   K5  = S5[x3] ^ S6[x2] ^ S7[xC] ^ S8[xD] ^ S5[x8]
+   K6  = S5[x1] ^ S6[x0] ^ S7[xE] ^ S8[xF] ^ S6[xD]
+   K7  = S5[x7] ^ S6[x6] ^ S7[x8] ^ S8[x9] ^ S7[x3]
+   K8  = S5[x5] ^ S6[x4] ^ S7[xA] ^ S8[xB] ^ S8[x7]
+   z0z1z2z3 = x0x1x2x3 ^ S5[xD] ^ S6[xF] ^ S7[xC] ^ S8[xE] ^ S7[x8]
+   z4z5z6z7 = x8x9xAxB ^ S5[z0] ^ S6[z2] ^ S7[z1] ^ S8[z3] ^ S8[xA]
+   z8z9zAzB = xCxDxExF ^ S5[z7] ^ S6[z6] ^ S7[z5] ^ S8[z4] ^ S5[x9]
+   zCzDzEzF = x4x5x6x7 ^ S5[zA] ^ S6[z9] ^ S7[zB] ^ S8[z8] ^ S6[xB]
+   K9  = S5[z3] ^ S6[z2] ^ S7[zC] ^ S8[zD] ^ S5[z9]
+   K10 = S5[z1] ^ S6[z0] ^ S7[zE] ^ S8[zF] ^ S6[zC]
+   K11 = S5[z7] ^ S6[z6] ^ S7[z8] ^ S8[z9] ^ S7[z2]
+   K12 = S5[z5] ^ S6[z4] ^ S7[zA] ^ S8[zB] ^ S8[z6]
+   x0x1x2x3 = z8z9zAzB ^ S5[z5] ^ S6[z7] ^ S7[z4] ^ S8[z6] ^ S7[z0]
+   x4x5x6x7 = z0z1z2z3 ^ S5[x0] ^ S6[x2] ^ S7[x1] ^ S8[x3] ^ S8[z2]
+   x8x9xAxB = z4z5z6z7 ^ S5[x7] ^ S6[x6] ^ S7[x5] ^ S8[x4] ^ S5[z1]
+   xCxDxExF = zCzDzEzF ^ S5[xA] ^ S6[x9] ^ S7[xB] ^ S8[x8] ^ S6[z3]
+   K13 = S5[x8] ^ S6[x9] ^ S7[x7] ^ S8[x6] ^ S5[x3]
+   K14 = S5[xA] ^ S6[xB] ^ S7[x5] ^ S8[x4] ^ S6[x7]
+   K15 = S5[xC] ^ S6[xD] ^ S7[x3] ^ S8[x2] ^ S7[x8]
+   K16 = S5[xE] ^ S6[xF] ^ S7[x1] ^ S8[x0] ^ S8[xD]
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+Adams			     Informational			[Page 4]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+   [The remaining half is identical to what is given above, carrying on
+   from the last created x0..xF to generate keys K17 - K32.]
+
+   z0z1z2z3 = x0x1x2x3 ^ S5[xD] ^ S6[xF] ^ S7[xC] ^ S8[xE] ^ S7[x8]
+   z4z5z6z7 = x8x9xAxB ^ S5[z0] ^ S6[z2] ^ S7[z1] ^ S8[z3] ^ S8[xA]
+   z8z9zAzB = xCxDxExF ^ S5[z7] ^ S6[z6] ^ S7[z5] ^ S8[z4] ^ S5[x9]
+   zCzDzEzF = x4x5x6x7 ^ S5[zA] ^ S6[z9] ^ S7[zB] ^ S8[z8] ^ S6[xB]
+   K17 = S5[z8] ^ S6[z9] ^ S7[z7] ^ S8[z6] ^ S5[z2]
+   K18 = S5[zA] ^ S6[zB] ^ S7[z5] ^ S8[z4] ^ S6[z6]
+   K19 = S5[zC] ^ S6[zD] ^ S7[z3] ^ S8[z2] ^ S7[z9]
+   K20 = S5[zE] ^ S6[zF] ^ S7[z1] ^ S8[z0] ^ S8[zC]
+   x0x1x2x3 = z8z9zAzB ^ S5[z5] ^ S6[z7] ^ S7[z4] ^ S8[z6] ^ S7[z0]
+   x4x5x6x7 = z0z1z2z3 ^ S5[x0] ^ S6[x2] ^ S7[x1] ^ S8[x3] ^ S8[z2]
+   x8x9xAxB = z4z5z6z7 ^ S5[x7] ^ S6[x6] ^ S7[x5] ^ S8[x4] ^ S5[z1]
+   xCxDxExF = zCzDzEzF ^ S5[xA] ^ S6[x9] ^ S7[xB] ^ S8[x8] ^ S6[z3]
+   K21 = S5[x3] ^ S6[x2] ^ S7[xC] ^ S8[xD] ^ S5[x8]
+   K22 = S5[x1] ^ S6[x0] ^ S7[xE] ^ S8[xF] ^ S6[xD]
+   K23 = S5[x7] ^ S6[x6] ^ S7[x8] ^ S8[x9] ^ S7[x3]
+   K24 = S5[x5] ^ S6[x4] ^ S7[xA] ^ S8[xB] ^ S8[x7]
+   z0z1z2z3 = x0x1x2x3 ^ S5[xD] ^ S6[xF] ^ S7[xC] ^ S8[xE] ^ S7[x8]
+   z4z5z6z7 = x8x9xAxB ^ S5[z0] ^ S6[z2] ^ S7[z1] ^ S8[z3] ^ S8[xA]
+   z8z9zAzB = xCxDxExF ^ S5[z7] ^ S6[z6] ^ S7[z5] ^ S8[z4] ^ S5[x9]
+   zCzDzEzF = x4x5x6x7 ^ S5[zA] ^ S6[z9] ^ S7[zB] ^ S8[z8] ^ S6[xB]
+   K25 = S5[z3] ^ S6[z2] ^ S7[zC] ^ S8[zD] ^ S5[z9]
+   K26 = S5[z1] ^ S6[z0] ^ S7[zE] ^ S8[zF] ^ S6[zC]
+   K27 = S5[z7] ^ S6[z6] ^ S7[z8] ^ S8[z9] ^ S7[z2]
+   K28 = S5[z5] ^ S6[z4] ^ S7[zA] ^ S8[zB] ^ S8[z6]
+   x0x1x2x3 = z8z9zAzB ^ S5[z5] ^ S6[z7] ^ S7[z4] ^ S8[z6] ^ S7[z0]
+   x4x5x6x7 = z0z1z2z3 ^ S5[x0] ^ S6[x2] ^ S7[x1] ^ S8[x3] ^ S8[z2]
+   x8x9xAxB = z4z5z6z7 ^ S5[x7] ^ S6[x6] ^ S7[x5] ^ S8[x4] ^ S5[z1]
+   xCxDxExF = zCzDzEzF ^ S5[xA] ^ S6[x9] ^ S7[xB] ^ S8[x8] ^ S6[z3]
+   K29 = S5[x8] ^ S6[x9] ^ S7[x7] ^ S8[x6] ^ S5[x3]
+   K30 = S5[xA] ^ S6[xB] ^ S7[x5] ^ S8[x4] ^ S6[x7]
+   K31 = S5[xC] ^ S6[xD] ^ S7[x3] ^ S8[x2] ^ S7[x8]
+   K32 = S5[xE] ^ S6[xF] ^ S7[x1] ^ S8[x0] ^ S8[xD]
+
+2.4.1. Masking Subkeys And Rotate Subkeys
+
+   Let Km1, ..., Km16 be 32-bit masking subkeys (one per round).
+   Let Kr1,    , Kr16 be 32-bit rotate subkeys (one per round); only the
+   least significant 5 bits are used in each round.
+
+   for (i=1; i<=16; i++)  { Kmi = Ki;  Kri = K16+i; }
+
+
+
+
+
+
+
+
+Adams			     Informational			[Page 5]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+2.5. Variable Keysize
+
+   The CAST-128 encryption algorithm has been designed to allow a key
+   size that can vary from 40 bits to 128 bits, in 8-bit increments
+   (that is, the allowable key sizes are 40, 48, 56, 64, ..., 112, 120,
+   and 128 bits.  For variable keysize operation, the specification is
+   as follows:
+
+   1) For key sizes up to and including 80 bits (i.e., 40, 48, 56, 64,
+      72, and 80 bits), the algorithm is exactly as specified but uses
+      12 rounds instead of 16;
+
+   2) For key sizes greater than 80 bits, the algorithm uses the full 16
+      rounds;
+
+   3) For key sizes less than 128 bits, the key is padded with zero
+      bytes (in the rightmost, or least significant, positions) out to
+      128 bits (since the CAST-128 key schedule assumes an input key of
+      128 bits).
+
+   Note that although CAST-128 can support all 12 key sizes listed
+   above, 40 bits, 64 bits, 80 bits, and 128 bits are the sizes that
+   find utility in typical environments.  Therefore, it will likely be
+   sufficient for most implementations to support some subset of only
+   these four sizes.
+
+   In order to avoid confusion when variable keysize operation is used,
+   the name CAST-128 is to be considered synonymous with the name CAST5;
+   this allows a keysize to be appended without ambiguity.  Thus, for
+   example, CAST-128 with a 40-bit key is to be referred to as CAST5-40;
+   where a 128-bit key is explicitly intended, the name CAST5-128 should
+   be used.
+
+2.6. CAST5 Object Identifiers
+
+   For those who may be using CAST in algorithm negotiation within a
+   protocol, or in any other context which may require the use of OBJECT
+   IDENTIFIERs, the following OIDs have been defined.
+
+algorithms OBJECT IDENTIFIER ::=
+   { iso(1) memberBody(2) usa(840) nt(113533) nsn(7) algorithms(66) }
+
+
+
+
+
+
+
+
+
+
+Adams			     Informational			[Page 6]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+cast5CBC OBJECT IDENTIFIER ::= { algorithms cast5CBC(10) }
+
+    Parameters ::= SEQUENCE {
+	iv	   OCTET STRING DEFAULT 0,  -- Initialization vector
+	keyLength  INTEGER		    -- Key length, in bits
+    }
+
+    Note: The iv is optional and defaults to all-zero. On the encoding
+	  end, if an all-zero iv is used, then it should absent from
+	  the Parameters. On the decoding end, an absent iv should be
+	  interpreted as meaning all-zeros.
+
+    This is encryption and decryption in CBC mode using the CAST-128
+    symmetric block cipher algorithm.
+
+
+cast5MAC OBJECT IDENTIFIER ::= { algorithms cast5MAC(11) }
+
+    Parameters ::= SEQUENCE {
+	macLength  INTEGER,	  -- MAC length, in bits
+	keyLength  INTEGER	  -- Key length, in bits
+    }
+
+    This is message authentication using the CAST-128 symmetric block
+    cipher algorithm.
+
+
+pbeWithMD5AndCast5CBC OBJECT IDENTIFIER ::=
+    { algorithms pbeWithMD5AndCAST5-CBC(12) }
+
+    Parameters ::= SEQUENCE {
+	salt		OCTET STRING,
+	iterationCount	INTEGER,      -- Total number of hash iterations
+	keyLength	INTEGER       -- Key length, in bits
+    }
+
+    Note: The IV is derived from the hashing procedure and therefore
+	  need not be included in Parameters.
+
+    This is password-based encryption and decryption in CBC mode
+    using MD5 and the CAST-128 symmetric block cipher .   See PKCS #5
+    (which uses the DES cipher) for details of the PBE computation.
+
+
+
+
+
+
+
+
+
+Adams			     Informational			[Page 7]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+2.7. Discussion
+
+   CAST-128 is a 12- or 16-round Feistel cipher that has a blocksize of
+   64 bits and a keysize of up to 128 bits; it uses rotation to provide
+   intrinsic immunity to linear and differential attacks; it uses a
+   mixture of XOR, addition and subtraction (modulo 2**32) in the round
+   function; and it uses three variations of the round function itself
+   throughout the cipher.  Finally, the 8x32 s-boxes used in the round
+   function each have a minimum nonlinearity of 74 and a maximum entry
+   of 2 in the difference distribution table.
+
+   This cipher appears to have cryptographic strength in accordance with
+   its keysize (128 bits) and has very good encryption / decryption
+   performance:  3.3 MBytes/sec on a 150 MHz Pentium processor.
+
+3. Intellectual Property Considerations
+
+   The CAST-128 cipher described in this document is available worldwide
+   on a royalty-free basis for commercial and non-commercial uses.
+
+4. Security Considerations
+
+   This entire memo is about security since it describes an algorithm
+   which is specifically intended for cryptographic purposes.
+
+5. References
+
+   [Adams] Adams, C., "Constructing Symmetric Ciphers using the CAST
+   Design Procedure", Designs, Codes, and Cryptography (to appear).
+
+   [Web1] "Constructing Symmetric Ciphers using the CAST Design
+   Procedure" (identical to [Adams] but available on-line) and "CAST
+   Design Procedure Addendum", http://www.entrust.com/library.htm.
+
+   [Web2] "CAST Encryption Algorithm Related Publications",
+   http://adonis.ee.queensu.ca:8000/cast/cast.html.
+
+6. Author's Address
+
+   Carlisle Adams
+   Entrust Technologies
+   750 Heron Road,
+   Ottawa, Canada, K1V 1A7
+
+   E-mail: cadams@entrust.com
+   Phone:  +1.613.763.9008
+
+
+
+
+
+Adams			     Informational			[Page 8]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+Appendix A. S-Boxes
+
+S-Box S1
+30fb40d4 9fa0ff0b 6beccd2f 3f258c7a 1e213f2f 9c004dd3 6003e540 cf9fc949
+bfd4af27 88bbbdb5 e2034090 98d09675 6e63a0e0 15c361d2 c2e7661d 22d4ff8e
+28683b6f c07fd059 ff2379c8 775f50e2 43c340d3 df2f8656 887ca41a a2d2bd2d
+a1c9e0d6 346c4819 61b76d87 22540f2f 2abe32e1 aa54166b 22568e3a a2d341d0
+66db40c8 a784392f 004dff2f 2db9d2de 97943fac 4a97c1d8 527644b7 b5f437a7
+b82cbaef d751d159 6ff7f0ed 5a097a1f 827b68d0 90ecf52e 22b0c054 bc8e5935
+4b6d2f7f 50bb64a2 d2664910 bee5812d b7332290 e93b159f b48ee411 4bff345d
+fd45c240 ad31973f c4f6d02e 55fc8165 d5b1caad a1ac2dae a2d4b76d c19b0c50
+882240f2 0c6e4f38 a4e4bfd7 4f5ba272 564c1d2f c59c5319 b949e354 b04669fe
+b1b6ab8a c71358dd 6385c545 110f935d 57538ad5 6a390493 e63d37e0 2a54f6b3
+3a787d5f 6276a0b5 19a6fcdf 7a42206a 29f9d4d5 f61b1891 bb72275e aa508167
+38901091 c6b505eb 84c7cb8c 2ad75a0f 874a1427 a2d1936b 2ad286af aa56d291
+d7894360 425c750d 93b39e26 187184c9 6c00b32d 73e2bb14 a0bebc3c 54623779
+64459eab 3f328b82 7718cf82 59a2cea6 04ee002e 89fe78e6 3fab0950 325ff6c2
+81383f05 6963c5c8 76cb5ad6 d49974c9 ca180dcf 380782d5 c7fa5cf6 8ac31511
+35e79e13 47da91d0 f40f9086 a7e2419e 31366241 051ef495 aa573b04 4a805d8d
+548300d0 00322a3c bf64cddf ba57a68e 75c6372b 50afd341 a7c13275 915a0bf5
+6b54bfab 2b0b1426 ab4cc9d7 449ccd82 f7fbf265 ab85c5f3 1b55db94 aad4e324
+cfa4bd3f 2deaa3e2 9e204d02 c8bd25ac eadf55b3 d5bd9e98 e31231b2 2ad5ad6c
+954329de adbe4528 d8710f69 aa51c90f aa786bf6 22513f1e aa51a79b 2ad344cc
+7b5a41f0 d37cfbad 1b069505 41ece491 b4c332e6 032268d4 c9600acc ce387e6d
+bf6bb16c 6a70fb78 0d03d9c9 d4df39de e01063da 4736f464 5ad328d8 b347cc96
+75bb0fc3 98511bfb 4ffbcc35 b58bcf6a e11f0abc bfc5fe4a a70aec10 ac39570a
+3f04442f 6188b153 e0397a2e 5727cb79 9ceb418f 1cacd68d 2ad37c96 0175cb9d
+c69dff09 c75b65f0 d9db40d8 ec0e7779 4744ead4 b11c3274 dd24cb9e 7e1c54bd
+f01144f9 d2240eb1 9675b3fd a3ac3755 d47c27af 51c85f4d 56907596 a5bb15e6
+580304f0 ca042cf1 011a37ea 8dbfaadb 35ba3e4a 3526ffa0 c37b4d09 bc306ed9
+98a52666 5648f725 ff5e569d 0ced63d0 7c63b2cf 700b45e1 d5ea50f1 85a92872
+af1fbda7 d4234870 a7870bf3 2d3b4d79 42e04198 0cd0ede7 26470db8 f881814c
+474d6ad7 7c0c5e5c d1231959 381b7298 f5d2f4db ab838653 6e2f1e23 83719c9e
+bd91e046 9a56456e dc39200c 20c8c571 962bda1c e1e696ff b141ab08 7cca89b9
+1a69e783 02cc4843 a2f7c579 429ef47d 427b169c 5ac9f049 dd8f0f00 5c8165bf
+
+S-Box S2
+1f201094 ef0ba75b 69e3cf7e 393f4380 fe61cf7a eec5207a 55889c94 72fc0651
+ada7ef79 4e1d7235 d55a63ce de0436ba 99c430ef 5f0c0794 18dcdb7d a1d6eff3
+a0b52f7b 59e83605 ee15b094 e9ffd909 dc440086 ef944459 ba83ccb3 e0c3cdfb
+d1da4181 3b092ab1 f997f1c1 a5e6cf7b 01420ddb e4e7ef5b 25a1ff41 e180f806
+1fc41080 179bee7a d37ac6a9 fe5830a4 98de8b7f 77e83f4e 79929269 24fa9f7b
+e113c85b acc40083 d7503525 f7ea615f 62143154 0d554b63 5d681121 c866c359
+3d63cf73 cee234c0 d4d87e87 5c672b21 071f6181 39f7627f 361e3084 e4eb573b
+602f64a4 d63acd9c 1bbc4635 9e81032d 2701f50c 99847ab4 a0e3df79 ba6cf38c
+10843094 2537a95e f46f6ffe a1ff3b1f 208cfb6a 8f458c74 d9e0a227 4ec73a34
+fc884f69 3e4de8df ef0e0088 3559648d 8a45388c 1d804366 721d9bfd a58684bb
+e8256333 844e8212 128d8098 fed33fb4 ce280ae1 27e19ba5 d5a6c252 e49754bd
+
+
+
+Adams			     Informational			[Page 9]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+c5d655dd eb667064 77840b4d a1b6a801 84db26a9 e0b56714 21f043b7 e5d05860
+54f03084 066ff472 a31aa153 dadc4755 b5625dbf 68561be6 83ca6b94 2d6ed23b
+eccf01db a6d3d0ba b6803d5c af77a709 33b4a34c 397bc8d6 5ee22b95 5f0e5304
+81ed6f61 20e74364 b45e1378 de18639b 881ca122 b96726d1 8049a7e8 22b7da7b
+5e552d25 5272d237 79d2951c c60d894c 488cb402 1ba4fe5b a4b09f6b 1ca815cf
+a20c3005 8871df63 b9de2fcb 0cc6c9e9 0beeff53 e3214517 b4542835 9f63293c
+ee41e729 6e1d2d7c 50045286 1e6685f3 f33401c6 30a22c95 31a70850 60930f13
+73f98417 a1269859 ec645c44 52c877a9 cdff33a6 a02b1741 7cbad9a2 2180036f
+50d99c08 cb3f4861 c26bd765 64a3f6ab 80342676 25a75e7b e4e6d1fc 20c710e6
+cdf0b680 17844d3b 31eef84d 7e0824e4 2ccb49eb 846a3bae 8ff77888 ee5d60f6
+7af75673 2fdd5cdb a11631c1 30f66f43 b3faec54 157fd7fa ef8579cc d152de58
+db2ffd5e 8f32ce19 306af97a 02f03ef8 99319ad5 c242fa0f a7e3ebb0 c68e4906
+b8da230c 80823028 dcdef3c8 d35fb171 088a1bc8 bec0c560 61a3c9e8 bca8f54d
+c72feffa 22822e99 82c570b4 d8d94e89 8b1c34bc 301e16e6 273be979 b0ffeaa6
+61d9b8c6 00b24869 b7ffce3f 08dc283b 43daf65a f7e19798 7619b72f 8f1c9ba4
+dc8637a0 16a7d3b1 9fc393b7 a7136eeb c6bcc63e 1a513742 ef6828bc 520365d6
+2d6a77ab 3527ed4b 821fd216 095c6e2e db92f2fb 5eea29cb 145892f5 91584f7f
+5483697b 2667a8cc 85196048 8c4bacea 833860d4 0d23e0f9 6c387e8a 0ae6d249
+b284600c d835731d dcb1c647 ac4c56ea 3ebd81b3 230eabb0 6438bc87 f0b5b1fa
+8f5ea2b3 fc184642 0a036b7a 4fb089bd 649da589 a345415e 5c038323 3e5d3bb9
+43d79572 7e6dd07c 06dfdf1e 6c6cc4ef 7160a539 73bfbe70 83877605 4523ecf1
+
+S-Box S3
+8defc240 25fa5d9f eb903dbf e810c907 47607fff 369fe44b 8c1fc644 aececa90
+beb1f9bf eefbcaea e8cf1950 51df07ae 920e8806 f0ad0548 e13c8d83 927010d5
+11107d9f 07647db9 b2e3e4d4 3d4f285e b9afa820 fade82e0 a067268b 8272792e
+553fb2c0 489ae22b d4ef9794 125e3fbc 21fffcee 825b1bfd 9255c5ed 1257a240
+4e1a8302 bae07fff 528246e7 8e57140e 3373f7bf 8c9f8188 a6fc4ee8 c982b5a5
+a8c01db7 579fc264 67094f31 f2bd3f5f 40fff7c1 1fb78dfc 8e6bd2c1 437be59b
+99b03dbf b5dbc64b 638dc0e6 55819d99 a197c81c 4a012d6e c5884a28 ccc36f71
+b843c213 6c0743f1 8309893c 0feddd5f 2f7fe850 d7c07f7e 02507fbf 5afb9a04
+a747d2d0 1651192e af70bf3e 58c31380 5f98302e 727cc3c4 0a0fb402 0f7fef82
+8c96fdad 5d2c2aae 8ee99a49 50da88b8 8427f4a0 1eac5790 796fb449 8252dc15
+efbd7d9b a672597d ada840d8 45f54504 fa5d7403 e83ec305 4f91751a 925669c2
+23efe941 a903f12e 60270df2 0276e4b6 94fd6574 927985b2 8276dbcb 02778176
+f8af918d 4e48f79e 8f616ddf e29d840e 842f7d83 340ce5c8 96bbb682 93b4b148
+ef303cab 984faf28 779faf9b 92dc560d 224d1e20 8437aa88 7d29dc96 2756d3dc
+8b907cee b51fd240 e7c07ce3 e566b4a1 c3e9615e 3cf8209d 6094d1e3 cd9ca341
+5c76460e 00ea983b d4d67881 fd47572c f76cedd9 bda8229c 127dadaa 438a074e
+1f97c090 081bdb8a 93a07ebe b938ca15 97b03cff 3dc2c0f8 8d1ab2ec 64380e51
+68cc7bfb d90f2788 12490181 5de5ffd4 dd7ef86a 76a2e214 b9a40368 925d958f
+4b39fffa ba39aee9 a4ffd30b faf7933b 6d498623 193cbcfa 27627545 825cf47a
+61bd8ba0 d11e42d1 cead04f4 127ea392 10428db7 8272a972 9270c4a8 127de50b
+285ba1c8 3c62f44f 35c0eaa5 e805d231 428929fb b4fcdf82 4fb66a53 0e7dc15b
+1f081fab 108618ae fcfd086d f9ff2889 694bcc11 236a5cae 12deca4d 2c3f8cc5
+d2d02dfe f8ef5896 e4cf52da 95155b67 494a488c b9b6a80c 5c8f82bc 89d36b45
+3a609437 ec00c9a9 44715253 0a874b49 d773bc40 7c34671c 02717ef6 4feb5536
+a2d02fff d2bf60c4 d43f03c0 50b4ef6d 07478cd1 006e1888 a2e53f55 b9e6d4bc
+
+
+
+Adams			     Informational		       [Page 10]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+a2048016 97573833 d7207d67 de0f8f3d 72f87b33 abcc4f33 7688c55d 7b00a6b0
+947b0001 570075d2 f9bb88f8 8942019e 4264a5ff 856302e0 72dbd92b ee971b69
+6ea22fde 5f08ae2b af7a616d e5c98767 cf1febd2 61efc8c2 f1ac2571 cc8239c2
+67214cb8 b1e583d1 b7dc3e62 7f10bdce f90a5c38 0ff0443d 606e6dc6 60543a49
+5727c148 2be98a1d 8ab41738 20e1be24 af96da0f 68458425 99833be5 600d457d
+282f9350 8334b362 d91d1120 2b6d8da0 642b1e31 9c305a00 52bce688 1b03588a
+f7baefd5 4142ed9c a4315c11 83323ec5 dfef4636 a133c501 e9d3531c ee353783
+
+S-Box S4
+9db30420 1fb6e9de a7be7bef d273a298 4a4f7bdb 64ad8c57 85510443 fa020ed1
+7e287aff e60fb663 095f35a1 79ebf120 fd059d43 6497b7b1 f3641f63 241e4adf
+28147f5f 4fa2b8cd c9430040 0cc32220 fdd30b30 c0a5374f 1d2d00d9 24147b15
+ee4d111a 0fca5167 71ff904c 2d195ffe 1a05645f 0c13fefe 081b08ca 05170121
+80530100 e83e5efe ac9af4f8 7fe72701 d2b8ee5f 06df4261 bb9e9b8a 7293ea25
+ce84ffdf f5718801 3dd64b04 a26f263b 7ed48400 547eebe6 446d4ca0 6cf3d6f5
+2649abdf aea0c7f5 36338cc1 503f7e93 d3772061 11b638e1 72500e03 f80eb2bb
+abe0502e ec8d77de 57971e81 e14f6746 c9335400 6920318f 081dbb99 ffc304a5
+4d351805 7f3d5ce3 a6c866c6 5d5bcca9 daec6fea 9f926f91 9f46222f 3991467d
+a5bf6d8e 1143c44f 43958302 d0214eeb 022083b8 3fb6180c 18f8931e 281658e6
+26486e3e 8bd78a70 7477e4c1 b506e07c f32d0a25 79098b02 e4eabb81 28123b23
+69dead38 1574ca16 df871b62 211c40b7 a51a9ef9 0014377b 041e8ac8 09114003
+bd59e4d2 e3d156d5 4fe876d5 2f91a340 557be8de 00eae4a7 0ce5c2ec 4db4bba6
+e756bdff dd3369ac ec17b035 06572327 99afc8b0 56c8c391 6b65811c 5e146119
+6e85cb75 be07c002 c2325577 893ff4ec 5bbfc92d d0ec3b25 b7801ab7 8d6d3b24
+20c763ef c366a5fc 9c382880 0ace3205 aac9548a eca1d7c7 041afa32 1d16625a
+6701902c 9b757a54 31d477f7 9126b031 36cc6fdb c70b8b46 d9e66a48 56e55a79
+026a4ceb 52437eff 2f8f76b4 0df980a5 8674cde3 edda04eb 17a9be04 2c18f4df
+b7747f9d ab2af7b4 efc34d20 2e096b7c 1741a254 e5b6a035 213d42f6 2c1c7c26
+61c2f50f 6552daf9 d2c231f8 25130f69 d8167fa2 0418f2c8 001a96a6 0d1526ab
+63315c21 5e0a72ec 49bafefd 187908d9 8d0dbd86 311170a7 3e9b640c cc3e10d7
+d5cad3b6 0caec388 f73001e1 6c728aff 71eae2a1 1f9af36e cfcbd12f c1de8417
+ac07be6b cb44a1d8 8b9b0f56 013988c3 b1c52fca b4be31cd d8782806 12a3a4e2
+6f7de532 58fd7eb6 d01ee900 24adffc2 f4990fc5 9711aac5 001d7b95 82e5e7d2
+109873f6 00613096 c32d9521 ada121ff 29908415 7fbb977f af9eb3db 29c9ed2a
+5ce2a465 a730f32c d0aa3fe8 8a5cc091 d49e2ce7 0ce454a9 d60acd86 015f1919
+77079103 dea03af6 78a8565e dee356df 21f05cbe 8b75e387 b3c50651 b8a5c3ef
+d8eeb6d2 e523be77 c2154529 2f69efdf afe67afb f470c4b2 f3e0eb5b d6cc9876
+39e4460c 1fda8538 1987832f ca007367 a99144f8 296b299e 492fc295 9266beab
+b5676e69 9bd3ddda df7e052f db25701c 1b5e51ee f65324e6 6afce36c 0316cc04
+8644213e b7dc59d0 7965291f ccd6fd43 41823979 932bcdf6 b657c34d 4edfd282
+7ae5290c 3cb9536b 851e20fe 9833557e 13ecf0b0 d3ffb372 3f85c5c1 0aef7ed2
+
+S-Box S5
+7ec90c04 2c6e74b9 9b0e66df a6337911 b86a7fff 1dd358f5 44dd9d44 1731167f
+08fbf1fa e7f511cc d2051b00 735aba00 2ab722d8 386381cb acf6243a 69befd7a
+e6a2e77f f0c720cd c4494816 ccf5c180 38851640 15b0a848 e68b18cb 4caadeff
+5f480a01 0412b2aa 259814fc 41d0efe2 4e40b48d 248eb6fb 8dba1cfe 41a99b02
+1a550a04 ba8f65cb 7251f4e7 95a51725 c106ecd7 97a5980a c539b9aa 4d79fe6a
+
+
+
+Adams			     Informational		       [Page 11]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+f2f3f763 68af8040 ed0c9e56 11b4958b e1eb5a88 8709e6b0 d7e07156 4e29fea7
+6366e52d 02d1c000 c4ac8e05 9377f571 0c05372a 578535f2 2261be02 d642a0c9
+df13a280 74b55bd2 682199c0 d421e5ec 53fb3ce8 c8adedb3 28a87fc9 3d959981
+5c1ff900 fe38d399 0c4eff0b 062407ea aa2f4fb1 4fb96976 90c79505 b0a8a774
+ef55a1ff e59ca2c2 a6b62d27 e66a4263 df65001f 0ec50966 dfdd55bc 29de0655
+911e739a 17af8975 32c7911c 89f89468 0d01e980 524755f4 03b63cc9 0cc844b2
+bcf3f0aa 87ac36e9 e53a7426 01b3d82b 1a9e7449 64ee2d7e cddbb1da 01c94910
+b868bf80 0d26f3fd 9342ede7 04a5c284 636737b6 50f5b616 f24766e3 8eca36c1
+136e05db fef18391 fb887a37 d6e7f7d4 c7fb7dc9 3063fcdf b6f589de ec2941da
+26e46695 b7566419 f654efc5 d08d58b7 48925401 c1bacb7f e5ff550f b6083049
+5bb5d0e8 87d72e5a ab6a6ee1 223a66ce c62bf3cd 9e0885f9 68cb3e47 086c010f
+a21de820 d18b69de f3f65777 fa02c3f6 407edac3 cbb3d550 1793084d b0d70eba
+0ab378d5 d951fb0c ded7da56 4124bbe4 94ca0b56 0f5755d1 e0e1e56e 6184b5be
+580a249f 94f74bc0 e327888e 9f7b5561 c3dc0280 05687715 646c6bd7 44904db3
+66b4f0a3 c0f1648a 697ed5af 49e92ff6 309e374f 2cb6356a 85808573 4991f840
+76f0ae02 083be84d 28421c9a 44489406 736e4cb8 c1092910 8bc95fc6 7d869cf4
+134f616f 2e77118d b31b2be1 aa90b472 3ca5d717 7d161bba 9cad9010 af462ba2
+9fe459d2 45d34559 d9f2da13 dbc65487 f3e4f94e 176d486f 097c13ea 631da5c7
+445f7382 175683f4 cdc66a97 70be0288 b3cdcf72 6e5dd2f3 20936079 459b80a5
+be60e2db a9c23101 eba5315c 224e42f2 1c5c1572 f6721b2c 1ad2fff3 8c25404e
+324ed72f 4067b7fd 0523138e 5ca3bc78 dc0fd66e 75922283 784d6b17 58ebb16e
+44094f85 3f481d87 fcfeae7b 77b5ff76 8c2302bf aaf47556 5f46b02a 2b092801
+3d38f5f7 0ca81f36 52af4a8a 66d5e7c0 df3b0874 95055110 1b5ad7a8 f61ed5ad
+6cf6e479 20758184 d0cefa65 88f7be58 4a046826 0ff6f8f3 a09c7f70 5346aba0
+5ce96c28 e176eda3 6bac307f 376829d2 85360fa9 17e3fe2a 24b79767 f5a96b20
+d6cd2595 68ff1ebf 7555442c f19f06be f9e0659a eeb9491d 34010718 bb30cab8
+e822fe15 88570983 750e6249 da627e55 5e76ffa8 b1534546 6d47de08 efe9e7d4
+
+S-Box S6
+f6fa8f9d 2cac6ce1 4ca34867 e2337f7c 95db08e7 016843b4 eced5cbc 325553ac
+bf9f0960 dfa1e2ed 83f0579d 63ed86b9 1ab6a6b8 de5ebe39 f38ff732 8989b138
+33f14961 c01937bd f506c6da e4625e7e a308ea99 4e23e33c 79cbd7cc 48a14367
+a3149619 fec94bd5 a114174a eaa01866 a084db2d 09a8486f a888614a 2900af98
+01665991 e1992863 c8f30c60 2e78ef3c d0d51932 cf0fec14 f7ca07d2 d0a82072
+fd41197e 9305a6b0 e86be3da 74bed3cd 372da53c 4c7f4448 dab5d440 6dba0ec3
+083919a7 9fbaeed9 49dbcfb0 4e670c53 5c3d9c01 64bdb941 2c0e636a ba7dd9cd
+ea6f7388 e70bc762 35f29adb 5c4cdd8d f0d48d8c b88153e2 08a19866 1ae2eac8
+284caf89 aa928223 9334be53 3b3a21bf 16434be3 9aea3906 efe8c36e f890cdd9
+80226dae c340a4a3 df7e9c09 a694a807 5b7c5ecc 221db3a6 9a69a02f 68818a54
+ceb2296f 53c0843a fe893655 25bfe68a b4628abc cf222ebf 25ac6f48 a9a99387
+53bddb65 e76ffbe7 e967fd78 0ba93563 8e342bc1 e8a11be9 4980740d c8087dfc
+8de4bf99 a11101a0 7fd37975 da5a26c0 e81f994f 9528cd89 fd339fed b87834bf
+5f04456d 22258698 c9c4c83b 2dc156be 4f628daa 57f55ec5 e2220abe d2916ebf
+4ec75b95 24f2c3c0 42d15d99 cd0d7fa0 7b6e27ff a8dc8af0 7345c106 f41e232f
+35162386 e6ea8926 3333b094 157ec6f2 372b74af 692573e4 e9a9d848 f3160289
+3a62ef1d a787e238 f3a5f676 74364853 20951063 4576698d b6fad407 592af950
+36f73523 4cfb6e87 7da4cec0 6c152daa cb0396a8 c50dfe5d fcd707ab 0921c42f
+89dff0bb 5fe2be78 448f4f33 754613c9 2b05d08d 48b9d585 dc049441 c8098f9b
+
+
+
+Adams			     Informational		       [Page 12]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+7dede786 c39a3373 42410005 6a091751 0ef3c8a6 890072d6 28207682 a9a9f7be
+bf32679d d45b5b75 b353fd00 cbb0e358 830f220a 1f8fb214 d372cf08 cc3c4a13
+8cf63166 061c87be 88c98f88 6062e397 47cf8e7a b6c85283 3cc2acfb 3fc06976
+4e8f0252 64d8314d da3870e3 1e665459 c10908f0 513021a5 6c5b68b7 822f8aa0
+3007cd3e 74719eef dc872681 073340d4 7e432fd9 0c5ec241 8809286c f592d891
+08a930f6 957ef305 b7fbffbd c266e96f 6fe4ac98 b173ecc0 bc60b42a 953498da
+fba1ae12 2d4bd736 0f25faab a4f3fceb e2969123 257f0c3d 9348af49 361400bc
+e8816f4a 3814f200 a3f94043 9c7a54c2 bc704f57 da41e7f9 c25ad33a 54f4a084
+b17f5505 59357cbe edbd15c8 7f97c5ab ba5ac7b5 b6f6deaf 3a479c3a 5302da25
+653d7e6a 54268d49 51a477ea 5017d55b d7d25d88 44136c76 0404a8c8 b8e5a121
+b81a928a 60ed5869 97c55b96 eaec991b 29935913 01fdb7f1 088e8dfa 9ab6f6f5
+3b4cbf9f 4a5de3ab e6051d35 a0e1d855 d36b4cf1 f544edeb b0e93524 bebb8fbd
+a2d762cf 49c92f54 38b5f331 7128a454 48392905 a65b1db8 851c97bd d675cf2f
+
+S-Box S7
+85e04019 332bf567 662dbfff cfc65693 2a8d7f6f ab9bc912 de6008a1 2028da1f
+0227bce7 4d642916 18fac300 50f18b82 2cb2cb11 b232e75c 4b3695f2 b28707de
+a05fbcf6 cd4181e9 e150210c e24ef1bd b168c381 fde4e789 5c79b0d8 1e8bfd43
+4d495001 38be4341 913cee1d 92a79c3f 089766be baeeadf4 1286becf b6eacb19
+2660c200 7565bde4 64241f7a 8248dca9 c3b3ad66 28136086 0bd8dfa8 356d1cf2
+107789be b3b2e9ce 0502aa8f 0bc0351e 166bf52a eb12ff82 e3486911 d34d7516
+4e7b3aff 5f43671b 9cf6e037 4981ac83 334266ce 8c9341b7 d0d854c0 cb3a6c88
+47bc2829 4725ba37 a66ad22b 7ad61f1e 0c5cbafa 4437f107 b6e79962 42d2d816
+0a961288 e1a5c06e 13749e67 72fc081a b1d139f7 f9583745 cf19df58 bec3f756
+c06eba30 07211b24 45c28829 c95e317f bc8ec511 38bc46e9 c6e6fa14 bae8584a
+ad4ebc46 468f508b 7829435f f124183b 821dba9f aff60ff4 ea2c4e6d 16e39264
+92544a8b 009b4fc3 aba68ced 9ac96f78 06a5b79a b2856e6e 1aec3ca9 be838688
+0e0804e9 55f1be56 e7e5363b b3a1f25d f7debb85 61fe033c 16746233 3c034c28
+da6d0c74 79aac56c 3ce4e1ad 51f0c802 98f8f35a 1626a49f eed82b29 1d382fe3
+0c4fb99a bb325778 3ec6d97b 6e77a6a9 cb658b5c d45230c7 2bd1408b 60c03eb7
+b9068d78 a33754f4 f430c87d c8a71302 b96d8c32 ebd4e7be be8b9d2d 7979fb06
+e7225308 8b75cf77 11ef8da4 e083c858 8d6b786f 5a6317a6 fa5cf7a0 5dda0033
+f28ebfb0 f5b9c310 a0eac280 08b9767a a3d9d2b0 79d34217 021a718d 9ac6336a
+2711fd60 438050e3 069908a8 3d7fedc4 826d2bef 4eeb8476 488dcf25 36c9d566
+28e74e41 c2610aca 3d49a9cf bae3b9df b65f8de6 92aeaf64 3ac7d5e6 9ea80509
+f22b017d a4173f70 dd1e16c3 15e0d7f9 50b1b887 2b9f4fd5 625aba82 6a017962
+2ec01b9c 15488aa9 d716e740 40055a2c 93d29a22 e32dbf9a 058745b9 3453dc1e
+d699296e 496cff6f 1c9f4986 dfe2ed07 b87242d1 19de7eae 053e561a 15ad6f8c
+66626c1c 7154c24c ea082b2a 93eb2939 17dcb0f0 58d4f2ae 9ea294fb 52cf564c
+9883fe66 2ec40581 763953c3 01d6692e d3a0c108 a1e7160e e4f2dfa6 693ed285
+74904698 4c2b0edd 4f757656 5d393378 a132234f 3d321c5d c3f5e194 4b269301
+c79f022f 3c997e7e 5e4f9504 3ffafbbd 76f7ad0e 296693f4 3d1fce6f c61e45be
+d3b5ab34 f72bf9b7 1b0434c0 4e72b567 5592a33d b5229301 cfd2a87f 60aeb767
+1814386b 30bcc33d 38a0c07d fd1606f2 c363519b 589dd390 5479f8e6 1cb8d647
+97fd61a9 ea7759f4 2d57539d 569a58cf e84e63ad 462e1b78 6580f87e f3817914
+91da55f4 40a230f3 d1988f35 b6e318d2 3ffa50bc 3d40f021 c3c0bdae 4958c24c
+518f36b2 84b1d370 0fedce83 878ddada f2a279c7 94e01be8 90716f4b 954b8aa3
+
+
+
+
+Adams			     Informational		       [Page 13]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+S-Box S8
+e216300d bbddfffc a7ebdabd 35648095 7789f8b7 e6c1121b 0e241600 052ce8b5
+11a9cfb0 e5952f11 ece7990a 9386d174 2a42931c 76e38111 b12def3a 37ddddfc
+de9adeb1 0a0cc32c be197029 84a00940 bb243a0f b4d137cf b44e79f0 049eedfd
+0b15a15d 480d3168 8bbbde5a 669ded42 c7ece831 3f8f95e7 72df191b 7580330d
+94074251 5c7dcdfa abbe6d63 aa402164 b301d40a 02e7d1ca 53571dae 7a3182a2
+12a8ddec fdaa335d 176f43e8 71fb46d4 38129022 ce949ad4 b84769ad 965bd862
+82f3d055 66fb9767 15b80b4e 1d5b47a0 4cfde06f c28ec4b8 57e8726e 647a78fc
+99865d44 608bd593 6c200e03 39dc5ff6 5d0b00a3 ae63aff2 7e8bd632 70108c0c
+bbd35049 2998df04 980cf42a 9b6df491 9e7edd53 06918548 58cb7e07 3b74ef2e
+522fffb1 d24708cc 1c7e27cd a4eb215b 3cf1d2e2 19b47a38 424f7618 35856039
+9d17dee7 27eb35e6 c9aff67b 36baf5b8 09c467cd c18910b1 e11dbf7b 06cd1af8
+7170c608 2d5e3354 d4de495a 64c6d006 bcc0c62c 3dd00db3 708f8f34 77d51b42
+264f620f 24b8d2bf 15c1b79e 46a52564 f8d7e54e 3e378160 7895cda5 859c15a5
+e6459788 c37bc75f db07ba0c 0676a3ab 7f229b1e 31842e7b 24259fd7 f8bef472
+835ffcb8 6df4c1f2 96f5b195 fd0af0fc b0fe134c e2506d3d 4f9b12ea f215f225
+a223736f 9fb4c428 25d04979 34c713f8 c4618187 ea7a6e98 7cd16efc 1436876c
+f1544107 bedeee14 56e9af27 a04aa441 3cf7c899 92ecbae6 dd67016d 151682eb
+a842eedf fdba60b4 f1907b75 20e3030f 24d8c29e e139673b efa63fb8 71873054
+b6f2cf3b 9f326442 cb15a4cc b01a4504 f1e47d8d 844a1be5 bae7dfdc 42cbda70
+cd7dae0a 57e85b7a d53f5af6 20cf4d8c cea4d428 79d130a4 3486ebfb 33d3cddc
+77853b53 37effcb5 c5068778 e580b3e6 4e68b8f4 c5c8b37e 0d809ea2 398feb7c
+132a4f94 43b7950e 2fee7d1c 223613bd dd06caa2 37df932b c4248289 acf3ebc3
+5715f6b7 ef3478dd f267616f c148cbe4 9052815e 5e410fab b48a2465 2eda7fa4
+e87b40e4 e98ea084 5889e9e1 efd390fc dd07d35b db485694 38d7e5b2 57720101
+730edebc 5b643113 94917e4f 503c2fba 646f1282 7523d24a e0779695 f9c17a8f
+7a5b2121 d187b896 29263a4d ba510cdf 81f47c9f ad1163ed ea7b5965 1a00726e
+11403092 00da6d77 4a0cdd61 ad1f4603 605bdfb0 9eedc364 22ebe6a8 cee7d28a
+a0e736a0 5564a6b9 10853209 c7eb8f37 2de705ca 8951570f df09822b bd691a6c
+aa12e4f2 87451c0f e0f6a27a 3ada4819 4cf1764f 0d771c2b 67cdb156 350d8384
+5938fa0f 42399ef3 36997b07 0e84093d 4aa93e61 8360d87b 1fa98b0c 1149382c
+e97625a5 0614d1b7 0e25244b 0c768347 589e8d82 0d2059d1 a466bb1e f8da0a82
+04f19130 ba6e4ec0 99265164 1ee7230d 50b2ad80 eaee6801 8db2a283 ea8bf59e
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+Adams			     Informational		       [Page 14]
+
+RFC 2144	     CAST-128 Encryption Algorithms		May 1997
+
+
+Appendix B. Test Vectors
+
+   This appendix provides test vectors for the CAST-128 cipher described
+   this document.
+
+B.1. Single Plaintext-Key-Ciphertext Sets
+
+   In order to ensure that the algorithm is implemented correctly, the
+   following test vectors can be used for verification (values given in
+   hexadecimal notation).
+
+   128-bit key	       = 01 23 45 67 12 34 56 78 23 45 67 89 34 56 78 9A
+	   plaintext   = 01 23 45 67 89 AB CD EF
+	   ciphertext  = 23 8B 4F E5 84 7E 44 B2
+
+   80-bit  key	       = 01 23 45 67 12 34 56 78 23 45
+		       = 01 23 45 67 12 34 56 78 23 45 00 00 00 00 00 00
+	   plaintext   = 01 23 45 67 89 AB CD EF
+	   ciphertext  = EB 6A 71 1A 2C 02 27 1B
+
+   40-bit  key	       = 01 23 45 67 12
+		       = 01 23 45 67 12 00 00 00 00 00 00 00 00 00 00 00
+	   plaintext   = 01 23 45 67 89 AB CD EF
+	   ciphertext  = 7A C8 16 D1 6E 9B 30 2E
+
+B.2. Full Maintenance Test
+
+   A maintenance test for CAST-128 has been defined to verify the
+   correctness of implementations.  It is defined in pseudo-code as
+   follows, where a and b are 128-bit vectors, aL and aR are the
+   leftmost and rightmost halves of a, bL and bR are the leftmost and
+   rightmost halves of b, and encrypt(d,k) is the encryption in ECB mode
+   of block d under key k.
+
+   Initial a = 01 23 45 67 12 34 56 78 23 45 67 89 34 56 78 9A (hex)
+   Initial b = 01 23 45 67 12 34 56 78 23 45 67 89 34 56 78 9A (hex)
+
+   do 1,000,000 times
+   {
+       aL = encrypt(aL,b)
+       aR = encrypt(aR,b)
+       bL = encrypt(bL,a)
+       bR = encrypt(bR,a)
+   }
+
+Verify a == EE A9 D0 A2 49 FD 3B A6 B3 43 6F B8 9D 6D CA 92 (hex)
+Verify b == B2 C9 5E B0 0C 31 AD 71 80 AC 05 B8 E8 3D 69 6E (hex)
+
+
+
+
+Adams			     Informational		       [Page 15]
+
diff -urN g10-0.2.5/g10/ChangeLog g10-0.2.6/g10/ChangeLog
--- g10-0.2.5/g10/ChangeLog	Tue Feb 10 11:57:29 1998
+++ g10-0.2.6/g10/ChangeLog	Fri Feb 13 20:44:11 1998
@@ -1,5 +1,27 @@
-Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
+Fri Feb 13 20:18:14 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
-	* ddd/hhhh:
+	* ringedit.c (enum_keyblocks, keyring_enum): New.
 
+Fri Feb 13 19:33:40 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* export.c: Add functionality.
+
+	* keygen.c (generate_keypair): Moved the leading comment behind the
+	key packet.
+	* kbnode.c (walk_kbnode): Fixed.
+
+	* g10.c (main): listing armored keys now work.
+
+Fri Feb 13 16:17:43 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* parse-packet.c (parse_publickey, parse_signature): Fixed calls
+	to mpi_read used for ELG b.
+
+Fri Feb 13 15:13:23 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10.c (main): changed formatting of help output.
+
+Thu Feb 12 22:24:42 1998  Werner Koch  (wk@frodo)
+
+	* pubkey-enc.c (get_session_key): rewritten
 
diff -urN g10-0.2.5/g10/Makefile.in g10-0.2.6/g10/Makefile.in
--- g10-0.2.5/g10/Makefile.in	Thu Feb 12 14:35:19 1998
+++ g10-0.2.6/g10/Makefile.in	Fri Feb 13 21:27:42 1998
@@ -85,7 +85,6 @@
 RANLIB = @RANLIB@
 VERSION = @VERSION@
 ZLIBS = @ZLIBS@
-ZLIB_SUBDIR = @ZLIB_SUBDIR@
 
 INCLUDES = -I$(top_srcdir)/include
 EXTRA_DIST = OPTIONS  pubring.g10
@@ -328,14 +327,14 @@
 	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
 	../include/../cipher/elgamal.h filter.h ../include/errors.h \
 	keydb.h ../include/util.h main.h
-encode.o: encode.c options.h packet.h ../include/types.h \
-	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/rsa.h \
-	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
-	../include/../cipher/elgamal.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h main.h
+encode.o encode.lo: encode.c ../config.h options.h packet.h \
+	../include/types.h ../include/iobuf.h ../include/mpi.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
+	../include/../cipher/gost.h ../include/../cipher/elgamal.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h
 encr-data.o: encr-data.c ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h packet.h ../include/cipher.h \
@@ -343,14 +342,14 @@
 	../include/../cipher/sha1.h ../include/../cipher/rsa.h \
 	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
 	../include/../cipher/elgamal.h filter.h
-export.o: export.c options.h packet.h ../include/types.h \
-	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/rsa.h \
-	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
-	../include/../cipher/elgamal.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h
+export.o export.lo: export.c ../config.h options.h packet.h \
+	../include/types.h ../include/iobuf.h ../include/mpi.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
+	../include/../cipher/gost.h ../include/../cipher/elgamal.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h main.h
 free-packet.o: free-packet.c packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
 	../include/cipher.h ../include/../cipher/md.h \
@@ -386,14 +385,15 @@
 	../include/../cipher/md5.h ../include/../cipher/rsa.h \
 	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
 	../include/../cipher/elgamal.h filter.h keydb.h options.h
-import.o: import.c options.h packet.h ../include/types.h \
-	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/rsa.h \
-	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
-	../include/../cipher/elgamal.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h trustdb.h
+import.o import.lo: import.c ../config.h options.h packet.h \
+	../include/types.h ../include/iobuf.h ../include/mpi.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
+	../include/../cipher/gost.h ../include/../cipher/elgamal.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h \
+	trustdb.h
 kbnode.o kbnode.lo: kbnode.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h packet.h \
@@ -477,11 +477,12 @@
 	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
 	../include/../cipher/elgamal.h filter.h ../include/ttyio.h \
 	main.h keydb.h
-pubkey-enc.o: pubkey-enc.c ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h packet.h ../include/cipher.h \
-	../include/../cipher/md5.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/rsa.h \
+pubkey-enc.o pubkey-enc.lo: pubkey-enc.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h packet.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/rsa.h \
 	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
 	../include/../cipher/elgamal.h filter.h keydb.h
 ringedit.o ringedit.lo: ringedit.c ../config.h ../include/util.h \
diff -urN g10-0.2.5/g10/encode.c g10-0.2.6/g10/encode.c
--- g10-0.2.5/g10/encode.c	Fri Jan 16 12:48:40 1998
+++ g10-0.2.6/g10/encode.c	Thu Feb 12 22:28:20 1998
@@ -182,7 +182,7 @@
 	goto leave;
     }
     else if( opt.verbose )
-	log_error("reading from '%s'\n", filename? filename: "[stdin]");
+	log_info("reading from '%s'\n", filename? filename: "[stdin]");
 
     if( !(out = open_outfile( filename, opt.armor? 1:0 )) ) {
 	rc = G10ERR_CREATE_FILE;  /* or user said: do not overwrite */
diff -urN g10-0.2.5/g10/export.c g10-0.2.6/g10/export.c
--- g10-0.2.5/g10/export.c	Mon Jan 26 13:20:22 1998
+++ g10-0.2.6/g10/export.c	Fri Feb 13 21:08:12 1998
@@ -31,17 +31,109 @@
 #include "keydb.h"
 #include "memory.h"
 #include "util.h"
+#include "main.h"
 
 
 /****************
- * Make a new keyring from all internal keyrings (if no user is given)
- * or for all selected users.
+ * Export the public keys (to standard out or --outout).
+ * Depending on opt.armor the output is armored.
+ * If USERS is NULL, the complete ring wil. be exported.
  */
 int
 export_pubkeys( STRLIST users )
 {
-    log_fatal("Not yet implemented");
-    return 0;
+    int rc = 0;
+    armor_filter_context_t afx;
+    compress_filter_context_t zfx;
+    IOBUF out = NULL;
+    PACKET pkt;
+    KBNODE keyblock = NULL;
+    KBNODE kbctx, node;
+    KBPOS kbpos;
+    STRLIST sl;
+    int all = !users;
+    int any=0;
+
+    memset( &afx, 0, sizeof afx);
+    memset( &zfx, 0, sizeof zfx);
+    init_packet( &pkt );
+
+    if( !(out = open_outfile( NULL, 0 )) ) {
+	rc = G10ERR_CREATE_FILE;
+	goto leave;
+    }
+
+    if( opt.armor ) {
+	afx.what = 1;
+	iobuf_push_filter( out, armor_filter, &afx );
+    }
+    if( opt.compress )
+	iobuf_push_filter( out, compress_filter, &zfx );
+
+    if( all ) {
+	rc = enum_keyblocks( 0, &kbpos, &keyblock );
+	if( rc ) {
+	    if( rc != -1 )
+		log_error("enum_keyblocks(open) failed: %s\n", g10_errstr(rc) );
+	    goto leave;
+	}
+	all = 2;
+    }
+
+    /* use the correct sequence. strlist_last,prev do work correct with
+     * NULL pointers :-) */
+    for( sl=strlist_last(users); sl || all ; sl=strlist_prev( users, sl )) {
+	if( all ) { /* get the next user */
+	    rc = enum_keyblocks( 1, &kbpos, &keyblock );
+	    if( rc == -1 )  /* EOF */
+		break;
+	    if( rc ) {
+		log_error("enum_keyblocks(read) failed: %s\n", g10_errstr(rc));
+		break;
+	    }
+	}
+	else {
+	    /* search the userid */
+	    rc = find_keyblock_byname( &kbpos, sl->d );
+	    if( rc ) {
+		log_error("%s: user not found: %s\n", sl->d, g10_errstr(rc) );
+		rc = 0;
+		continue;
+	    }
+	    /* read the keyblock */
+	    rc = read_keyblock( &kbpos, &keyblock );
+	}
+
+	if( rc ) {
+	    log_error("certificate read problem: %s\n", g10_errstr(rc));
+	    goto leave;
+	}
+
+	/* and write it */
+	for( kbctx=NULL; (node = walk_kbnode( keyblock, &kbctx, 0 )); ) {
+	    if( (rc = build_packet( out, node->pkt )) ) {
+		log_error("build_packet(%d) failed: %s\n",
+			    node->pkt->pkttype, g10_errstr(rc) );
+		rc = G10ERR_WRITE_FILE;
+		goto leave;
+	    }
+	}
+	any++;
+    }
+    if( rc == -1 )
+	rc = 0;
+
+  leave:
+    if( all == 2 )
+	enum_keyblocks( 2, &kbpos, &keyblock ); /* close */
+    release_kbnode( keyblock );
+    if( rc || !any )
+	iobuf_cancel(out);
+    else
+	iobuf_close(out);
+    if( !any )
+	log_info("warning: nothing exported\n");
+    return rc;
 }
 
 
diff -urN g10-0.2.5/g10/g10.c g10-0.2.6/g10/g10.c
--- g10-0.2.5/g10/g10.c	Thu Feb 12 14:06:24 1998
+++ g10-0.2.6/g10/g10.c	Fri Feb 13 19:13:20 1998
@@ -41,11 +41,85 @@
 #include "status.h"
 
 
+static ARGPARSE_OPTS opts[] = {
+
+    { 300, NULL, 0, N_("\vCommands:\n ") },
+
+    { 's', "sign",      0, N_("make a signature")},
+    { 539, "clearsign", 0, N_("make a clear text signature") },
+    { 'b', "detach-sign", 0, N_("make a detached signature")},
+    { 'e', "encrypt",   0, N_("encrypt data")},
+    { 'c', "symmetric", 0, N_("encryption only with symmetric cipher")},
+    { 507, "store",     0, N_("store only")},
+    { 'd', "decrypt",   0, N_("decrypt data (default)")},
+    { 'k', "list-keys", 0, N_("list keys")},
+    { 508, "check-keys",0, N_("check signatures on a key in the keyring")},
+    { 515, "fingerprint", 0, N_("show the fingerprints")},
+    { 521, "list-packets",0,N_("list only the sequence of packets")},
+    { 503, "gen-key",   0, N_("generate a new key pair")},
+    { 506, "sign-key"  ,0, N_("make a signature on a key in the keyring")},
+    { 505, "delete-key",0, N_("remove key from the public keyring")},
+    { 524, "edit-sig"  ,0, N_("edit a key signature")},
+    { 525, "change-passphrase", 0, N_("change the passphrase of your secret keyring")},
+    { 537, "export"          , 0, N_("export keys") },
+    { 530, "import",      0     , N_("import/merge keys")},
+
+    { 301, NULL, 0, N_("\v\nOptions:\n ") },
+
+    { 'a', "armor",     0, N_("create ascii armored output")},
+    { 'o', "output",    2, N_("use as output file")},
+    { 'u', "local-user",2, N_("use this user-id to sign or decrypt")},
+    { 'r', "remote-user", 2, N_("use this user-id for encryption")},
+    { 'v', "verbose",   0, N_("verbose") },
+    { 'z', NULL,        1, N_("set compress level (0 disables)") },
+    { 't', "textmode",  0, N_("use canonical text mode")},
+    { 'n', "dry-run",   0, N_("don't make any changes") },
+    { 500, "batch",     0, N_("batch mode: never ask")},
+    { 501, "yes",       0, N_("assume yes on most questions")},
+    { 502, "no",        0, N_("assume no on most questions")},
+    { 509, "keyring"   ,2, N_("add this keyring to the list of keyrings")},
+    { 517, "secret-keyring" ,2, N_("add this secret keyring to the list")},
+    { 518, "options"   , 2, N_("read options from file")},
+
+    { 510, "debug"     ,4|16, N_("set debugging flags")},
+    { 511, "debug-all" ,0, N_("enable full debugging")},
+    { 512, "status-fd" ,1, N_("write status info to this fd") },
+    { 534, "no-comment", 0,   N_("do not write comment packets")},
+    { 535, "completes-needed", 1, N_("(default is 1)")},
+    { 536, "marginals-needed", 1, N_("(default is 3)")},
+    { 527, "cipher-algo", 2 , N_("select default cipher algorithm")},
+    { 528, "pubkey-algo", 2 , N_("select default puplic key algorithm")},
+    { 529, "digest-algo", 2 , N_("select default message digest algorithm")},
+
+    { 302, NULL, 0, N_("\v\nExamples:\n\n"
+    " -se -r Bob [file]          sign and encrypt for user Bob\n"
+    " -sat [file]                make a clear text signature\n"
+    " -sb  [file]                make a detached signature\n"
+    " -k   [userid]              show keys\n"
+    " -kc  [userid]              show fingerprint\n"  ) },
+
+  /* hidden options */
+    { 532, "quick-random", 0, "\r"},
+    { 526, "no-verbose", 0, "\r"},
+    { 538, "trustdb-name", 2, "\r" },
+    { 540, "no-secmem-warning", 0, "\r" }, /* used only by regression tests */
+    { 519, "no-armor",   0, "\r"},
+    { 520, "no-default-keyring", 0, "\r" },
+    { 522, "no-greeting", 0, "\r" },
+    { 523, "passphrase-fd",1, "\r" },
+    { 541, "no-operation", 0, "\r" },      /* used by regression tests */
+
+
+{0} };
+
+
+
+
 enum cmd_values { aNull = 0,
     aSym, aStore, aEncr, aKeygen, aSign, aSignEncr,
     aSignKey, aClearsign, aListPackets, aEditSig,
     aKMode, aKModeC, aChangePass, aImport,
-    aExport,
+    aExport, aCheckKeys,
 aNOP };
 
 
@@ -59,7 +133,7 @@
     switch( level ) {
       case 10:
       case 0:	p = "g10 - v" VERSION "; "
-		    "Copyright 1997 Werner Koch (dd9jn)\n" ; break;
+		    "Copyright 1998 Werner Koch (dd9jn)\n" ; break;
       case 13:	p = "g10"; break;
       case 14:	p = VERSION; break;
       case 1:
@@ -105,7 +179,7 @@
 static void
 wrong_args( const char *text)
 {
-    fputs(_("Usage: g10 [options] "),stderr);
+    fputs(_("usage: g10 [options] "),stderr);
     fputs(text,stderr);
     putc('\n',stderr);
     g10_exit(2);
@@ -152,63 +226,28 @@
 }
 
 
+
+static void
+check_opts(void)
+{
+    if( !opt.def_cipher_algo || check_cipher_algo(opt.def_cipher_algo) )
+	log_error(_("selected cipher algorithm is invalid\n"));
+    if( !opt.def_pubkey_algo || check_pubkey_algo(opt.def_pubkey_algo) )
+	log_error(_("selected pubkey algorithm is invalid\n"));
+    if( !opt.def_digest_algo || check_digest_algo(opt.def_digest_algo) )
+	log_error(_("selected digest algorithm is invalid\n"));
+    if( opt.completes_needed < 1 )
+	log_error(_("completes-needed must be greater than 0\n"));
+    if( opt.marginals_needed < 2 )
+	log_error(_("marginals-needed must be greater than 1\n"));
+}
+
+
+
+
 void
 main( int argc, char **argv )
 {
-    static ARGPARSE_OPTS opts[] = {
-    { 'a', "armor",     0, N_("create ascii armored output")},
-    { 'v', "verbose",   0, N_("verbose") },
-    { 'z', NULL,        1, N_("set compress level (0 disables)") },
-    { 'n', "dry-run",   0, N_("don't make any changes") },
-    { 'c', "symmetric", 0, N_("do only a symmetric encryption")},
-    { 'o', "output",    2, N_("use as output file")},
-    { 500, "batch",     0, N_("batch mode: never ask")},
-    { 501, "yes",       0, N_("assume yes on most questions")},
-    { 502, "no",        0, N_("assume no on most questions")},
-    { 503, "gen-key",   0, N_("generate a new key pair")},
-    { 504, "add-key",   0, N_("add key to the public keyring")},
-    { 505, "delete-key",0, N_("remove key from public keyring")},
-    { 506, "sign-key"  ,0, N_("make a signature on a key in the keyring")},
-    { 507, "store",     0, N_("store only")},
-    { 508, "check-key" ,0, N_("check signatures on a key in the keyring")},
-    { 509, "keyring"   ,2, N_("add this keyring to the list of keyrings")},
-    { 's', "sign",      0, N_("make a signature")},
-    { 't', "textmode",  0, N_("use canonical text mode")},
-    { 'b', "detach-sign", 0, N_("make a detached signature")},
-    { 'e', "encrypt",   0, N_("encrypt data")},
-    { 'd', "decrypt",   0, N_("decrypt data (default)")},
-    { 'u', "local-user",2, N_("use this user-id to sign or decrypt")},
-    { 'r', "remote-user", 2, N_("use this user-id for encryption")},
-    { 'k', NULL      , 0, N_("list keys")},
-    { 510, "debug"     ,4|16, N_("set debugging flags")},
-    { 511, "debug-all" ,0, N_("enable full debugging")},
-    { 512, "status-fd" ,1, N_("write status info to this fd") },
-    { 515, "fingerprint", 0, N_("show the fingerprints")},
-    { 517, "secret-keyring" ,2, N_("add this secret keyring to the list")},
-    { 518, "options"   , 2, N_("read options from file")},
-    { 519, "no-armor",   0, "\r"},
-    { 520, "no-default-keyring", 0, "\r" },
-    { 521, "list-packets",0,N_("list only the sequence of packets")},
-    { 522, "no-greeting", 0, "\r" },
-    { 523, "passphrase-fd",1, "\r" },
-    { 524, "edit-sig"  ,0, N_("edit a key signature")},
-    { 525, "change-passphrase", 0, N_("change the passphrase of your secret keyring")},
-    { 526, "no-verbose", 0, "\r"},
-    { 527, "cipher-algo", 2 , N_("select default cipher algorithm")},
-    { 528, "pubkey-algo", 2 , N_("select default puplic key algorithm")},
-    { 529, "digest-algo", 2 , N_("select default message digest algorithm")},
-    { 530, "import",      0 , N_("put public keys into the trustdb")},
-    { 532, "quick-random", 0, "\r"},
-    { 534, "no-comment", 0,   N_("do not write comment packets")},
-    { 535, "completes-needed", 1, N_("(default is 1)")},
-    { 536, "marginals-needed", 1, N_("(default is 3)")},
-    { 537, "export", 0, N_("export all or the given keys") },
-    { 538, "trustdb-name", 2, "\r" },
-    { 539, "clearsign", 0, N_("make a clear text signature") },
-    { 540, "no-secmem-warning", 0, "\r" }, /* used only by regression tests */
-    { 541, "no-operation", 0, "\r" },      /* used by regression tests */
-
-    {0} };
     ARGPARSE_ARGS pargs;
     IOBUF a;
     int rc=0;
@@ -236,6 +275,7 @@
      * secmem_init()  somewhere after the option parsing
      */
 
+    log_set_name("g10");
     i18n_init();
     opt.compress = -1; /* defaults to standard compress level */
     opt.def_cipher_algo = CIPHER_ALGO_BLOWFISH;
@@ -278,9 +318,11 @@
 		if( parse_debug )
 		log_info(_("note: no default option file '%s'\n"), configname );
 	    }
-	    else
-		log_fatal(_("option file '%s': %s\n"),
+	    else {
+		log_error(_("option file '%s': %s\n"),
 				    configname, strerror(errno) );
+		g10_exit(1);
+	    }
 	    m_free(configname); configname = NULL;
 	}
 	if( parse_debug && configname )
@@ -291,9 +333,7 @@
     while( optfile_parse( configfp, configname, &configlineno,
 						&pargs, opts) ) {
 	switch( pargs.r_opt ) {
-	  case 'v': opt.verbose++;
-		    opt.list_sigs=1;
-		    break;
+	  case 'v': opt.verbose++; opt.list_sigs=1; break;
 	  case 'z': opt.compress = pargs.r.ret_int; break;
 	  case 'a': opt.armor = 1; opt.no_armor=0; break;
 	  case 'd': break; /* it is default */
@@ -322,7 +362,8 @@
 	  case 503: set_cmd( &cmd, aKeygen); break;
 	  case 506: set_cmd( &cmd, aSignKey); break;
 	  case 507: set_cmd( &cmd, aStore); break;
-	  case 508: opt.check_sigs = 1; opt.list_sigs = 1; break;
+	  case 508: set_cmd( &cmd, aCheckKeys);
+		    opt.check_sigs = 1; opt.list_sigs = 1; break;
 	  case 509: add_keyring(pargs.r.ret_str); nrings++; break;
 	  case 510: opt.debug |= pargs.r.ret_ulong; break;
 	  case 511: opt.debug = ~0; break;
@@ -374,27 +415,8 @@
 	goto next_pass;
     }
     m_free( configname ); configname = NULL;
-    if( !opt.def_cipher_algo || check_cipher_algo(opt.def_cipher_algo) ) {
-	log_error(_("selected cipher algorithm is invalid\n"));
-	errors++;
-    }
-    if( !opt.def_pubkey_algo || check_pubkey_algo(opt.def_pubkey_algo) ) {
-	log_error(_("selected pubkey algorithm is invalid\n"));
-	errors++;
-    }
-    if( !opt.def_digest_algo || check_digest_algo(opt.def_digest_algo) ) {
-	log_error(_("selected digest algorithm is invalid\n"));
-	errors++;
-    }
-    if( opt.completes_needed < 1 ) {
-	log_error(_("completes-needed must be greater than 0\n"));
-	errors++;
-    }
-    if( opt.marginals_needed < 2 ) {
-	log_error(_("marginals-needed must be greater than 1\n"));
-	errors++;
-    }
-    if( errors )
+    check_opts();
+    if( log_get_errorcount(0) )
 	g10_exit(2);
 
     if( greeting ) {
@@ -541,6 +563,7 @@
 						       g10_errstr(rc) );
 	break;
 
+      case aCheckKeys:
       case aKMode: /* list keyring */
 	if( !argc ) { /* list the default public keyrings */
 	    int i, seq=0;
@@ -563,14 +586,23 @@
 	    }
 
 	}
+	else if( cmd == aCheckKeys ) {
+	    log_error("will be soon: --check-keys user-ids\n");
+	}
 	else if( argc == 1) { /* list the given keyring */
 	    if( !(a = iobuf_open(fname)) )
-		log_fatal(_("can't open '%s'\n"), fname_print);
-	    proc_packets( a );
-	    iobuf_close(a);
+		log_error(_("can't open '%s'\n"), fname_print);
+	    else {
+		if( !opt.no_armor ) {
+		    memset( &afx, 0, sizeof afx);
+		    iobuf_push_filter( a, armor_filter, &afx );
+		}
+		proc_packets( a );
+		iobuf_close(a);
+	    }
 	}
 	else
-	    wrong_args(_("-k[v][v][v][c] [keyring]"));
+	    wrong_args(_("-k[v][v][v][c] [keyring]") );
 	break;
 
       case aKeygen: /* generate a key (interactive) */
@@ -607,18 +639,20 @@
 	if( argc > 1 )
 	    wrong_args(_("[filename]"));
 	if( !(a = iobuf_open(fname)) )
-	    log_fatal(_("can't open '%s'\n"), fname_print);
-	if( !opt.no_armor ) {
-	    /* push the armor filter, so it can peek at the input data */
-	    memset( &afx, 0, sizeof afx);
-	    iobuf_push_filter( a, armor_filter, &afx );
-	}
-	if( cmd == aListPackets ) {
-	    set_packet_list_mode(1);
-	    opt.list_packets=1;
+	    log_error(_("can't open '%s'\n"), fname_print);
+	else {
+	    if( !opt.no_armor ) {
+		/* push the armor filter, so it can peek at the input data */
+		memset( &afx, 0, sizeof afx);
+		iobuf_push_filter( a, armor_filter, &afx );
+	    }
+	    if( cmd == aListPackets ) {
+		set_packet_list_mode(1);
+		opt.list_packets=1;
+	    }
+	    proc_packets( a );
+	    iobuf_close(a);
 	}
-	proc_packets( a );
-	iobuf_close(a);
 	break;
     }
 
diff -urN g10-0.2.5/g10/import.c g10-0.2.6/g10/import.c
--- g10-0.2.5/g10/import.c	Mon Jan 19 17:53:09 1998
+++ g10-0.2.6/g10/import.c	Fri Feb 13 14:35:06 1998
@@ -35,15 +35,34 @@
 
 
 /****************
- * Import the public keys from the given filename.
- * Import is a somewhat misleading name, as we (only) add informations
- * about the public keys into aout trustdb.
+ * Import the public keys from the given filename. Input may be armored.
+ * This function rejects alls keys which are not valid self signed on at
+ * least one userid. Only user ids which are self signed will be imported.
+ * Other signatures are not not checked.
+ *
+ * Actually this functtion does a merge, it works like this:
+ *   FIXME: add handling for revocation certs
+ *
+ *  - get the keyblock
+ *  - check self-signatures and remove all userids and their isgnatures
+ *    without/invalid self-signatures.
+ *  - reject the keyblock, if we have no valid userid.
+ *  - See wether we have this key already in one of our pubrings.
+ *    If not, simply add it to the default keyring.
+ *  - Compare the key and the self-signatures of the new and the one in
+ *    our keyring.  If they are differen something weird is going on;
+ *    ask what to do.
+ *  - See wether we have only non-self-signature on one user id; if not
+ *    ask the user what to do.
+ *  - compare the signatures: If we already have this signature, check
+ *    that they compare okay, if not issue a warning and ask the user.
+ *    (consider to look at the timestamp and use the newest?)
+ *  - Simply add the signature.  Can't verify here because we may not have
+ *    the signatures public key yet; verification is done when putting it
+ *    into the trustdb, which is done automagically as soon as this pubkey
+ *    is used.
+ *  - Proceed with next signature.
  *
- * NOTE: this function is not really needed and will be changed to
- *	a function which reads a plain textfile, describing a public
- *	key and its associated ownertrust.  This can be used (together
- *	with the export function) to make a backup of the assigned
- *	ownertrusts.
  */
 int
 import_pubkeys( const char *filename )
diff -urN g10-0.2.5/g10/kbnode.c g10-0.2.6/g10/kbnode.c
--- g10-0.2.5/g10/kbnode.c	Wed Feb 11 13:44:01 1998
+++ g10-0.2.6/g10/kbnode.c	Fri Feb 13 19:33:36 1998
@@ -177,11 +177,12 @@
     do {
 	if( !*context ) {
 	    *context = root;
-	    return root;
+	    n = root;
+	}
+	else {
+	    n = (*context)->next;
+	    *context = n;
 	}
-
-	n = (*context)->next;
-	*context = n;
     } while( !all && n && (n->private_flag & 1) );
 
     return n;
diff -urN g10-0.2.5/g10/keydb.h g10-0.2.6/g10/keydb.h
--- g10-0.2.5/g10/keydb.h	Tue Feb 10 22:12:21 1998
+++ g10-0.2.6/g10/keydb.h	Fri Feb 13 20:06:54 1998
@@ -51,6 +51,8 @@
     int   resno;     /* resource number */
     ulong offset;    /* position information */
     unsigned count;  /* length of the keyblock in packets */
+    IOBUF  fp;	     /* used by enum_keyblocks */
+    PACKET *pkt;     /* ditto */
 };
 typedef struct keyblock_pos_struct KBPOS;
 
@@ -144,6 +146,7 @@
 int lock_keyblock( KBPOS *kbpos );
 void unlock_keyblock( KBPOS *kbpos );
 int read_keyblock( KBPOS *kbpos, KBNODE *ret_root );
+int enum_keyblocks( int mode, KBPOS *kbpos, KBNODE *ret_root );
 int insert_keyblock( KBPOS *kbpos, KBNODE root );
 int delete_keyblock( KBPOS *kbpos );
 int update_keyblock( KBPOS *kbpos, KBNODE root );
diff -urN g10-0.2.5/g10/keygen.c g10-0.2.6/g10/keygen.c
--- g10-0.2.5/g10/keygen.c	Wed Feb 11 14:26:15 1998
+++ g10-0.2.6/g10/keygen.c	Fri Feb 13 19:31:44 1998
@@ -535,11 +535,11 @@
 
     /* we create the packets as a tree of kbnodes. Because the structure
      * we create is known in advance we simply generate a linked list
-     * The first packet is a comment packet, followed by the userid and
-     * the self signature.
+     * The first packet is a dummy comment packet which we flag
+     * as deleted.  The very first packet must always be a CERT packet.
      */
-    pub_root = make_comment_node("#created by G10 pre-release " VERSION );
-    sec_root = make_comment_node("#created by G10 pre-release " VERSION );
+    pub_root = make_comment_node("#"); delete_kbnode(pub_root, pub_root);
+    sec_root = make_comment_node("#"); delete_kbnode(sec_root, sec_root);
 
     tty_printf(_(
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
@@ -557,6 +557,12 @@
 	rc = gen_dsa(nbits, pub_root, sec_root, dek, &skc );
     else
 	BUG();
+    if( !rc ) {
+	add_kbnode( pub_root,
+		make_comment_node("#created by G10 release " VERSION ));
+	add_kbnode( sec_root,
+		make_comment_node("#created by G10 release " VERSION ));
+    }
     if( !rc )
 	write_uid(pub_root, uid );
     if( !rc )
diff -urN g10-0.2.5/g10/parse-packet.c g10-0.2.6/g10/parse-packet.c
--- g10-0.2.5/g10/parse-packet.c	Tue Feb 10 18:52:52 1998
+++ g10-0.2.6/g10/parse-packet.c	Fri Feb 13 16:20:17 1998
@@ -437,6 +437,7 @@
     if( k->pubkey_algo == PUBKEY_ALGO_ELGAMAL ) {
 	n = pktlen;
 	k->d.elg.a = mpi_read(inp, &n, 0); pktlen -=n;
+	n = pktlen;
 	k->d.elg.b = mpi_read(inp, &n, 0 ); pktlen -=n;
 	if( list_mode ) {
 	    printf("\telg a: ");
@@ -502,6 +503,7 @@
 	sig->d.elg.digest_start[1] = iobuf_get_noeof(inp); pktlen--;
 	n = pktlen;
 	sig->d.elg.a = mpi_read(inp, &n, 0 ); pktlen -=n;
+	n = pktlen;
 	sig->d.elg.b = mpi_read(inp, &n, 0 ); pktlen -=n;
 	if( list_mode ) {
 	    printf("\tdigest algo %d, begin of digest %02x %02x\n",
diff -urN g10-0.2.5/g10/pubkey-enc.c g10-0.2.6/g10/pubkey-enc.c
--- g10-0.2.5/g10/pubkey-enc.c	Wed Jan  7 18:16:49 1998
+++ g10-0.2.6/g10/pubkey-enc.c	Thu Feb 12 22:24:03 1998
@@ -38,8 +38,10 @@
 int
 get_session_key( PKT_pubkey_enc *k, DEK *dek )
 {
-    int i, j, c, rc = 0;
-    MPI dek_frame = mpi_alloc_secure(40);
+    int rc = 0;
+    MPI plain_dek  = NULL;
+    byte *frame = NULL;
+    unsigned n, nframe;
     u16 csum, csum2;
     PKT_secret_cert *skc = m_alloc_clear( sizeof *skc );
 
@@ -58,7 +60,8 @@
 	skey.g = skc->d.elg.g;
 	skey.y = skc->d.elg.y;
 	skey.x = skc->d.elg.x;
-	elg_decrypt( dek_frame, k->d.elg.a, k->d.elg.b, &skey );
+	plain_dek = mpi_alloc_secure( mpi_get_nlimbs(skey.p) );
+	elg_decrypt( plain_dek, k->d.elg.a, k->d.elg.b, &skey );
 	memset( &skey, 0, sizeof skey );
     }
   #ifdef HAVE_RSA_CIPHER
@@ -74,7 +77,8 @@
 	skey.q = skc->d.rsa.rsa_q;
 	skey.d = skc->d.rsa.rsa_d;
 	skey.u = skc->d.rsa.rsa_u;
-	rsa_secret( dek_frame, k->d.rsa.rsa_integer, &skey );
+	plain_dek = mpi_alloc_secure( mpi_get_nlimbs(skey.n) );
+	rsa_secret( plain_dek, k->d.rsa.rsa_integer, &skey );
 	memset( &skey, 0, sizeof skey );
     }
   #endif/*HAVE_RSA_CIPHER*/
@@ -83,9 +87,10 @@
 	goto leave;
     }
     free_secret_cert( skc ); skc = NULL;
+    frame = mpi_get_buffer( plain_dek, &nframe, NULL );
+    mpi_free( plain_dek ); plain_dek = NULL;
 
-
-    /* Now get the DEK (data encryption key) from the dek_frame
+    /* Now get the DEK (data encryption key) from the frame
      *
      * Old versions encode the DEK in in this format (msb is left):
      *
@@ -101,51 +106,53 @@
      * CSUM
      */
     if( DBG_CIPHER )
-	log_mpidump("DEK frame:", dek_frame );
-    for(i=0; mpi_getbyte(dek_frame, i) != -1; i++ )
+	log_hexdump("DEK frame:", frame, nframe );
+    for(n=0; n < nframe && !frame[n]; n++ ) /* skip leading zeroes */
 	;
-    for(i--; i >= 0 && !(c=mpi_getbyte(dek_frame, i)); i--)
-	; /* Skip leading zeroes */
-    if( i < 16 )
+    if( n + 7 > nframe )
 	{ rc = G10ERR_WRONG_SECKEY; goto leave; }
-    if( c == 1 && mpi_getbyte(dek_frame,0) == 2 ) {
+    if( frame[n] == 1 && frame[nframe-1] == 2 ) {
 	log_error("old encoding of DEK is not supported\n");
 	rc = G10ERR_CIPHER_ALGO;
 	goto leave;
     }
-    if( c != 2 )  /* somethink is wrong */
+    if( frame[n] != 2 )  /* somethink is wrong */
 	{ rc = G10ERR_WRONG_SECKEY; goto leave; }
-    /* look for the zero byte */
-    for(i--; i > 4 ; i-- )
-	if( !mpi_getbyte(dek_frame,i) )
-	    break;
-    if( i <= 4 ) /* zero byte not found */
+    for(n++; n < nframe && frame[n]; n++ ) /* skip the random bytes */
+	;
+    n++; /* and the zero byte */
+    if( n + 4 > nframe )
 	{ rc = G10ERR_WRONG_SECKEY; goto leave; }
-    /* next byte indicates the used cipher */
-    switch( mpi_getbyte(dek_frame, --i ) ) {
+
+    dek->keylen = nframe - (n+1) - 2;
+    dek->algo = frame[n++];
+    switch( dek->algo ) {
       case CIPHER_ALGO_IDEA:
 	rc = G10ERR_NI_CIPHER;
 	goto leave;
       case CIPHER_ALGO_BLOWFISH:
-	if( i != 22 ) /* length of blowfish is 20 (+2 bytes checksum) */
+	if( dek->keylen != 20 )
 	    { rc = G10ERR_WRONG_SECKEY; goto leave; }
-	dek->algo = CIPHER_ALGO_BLOWFISH;
 	break;
       case CIPHER_ALGO_BLOWFISH128:
-	if( i != 18 ) /* length of blowfish-128 is 16 (+2 bytes checksum) */
+	if( dek->keylen != 16 )
+	    { rc = G10ERR_WRONG_SECKEY; goto leave; }
+	break;
+      case CIPHER_ALGO_CAST:
+	if( dek->keylen < 5 || dek->keylen > 16 )
 	    { rc = G10ERR_WRONG_SECKEY; goto leave; }
-	dek->algo = CIPHER_ALGO_BLOWFISH128;
 	break;
       default:
+	dek->algo = 0;
 	rc = G10ERR_CIPHER_ALGO;
 	goto leave;
     }
     /* copy the key to DEK and compare the checksum */
-    csum  = mpi_getbyte(dek_frame, 1) << 8;
-    csum |= mpi_getbyte(dek_frame, 0);
-    dek->keylen = i - 2;
-    for( i--, csum2=0, j=0; i > 1; i-- )
-	csum2 += dek->key[j++] = mpi_getbyte(dek_frame, i);
+    csum  = frame[nframe-2] << 8;
+    csum |= frame[nframe-1];
+    memcpy( dek->key, frame+n, dek->keylen );
+    for( csum2=0, n=0; n < dek->keylen; n++ )
+	csum2 += dek->key[n];
     if( csum != csum2 ) {
 	rc = G10ERR_WRONG_SECKEY;
 	goto leave;
@@ -154,7 +161,8 @@
 	log_hexdump("DEK is:", dek->key, dek->keylen );
 
   leave:
-    mpi_free(dek_frame);
+    mpi_free(plain_dek);
+    m_free(frame);
     if( skc )
 	free_secret_cert( skc );
     return rc;
diff -urN g10-0.2.5/g10/ringedit.c g10-0.2.6/g10/ringedit.c
--- g10-0.2.5/g10/ringedit.c	Tue Feb 10 22:48:27 1998
+++ g10-0.2.6/g10/ringedit.c	Fri Feb 13 21:01:23 1998
@@ -77,6 +77,7 @@
 static int keyring_search2( PUBKEY_FIND_INFO info, KBPOS *kbpos,
 						   const char *fname);
 static int keyring_read( KBPOS *kbpos, KBNODE *ret_root );
+static int keyring_enum( KBPOS *kbpos, KBNODE *ret_root );
 static int keyring_copy( KBPOS *kbpos, int mode, KBNODE root );
 
 
@@ -297,6 +298,78 @@
     return keyring_read( kbpos, ret_root );
 }
 
+
+/****************
+ * This functions can be used to read trough a complete keyring.
+ * Mode is: 0 = open
+ *	    1 = read
+ *	    2 = close
+ *	    all others are reserved!
+ * Note that you do not need a search prior to call this function,
+ * only handle is needed.
+ * NOTE: It is not alloed to do an insert/update/delte with this
+ *	 keyblock, if you want to do this, user search/read!
+ */
+int
+enum_keyblocks( int mode, KBPOS *kbpos, KBNODE *ret_root )
+{
+    int rc = 0;
+    RESTBL *rentry;
+
+    if( !mode || mode == 100 ) {
+	int i;
+	kbpos->fp = NULL;
+	if( !mode )
+	    i = 0;
+	else
+	    i = kbpos->resno+1;
+	for(; i < MAX_RESOURCES; i++ )
+	    if( resource_table[i].used && !resource_table[i].secret )
+		break;
+	if( i == MAX_RESOURCES )
+	    return -1; /* no resources */
+	kbpos->resno = i;
+	rentry = check_pos( kbpos );
+	kbpos->fp = iobuf_open( rentry->fname );
+	if( !kbpos->fp ) {
+	    log_error("can't open '%s'\n", rentry->fname );
+	    return G10ERR_OPEN_FILE;
+	}
+	kbpos->pkt = NULL;
+    }
+    else if( mode == 1 ) {
+	int cont;
+	do {
+	    cont = 0;
+	    if( !kbpos->fp )
+		return G10ERR_GENERAL;
+	    rc = keyring_enum( kbpos, ret_root );
+	    if( rc == -1 ) {
+		assert( !kbpos->pkt );
+		rentry = check_pos( kbpos );
+		assert(rentry);
+		/* close */
+		enum_keyblocks(2, kbpos, ret_root );
+		/* and open the next one */
+		rc = enum_keyblocks(100, kbpos, ret_root );
+		if( !rc )
+		    cont = 1;
+	    }
+	} while(cont);
+    }
+    else if( kbpos->fp ) {
+	iobuf_close( kbpos->fp );
+	kbpos->fp = NULL;
+	/* release pending packet */
+	free_packet( kbpos->pkt );
+	m_free( kbpos->pkt );
+    }
+    return rc;
+}
+
+
+
+
 /****************
  * Insert the keyblock described by ROOT into the keyring described
  * by KBPOS.  This actually appends the data to the keyfile.
@@ -551,9 +624,8 @@
 
     if( rc )
 	release_kbnode( root );
-    else {
+    else
 	*ret_root = root;
-    }
     free_packet( pkt );
     m_free( pkt );
     iobuf_close(a);
@@ -561,6 +633,69 @@
 }
 
 
+static int
+keyring_enum( KBPOS *kbpos, KBNODE *ret_root )
+{
+    PACKET *pkt;
+    int rc;
+    RESTBL *rentry;
+    KBNODE root = NULL;
+    int in_cert = 0;
+
+    if( !(rentry=check_pos(kbpos)) )
+	return G10ERR_GENERAL;
+
+    if( kbpos->pkt ) {
+	root = new_kbnode( kbpos->pkt );
+	kbpos->pkt = NULL;
+    }
+
+    pkt = m_alloc( sizeof *pkt );
+    init_packet(pkt);
+    while( (rc=parse_packet(kbpos->fp, pkt)) != -1 ) {
+	if( rc ) {  /* ignore errors */
+	    if( rc != G10ERR_UNKNOWN_PACKET ) {
+		log_error("read_keyblock: read error: %s\n", g10_errstr(rc) );
+		rc = G10ERR_INV_KEYRING;
+		goto ready;
+	    }
+	    free_packet( pkt );
+	    continue;
+	}
+	/* make a linked list of all packets */
+	switch( pkt->pkttype ) {
+	  case PKT_PUBLIC_CERT:
+	  case PKT_SECRET_CERT:
+	    if( in_cert ) { /* store this packet */
+		kbpos->pkt = pkt;
+		pkt = NULL;
+		goto ready;
+	    }
+	    in_cert = 1;
+	  default:
+	    if( !root )
+		root = new_kbnode( pkt );
+	    else
+		add_kbnode( root, new_kbnode( pkt ) );
+	    pkt = m_alloc( sizeof *pkt );
+	    init_packet(pkt);
+	    break;
+	}
+    }
+  ready:
+    if( rc == -1 && root )
+	rc = 0;
+
+    if( rc )
+	release_kbnode( root );
+    else
+	*ret_root = root;
+    free_packet( pkt );
+    m_free( pkt );
+    return rc;
+}
+
+
 
 /****************
  * Peromf insert/delete/update operation.
@@ -579,6 +714,8 @@
 
     if( !(rentry = check_pos( kbpos )) )
 	return G10ERR_GENERAL;
+    if( kbpos->fp )
+	BUG(); /* not allowed with such a handle */
 
     /* open the source file */
     fp = iobuf_open( rentry->fname );
diff -urN g10-0.2.5/g10/sign.c g10-0.2.6/g10/sign.c
--- g10-0.2.5/g10/sign.c	Wed Feb 11 22:50:53 1998
+++ g10-0.2.6/g10/sign.c	Fri Feb 13 20:48:14 1998
@@ -796,14 +796,14 @@
     /* search the userid */
     rc = find_keyblock_byname( &kbpos, username );
     if( rc ) {
-	log_error("user '%s' not found\n", username );
+	log_error("%s: user not found\n", username );
 	goto leave;
     }
 
     /* read the keyblock */
     rc = read_keyblock( &kbpos, &keyblock );
     if( rc ) {
-	log_error("error reading the certificate: %s\n", g10_errstr(rc) );
+	log_error("%s: certificate read problem: %s\n", username, g10_errstr(rc) );
 	goto leave;
     }
 
diff -urN g10-0.2.5/include/distfiles g10-0.2.6/include/distfiles
--- g10-0.2.5/include/distfiles	Mon Jan 26 17:49:20 1998
+++ g10-0.2.6/include/distfiles	Fri Feb 13 13:21:07 1998
@@ -8,3 +8,4 @@
 util.h
 i18n.h
 
+ChangeLog
diff -urN g10-0.2.5/include/util.h g10-0.2.6/include/util.h
--- g10-0.2.5/include/util.h	Wed Feb 11 01:31:27 1998
+++ g10-0.2.6/include/util.h	Fri Feb 13 14:54:09 1998
@@ -56,14 +56,14 @@
 } ARGPARSE_OPTS;
 
 /*-- logger.c --*/
+void log_set_name( const char *name );
+const char *log_get_name(void);
 void log_set_pid( int pid );
 int  log_get_errorcount( int clear );
 void log_hexdump( const char *text, char *buf, size_t len );
 void log_mpidump( const char *text, MPI a );
 
 #if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 5 )
-  void printstr( int level, const char *fmt, ... )
-			    __attribute__ ((format (printf,2,3)));
   void log_bug( const char *fmt, ... )
 			    __attribute__ ((noreturn, format (printf,1,2)));
   void log_bug0( const char *, int, const char * ) __attribute__ ((noreturn));
@@ -74,7 +74,6 @@
   void log_debug( const char *fmt, ... ) __attribute__ ((format (printf,1,2)));
   #define BUG() log_bug0(  __FILE__ , __LINE__, __FUNCTION__ )
 #else
-  void printstr( int level, const char *fmt, ... );
   void log_bug( const char *fmt, ... );
   void log_bug0( const char *, int );
   void log_fatal( const char *fmt, ... );
diff -urN g10-0.2.5/mpi/ChangeLog g10-0.2.6/mpi/ChangeLog
--- g10-0.2.5/mpi/ChangeLog	Tue Feb 10 11:57:29 1998
+++ g10-0.2.6/mpi/ChangeLog	Fri Feb 13 13:18:43 1998
@@ -1,5 +0,0 @@
-Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
-
-	* ddd/hhhh:
-
-
diff -urN g10-0.2.5/mpi/Makefile.in g10-0.2.6/mpi/Makefile.in
--- g10-0.2.5/mpi/Makefile.in	Thu Feb 12 14:34:49 1998
+++ g10-0.2.6/mpi/Makefile.in	Fri Feb 13 21:27:32 1998
@@ -85,7 +85,6 @@
 RANLIB = @RANLIB@
 VERSION = @VERSION@
 ZLIBS = @ZLIBS@
-ZLIB_SUBDIR = @ZLIB_SUBDIR@
 
 INCLUDES =  -I$(top_srcdir)/include
 
diff -urN g10-0.2.5/mpi/config.links g10-0.2.6/mpi/config.links
--- g10-0.2.5/mpi/config.links	Wed Feb 11 04:06:06 1998
+++ g10-0.2.6/mpi/config.links	Thu Feb 12 20:24:15 1998
@@ -37,7 +37,7 @@
 	;;
     hppa7000*-*-*)
 	echo '/* configured for HPPA (pa7000) */' >>./mpi/asm-syntax.h
-	path="hppa1_1 hppa"
+	path="hppa1.1 hppa"
 	mpi_extra_modules="udiv-qrnnd"
 	;;
     hppa1.0*-*-*)
@@ -47,7 +47,7 @@
 	;;
     hppa*-*-*)	# assume pa7100
 	echo '/* configured for HPPA (pa7100) */' >>./mpi/asm-syntax.h
-	path="pa7100 hppa1_1 hppa"
+	path="pa7100 hppa1.1 hppa"
 	mpi_extra_modules="udiv-qrnnd"
 	;;
     sparc9*-*-* | sparc64*-*-* | ultrasparc*-*-*)
diff -urN g10-0.2.5/mpi/hppa/README g10-0.2.6/mpi/hppa/README
--- g10-0.2.5/mpi/hppa/README	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/hppa/README	Mon Dec 22 21:28:13 1997
@@ -0,0 +1,84 @@
+This directory contains mpn functions for various HP PA-RISC chips.  Code
+that runs faster on the PA7100 and later implementations, is in the pa7100
+directory.
+
+RELEVANT OPTIMIZATION ISSUES
+
+  Load and Store timing
+
+On the PA7000 no memory instructions can issue the two cycles after a store.
+For the PA7100, this is reduced to one cycle.
+
+The PA7100 has a lookup-free cache, so it helps to schedule loads and the
+dependent instruction really far from each other.
+
+STATUS
+
+1. mpn_mul_1 could be improved to 6.5 cycles/limb on the PA7100, using the
+   instructions bwlow (but some sw pipelining is needed to avoid the
+   xmpyu-fstds delay):
+
+	fldds	s1_ptr
+
+	xmpyu
+	fstds	N(%r30)
+	xmpyu
+	fstds	N(%r30)
+
+	ldws	N(%r30)
+	ldws	N(%r30)
+	ldws	N(%r30)
+	ldws	N(%r30)
+
+	addc
+	stws	res_ptr
+	addc
+	stws	res_ptr
+
+	addib	Loop
+
+2. mpn_addmul_1 could be improved from the current 10 to 7.5 cycles/limb
+   (asymptotically) on the PA7100, using the instructions below.  With proper
+   sw pipelining and the unrolling level below, the speed becomes 8
+   cycles/limb.
+
+	fldds	s1_ptr
+	fldds	s1_ptr
+
+	xmpyu
+	fstds	N(%r30)
+	xmpyu
+	fstds	N(%r30)
+	xmpyu
+	fstds	N(%r30)
+	xmpyu
+	fstds	N(%r30)
+
+	ldws	N(%r30)
+	ldws	N(%r30)
+	ldws	N(%r30)
+	ldws	N(%r30)
+	ldws	N(%r30)
+	ldws	N(%r30)
+	ldws	N(%r30)
+	ldws	N(%r30)
+	addc
+	addc
+	addc
+	addc
+	addc	%r0,%r0,cy-limb
+
+	ldws	res_ptr
+	ldws	res_ptr
+	ldws	res_ptr
+	ldws	res_ptr
+	add
+	stws	res_ptr
+	addc
+	stws	res_ptr
+	addc
+	stws	res_ptr
+	addc
+	stws	res_ptr
+
+	addib
diff -urN g10-0.2.5/mpi/hppa/distfiles g10-0.2.6/mpi/hppa/distfiles
--- g10-0.2.5/mpi/hppa/distfiles	Tue Dec 23 18:04:23 1997
+++ g10-0.2.6/mpi/hppa/distfiles	Thu Feb 12 20:16:58 1998
@@ -1,4 +1,6 @@
-
-mpih-add1.S
+README
 udiv-qrnnd.S
+mpih-add1.S
+mpih-sub1.S
+mpih-shift.S
 
diff -urN g10-0.2.5/mpi/hppa/mpih-shift.S g10-0.2.6/mpi/hppa/mpih-shift.S
--- g10-0.2.5/mpi/hppa/mpih-shift.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/hppa/mpih-shift.S	Thu Feb 12 20:16:22 1998
@@ -0,0 +1,124 @@
+/* hppa   rshift, lshift
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(gr26)
+ *		   mpi_ptr_t up,	(gr25)
+ *		   mpi_size_t usize,	(gr24)
+ *		   unsigned cnt)	(gr23)
+ */
+
+	.code
+	.export 	mpihelp_lshift
+mpihelp_lshift
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	sh2add		%r24,%r25,%r25
+	sh2add		%r24,%r26,%r26
+	ldws,mb 	-4(0,%r25),%r22
+	subi		32,%r23,%r1
+	mtsar		%r1
+	addib,= 	-1,%r24,L$0004
+	vshd		%r0,%r22,%r28		; compute carry out limb
+	ldws,mb 	-4(0,%r25),%r29
+	addib,= 	-1,%r24,L$0002
+	vshd		%r22,%r29,%r20
+
+L$loop	ldws,mb 	-4(0,%r25),%r22
+	stws,mb 	%r20,-4(0,%r26)
+	addib,= 	-1,%r24,L$0003
+	vshd		%r29,%r22,%r20
+	ldws,mb 	-4(0,%r25),%r29
+	stws,mb 	%r20,-4(0,%r26)
+	addib,<>	-1,%r24,L$loop
+	vshd		%r22,%r29,%r20
+
+L$0002	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r29,%r0,%r20
+	bv		0(%r2)
+	stw		%r20,-4(0,%r26)
+L$0003	stws,mb 	%r20,-4(0,%r26)
+L$0004	vshd		%r22,%r0,%r20
+	bv		0(%r2)
+	stw		%r20,-4(0,%r26)
+
+	.exit
+	.procend
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,       (gr26)
+ *		   mpi_ptr_t up,       (gr25)
+ *		   mpi_size_t usize,   (gr24)
+ *		   unsigned cnt)       (gr23)
+ */
+
+	.code
+	.export 	mpihelp_rshift
+mpihelp_rshift
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	ldws,ma 	4(0,%r25),%r22
+	mtsar		%r23
+	addib,= 	-1,%r24,L$r004
+	vshd		%r22,%r0,%r28		; compute carry out limb
+	ldws,ma 	4(0,%r25),%r29
+	addib,= 	-1,%r24,L$r002
+	vshd		%r29,%r22,%r20
+
+L$roop	ldws,ma 	4(0,%r25),%r22
+	stws,ma 	%r20,4(0,%r26)
+	addib,= 	-1,%r24,L$r003
+	vshd		%r22,%r29,%r20
+	ldws,ma 	4(0,%r25),%r29
+	stws,ma 	%r20,4(0,%r26)
+	addib,<>	-1,%r24,L$roop
+	vshd		%r29,%r22,%r20
+
+L$r002	stws,ma 	%r20,4(0,%r26)
+	vshd		%r0,%r29,%r20
+	bv		0(%r2)
+	stw		%r20,0(0,%r26)
+L$r003	stws,ma 	%r20,4(0,%r26)
+L$r004	vshd		%r0,%r22,%r20
+	bv		0(%r2)
+	stw		%r20,0(0,%r26)
+
+	.exit
+	.procend
+
diff -urN g10-0.2.5/mpi/hppa/mpih-sub1.S g10-0.2.6/mpi/hppa/mpih-sub1.S
--- g10-0.2.5/mpi/hppa/mpih-sub1.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/hppa/mpih-sub1.S	Thu Feb 12 20:10:21 1998
@@ -0,0 +1,77 @@
+/* hppa   sub_n -- Sub two limb vectors of the same length > 0 and store
+ *		   sum in a third limb vector.
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *	Copyright (c) 1998 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ *  mpi_limb_t
+ *  mpihelp_sub_n( mpi_ptr_t res_ptr,	(gr26)
+ *		   mpi_ptr_t s1_ptr,	(gr25)
+ *		   mpi_ptr_t s2_ptr,	(gr24)
+ *		   mpi_size_t size)	(gr23)
+ *
+ * One might want to unroll this as for other processors, but it turns
+ * out that the data cache contention after a store makes such
+ * unrolling useless.  We can't come under 5 cycles/limb anyway.
+ */
+
+
+	.code
+	.export 	mpihelp_sub_n
+mpihelp_sub_n
+	.proc
+	.callinfo	frame=0,no_calls
+	.entry
+
+	ldws,ma 	4(0,%r25),%r20
+	ldws,ma 	4(0,%r24),%r19
+
+	addib,= 	-1,%r23,L$end	; check for (SIZE == 1)
+	 sub		%r20,%r19,%r28	; subtract first limbs ignoring cy
+
+L$loop	ldws,ma 	4(0,%r25),%r20
+	ldws,ma 	4(0,%r24),%r19
+	stws,ma 	%r28,4(0,%r26)
+	addib,<>	-1,%r23,L$loop
+	 subb		%r20,%r19,%r28
+
+L$end	stws		%r28,0(0,%r26)
+	addc		%r0,%r0,%r28
+	bv		0(%r2)
+	 subi		1,%r28,%r28
+
+	.exit
+	.procend
+
+
+
diff -urN g10-0.2.5/mpi/hppa1.1/distfiles g10-0.2.6/mpi/hppa1.1/distfiles
--- g10-0.2.5/mpi/hppa1.1/distfiles	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/hppa1.1/distfiles	Thu Feb 12 20:43:39 1998
@@ -0,0 +1,5 @@
+udiv-qrnnd.S
+mpih-mul1.S
+mpih-mul2.S
+mpih-mul3.S
+
diff -urN g10-0.2.5/mpi/hppa1.1/mpih-mul1.S g10-0.2.6/mpi/hppa1.1/mpih-mul1.S
--- g10-0.2.5/mpi/hppa1.1/mpih-mul1.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/hppa1.1/mpih-mul1.S	Thu Feb 12 20:37:06 1998
@@ -0,0 +1,112 @@
+/* hppa1.1  mul_1 -- Multiply a limb vector with a limb and store
+ *		     the result in a second limb vector.
+ *	Copyright (C) 1992, 1993, 1994 Free Software Foundation, Inc.
+ *	Copyright (c) 1998 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_mul_1( mpi_ptr_t res_ptr,	(r26)
+ *		  mpi_ptr_t s1_ptr,	(r25)
+ *		  mpi_size_t s1_size,	(r24)
+ *		  mpi_limb_t s2_limb)	(r23)
+ *
+ *
+ *
+ * This runs at 9 cycles/limb on a PA7000.  With the used instructions, it can
+ * not become faster due to data cache contention after a store.  On the
+ * PA7100 it runs at 7 cycles/limb, and that can not be improved either, since
+ * only the xmpyu does not need the integer pipeline, so the only dual-issue
+ * we will get are addc+xmpyu.	Unrolling would not help either CPU.
+ *
+ * We could use fldds to read two limbs at a time from the S1 array, and that
+ * could bring down the times to 8.5 and 6.5 cycles/limb for the PA7000 and
+ * PA7100, respectively.  We don't do that since it does not seem worth the
+ * (alignment) troubles...
+ *
+ * At least the PA7100 is rumored to be able to deal with cache-misses
+ * without stalling instruction issue.	If this is true, and the cache is
+ * actually also lockup-free, we should use a deeper software pipeline, and
+ * load from S1 very early!  (The loads and stores to -12(sp) will surely be
+ * in the cache.)
+ */
+
+	.code
+	.export 	mpihelp_mul_1
+mpihelp_mul_1
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	ldo		64(%r30),%r30
+	fldws,ma	4(%r25),%fr5
+	stw		%r23,-16(%r30)		; move s2_limb ...
+	addib,= 	-1,%r24,L$just_one_limb
+	 fldws		-16(%r30),%fr4		; ... into fr4
+	add		%r0,%r0,%r0		; clear carry
+	xmpyu		%fr4,%fr5,%fr6
+	fldws,ma	4(%r25),%fr7
+	fstds		%fr6,-16(%r30)
+	xmpyu		%fr4,%fr7,%fr8
+	ldw		-12(%r30),%r19		; least significant limb in product
+	ldw		-16(%r30),%r28
+
+	fstds		%fr8,-16(%r30)
+	addib,= 	-1,%r24,L$end
+	 ldw		-12(%r30),%r1
+
+; Main loop
+L$loop	fldws,ma	4(%r25),%fr5
+	stws,ma 	%r19,4(%r26)
+	addc		%r28,%r1,%r19
+	xmpyu		%fr4,%fr5,%fr6
+	ldw		-16(%r30),%r28
+	fstds		%fr6,-16(%r30)
+	addib,<>	-1,%r24,L$loop
+	 ldw		-12(%r30),%r1
+
+L$end	stws,ma 	%r19,4(%r26)
+	addc		%r28,%r1,%r19
+	ldw		-16(%r30),%r28
+	stws,ma 	%r19,4(%r26)
+	addc		%r0,%r28,%r28
+	bv		0(%r2)
+	 ldo		-64(%r30),%r30
+
+L$just_one_limb
+	xmpyu		%fr4,%fr5,%fr6
+	fstds		%fr6,-16(%r30)
+	ldw		-16(%r30),%r28
+	ldo		-64(%r30),%r30
+	bv		0(%r2)
+	 fstws		%fr6R,0(%r26)
+
+	.exit
+	.procend
+
+
diff -urN g10-0.2.5/mpi/hppa1.1/mpih-mul2.S g10-0.2.6/mpi/hppa1.1/mpih-mul2.S
--- g10-0.2.5/mpi/hppa1.1/mpih-mul2.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/hppa1.1/mpih-mul2.S	Thu Feb 12 20:40:17 1998
@@ -0,0 +1,114 @@
+/* hppa1.1   addmul_1 -- Multiply a limb vector with a limb and add
+ *			 the result to a second limb vector.
+ *	Copyright (C) 1992, 1993, 1994 Free Software Foundation, Inc.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_addmul_1( mpi_ptr_t res_ptr,      (r26)
+ *		     mpi_ptr_t s1_ptr,	     (r25)
+ *		     mpi_size_t s1_size,     (r24)
+ *		     mpi_limb_t s2_limb)     (r23)
+ *
+ * This runs at 11 cycles/limb on a PA7000.  With the used instructions, it
+ * can not become faster due to data cache contention after a store.  On the
+ * PA7100 it runs at 10 cycles/limb, and that can not be improved either,
+ * since only the xmpyu does not need the integer pipeline, so the only
+ * dual-issue we will get are addc+xmpyu.  Unrolling could gain a cycle/limb
+ * on the PA7100.
+ *
+ * There are some ideas described in mul1.S that applies to this code too.
+ */
+
+	.code
+	.export 	mpihelp_addmul_1
+mpihelp_addmul_1
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	ldo		64(%r30),%r30
+	fldws,ma	4(%r25),%fr5
+	stw		%r23,-16(%r30)		; move s2_limb ...
+	addib,= 	-1,%r24,L$just_one_limb
+	 fldws		-16(%r30),%fr4		; ... into fr4
+	add		%r0,%r0,%r0		; clear carry
+	xmpyu		%fr4,%fr5,%fr6
+	fldws,ma	4(%r25),%fr7
+	fstds		%fr6,-16(%r30)
+	xmpyu		%fr4,%fr7,%fr8
+	ldw		-12(%r30),%r19		; least significant limb in product
+	ldw		-16(%r30),%r28
+
+	fstds		%fr8,-16(%r30)
+	addib,= 	-1,%r24,L$end
+	 ldw		-12(%r30),%r1
+
+; Main loop
+L$loop	ldws		0(%r26),%r29
+	fldws,ma	4(%r25),%fr5
+	add		%r29,%r19,%r19
+	stws,ma 	%r19,4(%r26)
+	addc		%r28,%r1,%r19
+	xmpyu		%fr4,%fr5,%fr6
+	ldw		-16(%r30),%r28
+	fstds		%fr6,-16(%r30)
+	addc		%r0,%r28,%r28
+	addib,<>	-1,%r24,L$loop
+	 ldw		-12(%r30),%r1
+
+L$end	ldw		0(%r26),%r29
+	add		%r29,%r19,%r19
+	stws,ma 	%r19,4(%r26)
+	addc		%r28,%r1,%r19
+	ldw		-16(%r30),%r28
+	ldws		0(%r26),%r29
+	addc		%r0,%r28,%r28
+	add		%r29,%r19,%r19
+	stws,ma 	%r19,4(%r26)
+	addc		%r0,%r28,%r28
+	bv		0(%r2)
+	 ldo		-64(%r30),%r30
+
+L$just_one_limb
+	xmpyu		%fr4,%fr5,%fr6
+	ldw		0(%r26),%r29
+	fstds		%fr6,-16(%r30)
+	ldw		-12(%r30),%r1
+	ldw		-16(%r30),%r28
+	add		%r29,%r1,%r19
+	stw		%r19,0(%r26)
+	addc		%r0,%r28,%r28
+	bv		0(%r2)
+	 ldo		-64(%r30),%r30
+
+	.exit
+	.procend
+
+
diff -urN g10-0.2.5/mpi/hppa1.1/mpih-mul3.S g10-0.2.6/mpi/hppa1.1/mpih-mul3.S
--- g10-0.2.5/mpi/hppa1.1/mpih-mul3.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/hppa1.1/mpih-mul3.S	Thu Feb 12 20:43:19 1998
@@ -0,0 +1,124 @@
+/* hppa1.1   submul_1 -- Multiply a limb vector with a limb and add
+ *			 the result to a second limb vector.
+ *	Copyright (C) 1992, 1993, 1994 Free Software Foundation, Inc.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_submul_1( mpi_ptr_t res_ptr,      (r26)
+ *		     mpi_ptr_t s1_ptr,	     (r25)
+ *		     mpi_size_t s1_size,     (r24)
+ *		     mpi_limb_t s2_limb)     (r23)
+ *
+ *
+ * This runs at 12 cycles/limb on a PA7000.  With the used instructions, it
+ * can not become faster due to data cache contention after a store.  On the
+ * PA7100 it runs at 11 cycles/limb, and that can not be improved either,
+ * since only the xmpyu does not need the integer pipeline, so the only
+ * dual-issue we will get are addc+xmpyu.  Unrolling could gain a cycle/limb
+ * on the PA7100.
+ *
+ * There are some ideas described in mul1.S that applies to this code too.
+ *
+ * It seems possible to make this run as fast as addmul_1, if we use
+ *	 sub,>>= %r29,%r19,%r22
+ *	 addi	 1,%r28,%r28
+ * but that requires reworking the hairy software pipeline...
+ */
+
+
+	.code
+	.export 	mpihelp_submul_1
+mpihelp_submul_1
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	ldo		64(%r30),%r30
+	fldws,ma	4(%r25),%fr5
+	stw		%r23,-16(%r30)		; move s2_limb ...
+	addib,= 	-1,%r24,L$just_one_limb
+	 fldws		-16(%r30),%fr4		; ... into fr4
+	add		%r0,%r0,%r0		; clear carry
+	xmpyu		%fr4,%fr5,%fr6
+	fldws,ma	4(%r25),%fr7
+	fstds		%fr6,-16(%r30)
+	xmpyu		%fr4,%fr7,%fr8
+	ldw		-12(%r30),%r19		; least significant limb in product
+	ldw		-16(%r30),%r28
+
+	fstds		%fr8,-16(%r30)
+	addib,= 	-1,%r24,L$end
+	 ldw		-12(%r30),%r1
+
+; Main loop
+L$loop	ldws		0(%r26),%r29
+	fldws,ma	4(%r25),%fr5
+	sub		%r29,%r19,%r22
+	add		%r22,%r19,%r0
+	stws,ma 	%r22,4(%r26)
+	addc		%r28,%r1,%r19
+	xmpyu		%fr4,%fr5,%fr6
+	ldw		-16(%r30),%r28
+	fstds		%fr6,-16(%r30)
+	addc		%r0,%r28,%r28
+	addib,<>	-1,%r24,L$loop
+	 ldw		-12(%r30),%r1
+
+L$end	ldw		0(%r26),%r29
+	sub		%r29,%r19,%r22
+	add		%r22,%r19,%r0
+	stws,ma 	%r22,4(%r26)
+	addc		%r28,%r1,%r19
+	ldw		-16(%r30),%r28
+	ldws		0(%r26),%r29
+	addc		%r0,%r28,%r28
+	sub		%r29,%r19,%r22
+	add		%r22,%r19,%r0
+	stws,ma 	%r22,4(%r26)
+	addc		%r0,%r28,%r28
+	bv		0(%r2)
+	 ldo		-64(%r30),%r30
+
+L$just_one_limb
+	xmpyu		%fr4,%fr5,%fr6
+	ldw		0(%r26),%r29
+	fstds		%fr6,-16(%r30)
+	ldw		-12(%r30),%r1
+	ldw		-16(%r30),%r28
+	sub		%r29,%r1,%r22
+	add		%r22,%r1,%r0
+	stw		%r22,0(%r26)
+	addc		%r0,%r28,%r28
+	bv		0(%r2)
+	 ldo		-64(%r30),%r30
+
+	.exit
+	.procend
+
diff -urN g10-0.2.5/mpi/hppa1.1/udiv-qrnnd.S g10-0.2.6/mpi/hppa1.1/udiv-qrnnd.S
--- g10-0.2.5/mpi/hppa1.1/udiv-qrnnd.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/hppa1.1/udiv-qrnnd.S	Thu Feb 12 20:31:00 1998
@@ -0,0 +1,88 @@
+/* HP-PA  __udiv_qrnnd division support, used from longlong.h.
+ *	  This version runs fast on PA 7000 and later.
+ *
+ *	Copyright (C) 1993, 1994 Free Software Foundation, Inc.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+
+/* INPUT PARAMETERS
+ *   rem_ptr	   gr26
+ *   n1 	   gr25
+ *   n0 	   gr24
+ *   d		   gr23
+ */
+
+	.code
+L$0000	.word		0x43f00000
+	.word		0x0
+	.export 	__udiv_qrnnd
+__udiv_qrnnd
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+	ldo		64(%r30),%r30
+
+	stws		%r25,-16(0,%r30)	; n_hi
+	stws		%r24,-12(0,%r30)	; n_lo
+	ldil		L'L$0000,%r19
+	ldo		R'L$0000(%r19),%r19
+	fldds		-16(0,%r30),%fr5
+	stws		%r23,-12(0,%r30)
+	comib,<=	0,%r25,L$1
+	fcnvxf,dbl,dbl	%fr5,%fr5
+	fldds		0(0,%r19),%fr4
+	fadd,dbl	%fr4,%fr5,%fr5
+L$1
+	fcpy,sgl	%fr0,%fr6L
+	fldws		-12(0,%r30),%fr6R
+	fcnvxf,dbl,dbl	%fr6,%fr4
+
+	fdiv,dbl	%fr5,%fr4,%fr5
+
+	fcnvfx,dbl,dbl	%fr5,%fr4
+	fstws		%fr4R,-16(%r30)
+	xmpyu		%fr4R,%fr6R,%fr6
+	ldws		-16(%r30),%r28
+	fstds		%fr6,-16(0,%r30)
+	ldws		-12(0,%r30),%r21
+	ldws		-16(0,%r30),%r20
+	sub		%r24,%r21,%r22
+	subb		%r25,%r20,%r19
+	comib,= 	0,%r19,L$2
+	ldo		-64(%r30),%r30
+
+	add		%r22,%r23,%r22
+	ldo		-1(%r28),%r28
+L$2	bv		0(%r2)
+	stws		%r22,0(0,%r26)
+
+	.exit
+	.procend
+
+
diff -urN g10-0.2.5/mpi/mpicoder.c g10-0.2.6/mpi/mpicoder.c
--- g10-0.2.5/mpi/mpicoder.c	Mon Feb  2 20:12:57 1998
+++ g10-0.2.6/mpi/mpicoder.c	Thu Feb 12 22:34:50 1998
@@ -118,7 +118,7 @@
 
   leave:
     if( nread > *ret_nread )
-	log_error("Ooops: mpi crosses packet border");
+	log_bug("mpi crosses packet border");
     else
 	*ret_nread = nread;
     return val;
diff -urN g10-0.2.5/mpi/mpiutil.c g10-0.2.6/mpi/mpiutil.c
--- g10-0.2.5/mpi/mpiutil.c	Tue Feb  3 09:44:47 1998
+++ g10-0.2.6/mpi/mpiutil.c	Thu Feb 12 21:06:35 1998
@@ -35,6 +35,13 @@
   #undef mpi_free
 #endif
 
+/****************
+ * fixme: It was a bad idea to use the number of limbs to allocate
+ *	  because on a alpha the limbs are large but we normally need
+ *	  integers of n bits - So we should chnage this to bits (or bytes).
+ *
+ *	  But mpi_alloc is used in a lot of places :-)
+ */
 MPI
 #ifdef M_DEBUG
 mpi_debug_alloc( unsigned nlimbs, const char *info )
diff -urN g10-0.2.5/mpi/pa7100/distfiles g10-0.2.6/mpi/pa7100/distfiles
--- g10-0.2.5/mpi/pa7100/distfiles	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/pa7100/distfiles	Thu Feb 12 20:49:59 1998
@@ -0,0 +1,2 @@
+mpih-shift.S
+
diff -urN g10-0.2.5/mpi/pa7100/mpih-shift.S g10-0.2.6/mpi/pa7100/mpih-shift.S
--- g10-0.2.5/mpi/pa7100/mpih-shift.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/mpi/pa7100/mpih-shift.S	Thu Feb 12 20:49:23 1998
@@ -0,0 +1,158 @@
+/* hppa   rshift, lshift
+ *	  optimized for the PA7100, where is runs at 3.25 cycles/limb
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(gr26)
+ *		   mpi_ptr_t up,	(gr25)
+ *		   mpi_size_t usize,	(gr24)
+ *		   unsigned cnt)	(gr23)
+ */
+
+	.code
+	.export 	mpihelp_lshift
+mpihelp_lshift
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	sh2add		%r24,%r25,%r25
+	sh2add		%r24,%r26,%r26
+	ldws,mb 	-4(0,%r25),%r22
+	subi		32,%r23,%r1
+	mtsar		%r1
+	addib,= 	-1,%r24,L$0004
+	vshd		%r0,%r22,%r28		; compute carry out limb
+	ldws,mb 	-4(0,%r25),%r29
+	addib,<=	-5,%r24,L$rest
+	vshd		%r22,%r29,%r20
+
+L$loop	ldws,mb 	-4(0,%r25),%r22
+	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r29,%r22,%r20
+	ldws,mb 	-4(0,%r25),%r29
+	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r22,%r29,%r20
+	ldws,mb 	-4(0,%r25),%r22
+	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r29,%r22,%r20
+	ldws,mb 	-4(0,%r25),%r29
+	stws,mb 	%r20,-4(0,%r26)
+	addib,> 	-4,%r24,L$loop
+	vshd		%r22,%r29,%r20
+
+L$rest	addib,= 	4,%r24,L$end1
+	nop
+L$eloop ldws,mb 	-4(0,%r25),%r22
+	stws,mb 	%r20,-4(0,%r26)
+	addib,<=	-1,%r24,L$end2
+	vshd		%r29,%r22,%r20
+	ldws,mb 	-4(0,%r25),%r29
+	stws,mb 	%r20,-4(0,%r26)
+	addib,> 	-1,%r24,L$eloop
+	vshd		%r22,%r29,%r20
+
+L$end1	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r29,%r0,%r20
+	bv		0(%r2)
+	stw		%r20,-4(0,%r26)
+L$end2	stws,mb 	%r20,-4(0,%r26)
+L$0004	vshd		%r22,%r0,%r20
+	bv		0(%r2)
+	stw		%r20,-4(0,%r26)
+
+	.exit
+	.procend
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,       (gr26)
+ *		   mpi_ptr_t up,       (gr25)
+ *		   mpi_size_t usize,   (gr24)
+ *		   unsigned cnt)       (gr23)
+ */
+
+	.code
+	.export 	mpihelp_rshift
+mpihelp_rshift
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	ldws,ma 	4(0,%r25),%r22
+	mtsar		%r23
+	addib,= 	-1,%r24,L$r004
+	vshd		%r22,%r0,%r28		; compute carry out limb
+	ldws,ma 	4(0,%r25),%r29
+	addib,<=	-5,%r24,L$rrest
+	vshd		%r29,%r22,%r20
+
+L$roop	ldws,ma 	4(0,%r25),%r22
+	stws,ma 	%r20,4(0,%r26)
+	vshd		%r22,%r29,%r20
+	ldws,ma 	4(0,%r25),%r29
+	stws,ma 	%r20,4(0,%r26)
+	vshd		%r29,%r22,%r20
+	ldws,ma 	4(0,%r25),%r22
+	stws,ma 	%r20,4(0,%r26)
+	vshd		%r22,%r29,%r20
+	ldws,ma 	4(0,%r25),%r29
+	stws,ma 	%r20,4(0,%r26)
+	addib,> 	-4,%r24,L$roop
+	vshd		%r29,%r22,%r20
+
+L$rrest addib,= 	4,%r24,L$rend1
+	nop
+L$eroop ldws,ma 	4(0,%r25),%r22
+	stws,ma 	%r20,4(0,%r26)
+	addib,<=	-1,%r24,L$rend2
+	vshd		%r22,%r29,%r20
+	ldws,ma 	4(0,%r25),%r29
+	stws,ma 	%r20,4(0,%r26)
+	addib,> 	-1,%r24,L$eroop
+	vshd		%r29,%r22,%r20
+
+L$rend1  stws,ma	 %r20,4(0,%r26)
+	vshd		%r0,%r29,%r20
+	bv		0(%r2)
+	stw		%r20,0(0,%r26)
+L$rend2  stws,ma	 %r20,4(0,%r26)
+L$r004	vshd		%r0,%r22,%r20
+	bv		0(%r2)
+	stw		%r20,0(0,%r26)
+
+	.exit
+	.procend
+
+
diff -urN g10-0.2.5/po/ChangeLog g10-0.2.6/po/ChangeLog
--- g10-0.2.5/po/ChangeLog	Tue Feb 10 11:57:29 1998
+++ g10-0.2.6/po/ChangeLog	Fri Feb 13 13:24:34 1998
@@ -1,5 +0,0 @@
-Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
-
-	* ddd/hhhh:
-
-
diff -urN g10-0.2.5/po/cat-id-tbl.c g10-0.2.6/po/cat-id-tbl.c
--- g10-0.2.5/po/cat-id-tbl.c	Thu Feb 12 14:07:31 1998
+++ g10-0.2.6/po/cat-id-tbl.c	Fri Feb 13 18:50:36 1998
@@ -21,83 +21,98 @@
 DON'T USE ANY DATA GENERATED BY THIS PROGRAM!!\n\
 \n", 5},
   {"\
+\\vCommands:\n\
+ ", 6},
+  {"make a signature", 7},
+  {"make a clear text signature", 8},
+  {"make a detached signature", 9},
+  {"encrypt data", 10},
+  {"encryption only with symmetric cipher", 11},
+  {"store only", 12},
+  {"decrypt data (default)", 13},
+  {"list keys", 14},
+  {"check signatures on a key in the keyring", 15},
+  {"show the fingerprints", 16},
+  {"list only the sequence of packets", 17},
+  {"generate a new key pair", 18},
+  {"make a signature on a key in the keyring", 19},
+  {"remove key from the public keyring", 20},
+  {"edit a key signature", 21},
+  {"change the passphrase of your secret keyring", 22},
+  {"export keys", 23},
+  {"import/merge keys", 24},
+  {"\
+\\v\n\
+Options:\n\
+ ", 25},
+  {"create ascii armored output", 26},
+  {"use as output file", 27},
+  {"use this user-id to sign or decrypt", 28},
+  {"use this user-id for encryption", 29},
+  {"verbose", 30},
+  {"set compress level (0 disables)", 31},
+  {"use canonical text mode", 32},
+  {"don't make any changes", 33},
+  {"batch mode: never ask", 34},
+  {"assume yes on most questions", 35},
+  {"assume no on most questions", 36},
+  {"add this keyring to the list of keyrings", 37},
+  {"add this secret keyring to the list", 38},
+  {"read options from file", 39},
+  {"set debugging flags", 40},
+  {"enable full debugging", 41},
+  {"write status info to this fd", 42},
+  {"do not write comment packets", 43},
+  {"(default is 1)", 44},
+  {"(default is 3)", 45},
+  {"select default cipher algorithm", 46},
+  {"select default puplic key algorithm", 47},
+  {"select default message digest algorithm", 48},
+  {"\
+\\v\n\
+Examples:\n\
+\n\
+ -se -r Bob [file]          sign and encrypt for user Bob\n\
+ -sat [file]                make a clear text signature\n\
+ -sb  [file]                make a detached signature\n\
+ -k   [userid]              show keys\n\
+ -kc  [userid]              show fingerprint\n", 49},
+  {"\
 Syntax: g10 [options] [files]\n\
 sign, check, encrypt or decrypt\n\
-default operation depends on the input data\n", 6},
-  {"Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n", 7},
+default operation depends on the input data\n", 50},
+  {"Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n", 51},
   {"\
 WARNING: This version has RSA support! Your are not allowed to\n\
-         use it inside the Unites States before Sep 30, 2000!\n", 8},
-  {"Usage: g10 [options] ", 9},
-  {"conflicting commands\n", 10},
-  {"create ascii armored output", 11},
-  {"verbose", 12},
-  {"set compress level (0 disables)", 13},
-  {"don't make any changes", 14},
-  {"do only a symmetric encryption", 15},
-  {"use as output file", 16},
-  {"batch mode: never ask", 17},
-  {"assume yes on most questions", 18},
-  {"assume no on most questions", 19},
-  {"generate a new key pair", 20},
-  {"add key to the public keyring", 21},
-  {"remove key from public keyring", 22},
-  {"make a signature on a key in the keyring", 23},
-  {"store only", 24},
-  {"check signatures on a key in the keyring", 25},
-  {"add this keyring to the list of keyrings", 26},
-  {"make a signature", 27},
-  {"use canonical text mode", 28},
-  {"make a detached signature", 29},
-  {"encrypt data", 30},
-  {"decrypt data (default)", 31},
-  {"use this user-id to sign or decrypt", 32},
-  {"use this user-id for encryption", 33},
-  {"list keys", 34},
-  {"set debugging flags", 35},
-  {"enable full debugging", 36},
-  {"write status info to this fd", 37},
-  {"show the fingerprints", 38},
-  {"add this secret keyring to the list", 39},
-  {"read options from file", 40},
-  {"list only the sequence of packets", 41},
-  {"edit a key signature", 42},
-  {"change the passphrase of your secret keyring", 43},
-  {"select default cipher algorithm", 44},
-  {"select default puplic key algorithm", 45},
-  {"select default message digest algorithm", 46},
-  {"put public keys into the trustdb", 47},
-  {"do not write comment packets", 48},
-  {"(default is 1)", 49},
-  {"(default is 3)", 50},
-  {"export all or the given keys", 51},
-  {"make a clear text signature", 52},
-  {"note: no default option file '%s'\n", 53},
-  {"option file '%s': %s\n", 54},
-  {"reading options from '%s'\n", 55},
-  {"selected cipher algorithm is invalid\n", 56},
-  {"selected pubkey algorithm is invalid\n", 57},
-  {"selected digest algorithm is invalid\n", 58},
-  {"completes-needed must be greater than 0\n", 59},
-  {"marginals-needed must be greater than 1\n", 60},
-  {"failed to initialize the TrustDB: %s\n", 61},
-  {"--store [filename]", 62},
-  {"--symmetric [filename]", 63},
-  {"--encrypt [filename]", 64},
-  {"--sign [filename]", 65},
-  {"--sign --encrypt [filename]", 66},
-  {"--clearsign [filename]", 67},
-  {"--sign-key username", 68},
-  {"--edit-sig username", 69},
-  {"--change-passphrase [username]", 70},
-  {"can't open '%s'\n", 71},
-  {"-k[v][v][v][c] [keyring]", 72},
-  {"--gen-key", 73},
-  {"nyi", 74},
-  {"[filename]", 75},
+         use it inside the Unites States before Sep 30, 2000!\n", 52},
+  {"usage: g10 [options] ", 53},
+  {"conflicting commands\n", 54},
+  {"selected cipher algorithm is invalid\n", 55},
+  {"selected pubkey algorithm is invalid\n", 56},
+  {"selected digest algorithm is invalid\n", 57},
+  {"completes-needed must be greater than 0\n", 58},
+  {"marginals-needed must be greater than 1\n", 59},
+  {"note: no default option file '%s'\n", 60},
+  {"option file '%s': %s\n", 61},
+  {"reading options from '%s'\n", 62},
+  {"failed to initialize the TrustDB: %s\n", 63},
+  {"--store [filename]", 64},
+  {"--symmetric [filename]", 65},
+  {"--encrypt [filename]", 66},
+  {"--sign [filename]", 67},
+  {"--sign --encrypt [filename]", 68},
+  {"--clearsign [filename]", 69},
+  {"--sign-key username", 70},
+  {"--edit-sig username", 71},
+  {"--change-passphrase [username]", 72},
+  {"can't open '%s'\n", 73},
+  {"-k[v][v][v][c] [keyring]", 74},
+  {"--gen-key", 75},
+  {"nyi", 76},
+  {"[filename]", 77},
   {"\
 No ownertrust defined for %lu:\n\
-%4u%c/%08lX %s \"", 76},
+%4u%c/%08lX %s \"", 78},
   {"\
 \"\n\
 \n\
@@ -110,77 +125,77 @@
  3 = I trust marginally\n\
  4 = I trust fully\n\
  s = please show me more informations\n\
-\n", 77},
-  {"Your decision? ", 78},
+\n", 79},
+  {"Your decision? ", 80},
   {"\
 It's up to you to assign a value here; this value will never be exported\n\
 to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n\
-to do with the (implicitly created) web-of-certificates.\n", 79},
-  {"You will see a list of signators etc. here\n", 80},
+to do with the (implicitly created) web-of-certificates.\n", 81},
+  {"You will see a list of signators etc. here\n", 82},
   {"\
 Could not find a valid trust path to the key.  Lets see, wether we\n\
 can assign some missing owner trust values.\n\
-\n", 81},
-  {"writing self signature\n", 82},
-  {"Key generation can only be used in interactive mode\n", 83},
+\n", 83},
+  {"writing self signature\n", 84},
+  {"Key generation can only be used in interactive mode\n", 85},
   {"\
 Please select the algorithm to use:\n\
    (1) ElGamal is the suggested one.\n\
-   (2) DSA can only be used for signatures.\n", 84},
-  {"   (3) RSA cannot be used in the U.S.\n", 85},
-  {"Your selection? (1,2,3) ", 86},
-  {"Your selection? (1,2) ", 87},
-  {"Sorry; DSA is not yet supported.\n", 88},
+   (2) DSA can only be used for signatures.\n", 86},
+  {"   (3) RSA cannot be used in the U.S.\n", 87},
+  {"Your selection? (1,2,3) ", 88},
+  {"Your selection? (1,2) ", 89},
+  {"Sorry; DSA is not yet supported.\n", 90},
   {"\
 About to generate a new %s keypair.\n\
               minimum keysize is  768 bits\n\
               default keysize is 1024 bits\n\
-    highest suggested keysize is 2048 bits\n", 89},
-  {"What keysize do you want? (1024) ", 90},
-  {"DSA does only allow keysizes from 512 to 1024\n", 91},
-  {"keysize too small; 768 is smallest value allowed.\n", 92},
-  {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 93},
-  {"Are you sure, that you want this keysize? ", 94},
-  {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 95},
-  {"Requested keysize is %u bits\n", 96},
-  {"rounded up to %u bits\n", 97},
+    highest suggested keysize is 2048 bits\n", 91},
+  {"What keysize do you want? (1024) ", 92},
+  {"DSA does only allow keysizes from 512 to 1024\n", 93},
+  {"keysize too small; 768 is smallest value allowed.\n", 94},
+  {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 95},
+  {"Are you sure, that you want this keysize? ", 96},
+  {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 97},
+  {"Requested keysize is %u bits\n", 98},
+  {"rounded up to %u bits\n", 99},
   {"\
 \n\
 You need a User-ID to identify your key; the software constructs the user id\n\
 from Real Name, Comment and Email Address in this form:\n\
     \"Heinrich Heine (Der Dichter) <heinrichh@uni-duesseldorf.de>\"\n\
-\n", 98},
-  {"Real name: ", 99},
-  {"Invalid character in name\n", 100},
-  {"Name may not start with a digit\n", 101},
-  {"Name must be at least 5 characters long\n", 102},
-  {"Email address: ", 103},
-  {"Not a valid email address\n", 104},
-  {"Comment: ", 105},
-  {"Invalid character in comment\n", 106},
+\n", 100},
+  {"Real name: ", 101},
+  {"Invalid character in name\n", 102},
+  {"Name may not start with a digit\n", 103},
+  {"Name must be at least 5 characters long\n", 104},
+  {"Email address: ", 105},
+  {"Not a valid email address\n", 106},
+  {"Comment: ", 107},
+  {"Invalid character in comment\n", 108},
   {"\
 You selected this USER-ID:\n\
     \"%s\"\n\
-\n", 107},
-  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 108},
+\n", 109},
+  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 110},
   {"\
 You need a Passphrase to protect your secret key.\n\
-\n", 109},
+\n", 111},
   {"\
 You don't what a passphrase - this is probably a *bad* idea!\n\
 I will do it anyway.  You can change your passphrase at anytime,\n\
 using this program with the option \"--change-passphrase\"\n\
-\n", 110},
-  {"passphrase not correctly repeated; try again.\n", 111},
-  {"writing public certificate to '%s'\n", 112},
-  {"writing secret certificate to '%s'\n", 113},
+\n", 112},
+  {"passphrase not correctly repeated; try again.\n", 113},
+  {"writing public certificate to '%s'\n", 114},
+  {"writing secret certificate to '%s'\n", 115},
   {"\
 We need to generate a lot of random bytes. It is a good idea to perform\n\
 some other action (work in another window, move the mouse, utilize the\n\
 network and the disks) during the prime generation; this gives the random\n\
-number generator a better chance to gain enough entropy.\n", 114},
-  {"public and secret key created and signed.\n", 115},
-  {"Key generation failed: %s\n", 116},
+number generator a better chance to gain enough entropy.\n", 116},
+  {"public and secret key created and signed.\n", 117},
+  {"Key generation failed: %s\n", 118},
 };
 
-int _msg_tbl_length = 116;
+int _msg_tbl_length = 118;
diff -urN g10-0.2.5/po/g10.pot g10-0.2.6/po/g10.pot
--- g10-0.2.5/po/g10.pot	Thu Feb 12 14:07:29 1998
+++ g10-0.2.6/po/g10.pot	Fri Feb 13 21:20:50 1998
@@ -1,6 +1,6 @@
 msgid ""
 msgstr ""
-"Date: 1998-02-12 14:07:29+0100\n"
+"Date: 1998-02-13 21:20:50+0100\n"
 "From: Werner Koch <wk@frodo>\n"
 "Content-Type: text/plain; charset=\n"
 "Xgettext-Options: --default-domain=g10 --directory=.. --add-comments --keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
@@ -30,293 +30,313 @@
 "\n"
 msgstr ""
 
-#: g10/g10.c:70
+#: g10/g10.c:46
 msgid ""
-"Syntax: g10 [options] [files]\n"
-"sign, check, encrypt or decrypt\n"
-"default operation depends on the input data\n"
-msgstr ""
-
-#: g10/g10.c:75
-msgid "Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n"
+"\\vCommands:\n"
+" "
 msgstr ""
 
-#: g10/g10.c:80
-msgid ""
-"WARNING: This version has RSA support! Your are not allowed to\n"
-"         use it inside the Unites States before Sep 30, 2000!\n"
+#: g10/g10.c:48
+msgid "make a signature"
 msgstr ""
 
-#: g10/g10.c:108
-msgid "Usage: g10 [options] "
+#: g10/g10.c:49
+msgid "make a clear text signature"
 msgstr ""
 
-#: g10/g10.c:147
-msgid "conflicting commands\n"
+#: g10/g10.c:50
+msgid "make a detached signature"
 msgstr ""
 
-#: g10/g10.c:159
-msgid "create ascii armored output"
+#: g10/g10.c:51
+msgid "encrypt data"
 msgstr ""
 
-#: g10/g10.c:160
-msgid "verbose"
+#: g10/g10.c:52
+msgid "encryption only with symmetric cipher"
 msgstr ""
 
-#: g10/g10.c:161
-msgid "set compress level (0 disables)"
+#: g10/g10.c:53
+msgid "store only"
 msgstr ""
 
-#: g10/g10.c:162
-msgid "don't make any changes"
+#: g10/g10.c:54
+msgid "decrypt data (default)"
 msgstr ""
 
-#: g10/g10.c:163
-msgid "do only a symmetric encryption"
+#: g10/g10.c:55
+msgid "list keys"
 msgstr ""
 
-#: g10/g10.c:164
-msgid "use as output file"
+#: g10/g10.c:56
+msgid "check signatures on a key in the keyring"
 msgstr ""
 
-#: g10/g10.c:165
-msgid "batch mode: never ask"
+#: g10/g10.c:57
+msgid "show the fingerprints"
 msgstr ""
 
-#: g10/g10.c:166
-msgid "assume yes on most questions"
+#: g10/g10.c:58
+msgid "list only the sequence of packets"
 msgstr ""
 
-#: g10/g10.c:167
-msgid "assume no on most questions"
+#: g10/g10.c:59
+msgid "generate a new key pair"
 msgstr ""
 
-#: g10/g10.c:168
-msgid "generate a new key pair"
+#: g10/g10.c:60
+msgid "make a signature on a key in the keyring"
 msgstr ""
 
-#: g10/g10.c:169
-msgid "add key to the public keyring"
+#: g10/g10.c:61
+msgid "remove key from the public keyring"
 msgstr ""
 
-#: g10/g10.c:170
-msgid "remove key from public keyring"
+#: g10/g10.c:62
+msgid "edit a key signature"
 msgstr ""
 
-#: g10/g10.c:171
-msgid "make a signature on a key in the keyring"
+#: g10/g10.c:63
+msgid "change the passphrase of your secret keyring"
 msgstr ""
 
-#: g10/g10.c:172
-msgid "store only"
+#: g10/g10.c:64
+msgid "export keys"
 msgstr ""
 
-#: g10/g10.c:173
-msgid "check signatures on a key in the keyring"
+#: g10/g10.c:65
+msgid "import/merge keys"
 msgstr ""
 
-#: g10/g10.c:174
-msgid "add this keyring to the list of keyrings"
+#: g10/g10.c:67
+msgid ""
+"\\v\n"
+"Options:\n"
+" "
 msgstr ""
 
-#: g10/g10.c:175
-msgid "make a signature"
+#: g10/g10.c:69
+msgid "create ascii armored output"
 msgstr ""
 
-#: g10/g10.c:176
-msgid "use canonical text mode"
+#: g10/g10.c:70
+msgid "use as output file"
 msgstr ""
 
-#: g10/g10.c:177
-msgid "make a detached signature"
+#: g10/g10.c:71
+msgid "use this user-id to sign or decrypt"
 msgstr ""
 
-#: g10/g10.c:178
-msgid "encrypt data"
+#: g10/g10.c:72
+msgid "use this user-id for encryption"
 msgstr ""
 
-#: g10/g10.c:179
-msgid "decrypt data (default)"
+#: g10/g10.c:73
+msgid "verbose"
 msgstr ""
 
-#: g10/g10.c:180
-msgid "use this user-id to sign or decrypt"
+#: g10/g10.c:74
+msgid "set compress level (0 disables)"
 msgstr ""
 
-#: g10/g10.c:181
-msgid "use this user-id for encryption"
+#: g10/g10.c:75
+msgid "use canonical text mode"
 msgstr ""
 
-#: g10/g10.c:182
-msgid "list keys"
+#: g10/g10.c:76
+msgid "don't make any changes"
 msgstr ""
 
-#: g10/g10.c:183
-msgid "set debugging flags"
+#: g10/g10.c:77
+msgid "batch mode: never ask"
 msgstr ""
 
-#: g10/g10.c:184
-msgid "enable full debugging"
+#: g10/g10.c:78
+msgid "assume yes on most questions"
 msgstr ""
 
-#: g10/g10.c:185
-msgid "write status info to this fd"
+#: g10/g10.c:79
+msgid "assume no on most questions"
 msgstr ""
 
-#: g10/g10.c:186
-msgid "show the fingerprints"
+#: g10/g10.c:80
+msgid "add this keyring to the list of keyrings"
 msgstr ""
 
-#: g10/g10.c:187
+#: g10/g10.c:81
 msgid "add this secret keyring to the list"
 msgstr ""
 
-#: g10/g10.c:188
+#: g10/g10.c:82
 msgid "read options from file"
 msgstr ""
 
-#: g10/g10.c:191
-msgid "list only the sequence of packets"
+#: g10/g10.c:84
+msgid "set debugging flags"
 msgstr ""
 
-#: g10/g10.c:194
-msgid "edit a key signature"
+#: g10/g10.c:85
+msgid "enable full debugging"
 msgstr ""
 
-#: g10/g10.c:195
-msgid "change the passphrase of your secret keyring"
+#: g10/g10.c:86
+msgid "write status info to this fd"
 msgstr ""
 
-#: g10/g10.c:197
-msgid "select default cipher algorithm"
+#: g10/g10.c:87
+msgid "do not write comment packets"
 msgstr ""
 
-#: g10/g10.c:198
-msgid "select default puplic key algorithm"
+#: g10/g10.c:88
+msgid "(default is 1)"
 msgstr ""
 
-#: g10/g10.c:199
-msgid "select default message digest algorithm"
+#: g10/g10.c:89
+msgid "(default is 3)"
 msgstr ""
 
-#: g10/g10.c:200
-msgid "put public keys into the trustdb"
+#: g10/g10.c:90
+msgid "select default cipher algorithm"
 msgstr ""
 
-#: g10/g10.c:202
-msgid "do not write comment packets"
+#: g10/g10.c:91
+msgid "select default puplic key algorithm"
 msgstr ""
 
-#: g10/g10.c:203
-msgid "(default is 1)"
+#: g10/g10.c:92
+msgid "select default message digest algorithm"
 msgstr ""
 
-#: g10/g10.c:204
-msgid "(default is 3)"
+#: g10/g10.c:94
+msgid ""
+"\\v\n"
+"Examples:\n"
+"\n"
+" -se -r Bob [file]          sign and encrypt for user Bob\n"
+" -sat [file]                make a clear text signature\n"
+" -sb  [file]                make a detached signature\n"
+" -k   [userid]              show keys\n"
+" -kc  [userid]              show fingerprint\n"
 msgstr ""
 
-#: g10/g10.c:205
-msgid "export all or the given keys"
+#: g10/g10.c:144
+msgid ""
+"Syntax: g10 [options] [files]\n"
+"sign, check, encrypt or decrypt\n"
+"default operation depends on the input data\n"
 msgstr ""
 
-#: g10/g10.c:207
-msgid "make a clear text signature"
+#: g10/g10.c:149
+msgid "Please report bugs to <g10-bugs@isil.d.shuttle.de>.\n"
 msgstr ""
 
-#: g10/g10.c:279
-msgid "note: no default option file '%s'\n"
+#: g10/g10.c:154
+msgid ""
+"WARNING: This version has RSA support! Your are not allowed to\n"
+"         use it inside the Unites States before Sep 30, 2000!\n"
 msgstr ""
 
-#: g10/g10.c:282
-msgid "option file '%s': %s\n"
+#: g10/g10.c:182
+msgid "usage: g10 [options] "
 msgstr ""
 
-#: g10/g10.c:287
-msgid "reading options from '%s'\n"
+#: g10/g10.c:221
+msgid "conflicting commands\n"
 msgstr ""
 
-#: g10/g10.c:378
+#: g10/g10.c:234
 msgid "selected cipher algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:382
+#: g10/g10.c:236
 msgid "selected pubkey algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:386
+#: g10/g10.c:238
 msgid "selected digest algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:390
+#: g10/g10.c:240
 msgid "completes-needed must be greater than 0\n"
 msgstr ""
 
-#: g10/g10.c:394
+#: g10/g10.c:242
 msgid "marginals-needed must be greater than 1\n"
 msgstr ""
 
-#: g10/g10.c:452
+#: g10/g10.c:319
+msgid "note: no default option file '%s'\n"
+msgstr ""
+
+#: g10/g10.c:322
+msgid "option file '%s': %s\n"
+msgstr ""
+
+#: g10/g10.c:329
+msgid "reading options from '%s'\n"
+msgstr ""
+
+#: g10/g10.c:474
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr ""
 
-#: g10/g10.c:458
+#. only store the file
+#: g10/g10.c:480
 msgid "--store [filename]"
 msgstr ""
 
-#. encrypt the given file only with the symmetric cipher
-#: g10/g10.c:466
+#: g10/g10.c:488
 msgid "--symmetric [filename]"
 msgstr ""
 
-#: g10/g10.c:473
+#. encrypt the given file
+#: g10/g10.c:495
 msgid "--encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:486
+#: g10/g10.c:508
 msgid "--sign [filename]"
 msgstr ""
 
-#. sign and encrypt the given file
-#: g10/g10.c:499
+#: g10/g10.c:521
 msgid "--sign --encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:513
+#: g10/g10.c:535
 msgid "--clearsign [filename]"
 msgstr ""
 
-#: g10/g10.c:521
+#. sign the key given as argument
+#: g10/g10.c:543
 msgid "--sign-key username"
 msgstr ""
 
-#. Edit a key signature
-#: g10/g10.c:529
+#: g10/g10.c:551
 msgid "--edit-sig username"
 msgstr ""
 
-#. no arg: use default, 1 arg use this one
-#: g10/g10.c:537
+#: g10/g10.c:559
 msgid "--change-passphrase [username]"
 msgstr ""
 
 #. list the given keyring
-#: g10/g10.c:551 g10/g10.c:568 g10/g10.c:610
+#: g10/g10.c:574 g10/g10.c:594 g10/g10.c:642
 msgid "can't open '%s'\n"
 msgstr ""
 
-#: g10/g10.c:573
+#: g10/g10.c:605
 msgid "-k[v][v][v][c] [keyring]"
 msgstr ""
 
-#: g10/g10.c:578
+#: g10/g10.c:610
 msgid "--gen-key"
 msgstr ""
 
-#: g10/g10.c:584
+#: g10/g10.c:616
 msgid "nyi"
 msgstr ""
 
-#: g10/g10.c:608
+#: g10/g10.c:640
 msgid "[filename]"
 msgstr ""
 
@@ -522,10 +542,10 @@
 "number generator a better chance to gain enough entropy.\n"
 msgstr ""
 
-#: g10/keygen.c:612
+#: g10/keygen.c:618
 msgid "public and secret key created and signed.\n"
 msgstr ""
 
-#: g10/keygen.c:623
+#: g10/keygen.c:629
 msgid "Key generation failed: %s\n"
 msgstr ""
diff -urN g10-0.2.5/tools/ChangeLog g10-0.2.6/tools/ChangeLog
--- g10-0.2.5/tools/ChangeLog	Tue Feb 10 11:57:29 1998
+++ g10-0.2.6/tools/ChangeLog	Fri Feb 13 13:19:03 1998
@@ -1,5 +0,0 @@
-Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
-
-	* ddd/hhhh:
-
-
diff -urN g10-0.2.5/tools/Makefile.in g10-0.2.6/tools/Makefile.in
--- g10-0.2.5/tools/Makefile.in	Thu Feb 12 14:35:11 1998
+++ g10-0.2.6/tools/Makefile.in	Fri Feb 13 21:27:38 1998
@@ -85,7 +85,6 @@
 RANLIB = @RANLIB@
 VERSION = @VERSION@
 ZLIBS = @ZLIBS@
-ZLIB_SUBDIR = @ZLIB_SUBDIR@
 
 INCLUDES = -I$(top_srcdir)/include
 needed_libs = ../cipher/libcipher.a  ../util/libutil.a ../mpi/libmpi.a ../util/libutil.a
diff -urN g10-0.2.5/tools/clean-sat.c g10-0.2.6/tools/clean-sat.c
--- g10-0.2.5/tools/clean-sat.c	Wed Feb 11 21:11:47 1998
+++ g10-0.2.6/tools/clean-sat.c	Thu Feb 12 14:57:31 1998
@@ -6,7 +6,7 @@
 int
 main(int argc, char **argv)
 {
-    int c, c2;
+    int c;
 
     if( argc > 1 ) {
 	fprintf(stderr, "no arguments, please\n");
diff -urN g10-0.2.5/util/ChangeLog g10-0.2.6/util/ChangeLog
--- g10-0.2.5/util/ChangeLog	Tue Feb 10 11:57:29 1998
+++ g10-0.2.6/util/ChangeLog	Fri Feb 13 19:35:51 1998
@@ -1,5 +1,18 @@
-Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
+Fri Feb 13 19:34:59 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
-	* ddd/hhhh:
+	* iobuf.c (iobuf_seek): Set counters to new offset.
+
+Fri Feb 13 17:13:04 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* logger.c (log_set_name, log_get_name): New.
+	(print_prefix, pgm_name): New, changed all function to make use it.
+	(log_mpidump): Removed the "DBG" prefix.
+	(log_hexdump): Ditto.
+
+	* logger.c (printstr): Removed.
+
+Fri Feb 13 15:14:13 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* argparse.c (show_help): New '\v' kludge.
 
 
diff -urN g10-0.2.5/util/Makefile.in g10-0.2.6/util/Makefile.in
--- g10-0.2.5/util/Makefile.in	Thu Feb 12 14:34:43 1998
+++ g10-0.2.6/util/Makefile.in	Fri Feb 13 21:27:30 1998
@@ -85,7 +85,6 @@
 RANLIB = @RANLIB@
 VERSION = @VERSION@
 ZLIBS = @ZLIBS@
-ZLIB_SUBDIR = @ZLIB_SUBDIR@
 
 INCLUDES = -I$(top_srcdir)/include
 
diff -urN g10-0.2.5/util/argparse.c g10-0.2.6/util/argparse.c
--- g10-0.2.5/util/argparse.c	Wed Feb 11 19:41:21 1998
+++ g10-0.2.6/util/argparse.c	Fri Feb 13 15:10:08 1998
@@ -538,16 +538,31 @@
 	/* get max. length of long options */
 	for(i=indent=0; opts[i].short_opt; i++ ) {
 	    if( opts[i].long_opt )
-		if( (j=strlen(opts[i].long_opt)) > indent && j < 35 )
-		    indent = j;
+		if( !opts[i].description || *opts[i].description != '\v' )
+		    if( (j=strlen(opts[i].long_opt)) > indent && j < 35 )
+			 indent = j;
 	}
 	/* example: " -v, --verbose   Viele Sachen ausgeben" */
 	indent += 10;
-	puts("Options:");
+	if( *opts[0].description != '\v' )
+	    puts("Options:");
 	for(i=0; opts[i].short_opt; i++ ) {
 	    s = _( opts[i].description );
 	    if( s && *s== '\r' ) /* hide this line */
 		continue;
+	    if( s && *s == '\v' ) { /* unindented comment only line */
+		for(s++; *s; s++ ) {
+		    if( *s == '\n' ) {
+			if( s[1] )
+			    putchar('\n');
+		    }
+		    else
+			putchar(*s);
+		}
+		putchar('\n');
+		continue;
+	    }
+
 	    if( opts[i].short_opt < 256 )
 		printf(" -%c", opts[i].short_opt );
 	    else
diff -urN g10-0.2.5/util/iobuf.c g10-0.2.6/util/iobuf.c
--- g10-0.2.5/util/iobuf.c	Tue Feb 10 13:36:46 1998
+++ g10-0.2.6/util/iobuf.c	Fri Feb 13 18:52:29 1998
@@ -867,6 +867,11 @@
 }
 
 
+
+/****************
+ * This is a very limited implementation. It simply discards all internal
+ * buffering and remove all filters but the first one.
+ */
 int
 iobuf_seek( IOBUF a, ulong newpos )
 {
@@ -885,6 +890,10 @@
 	log_error("can't seek to %lu: %s\n", newpos, strerror(errno) );
 	return -1;
     }
+    a->d.len = 0;   /* discard buffer */
+    a->d.start = 0;
+    a->nbytes = 0;
+    a->nlimit = 0;
     a->ntotal = newpos;
     /* remove filters, but the last */
     while( a->chain )
diff -urN g10-0.2.5/util/logger.c g10-0.2.6/util/logger.c
--- g10-0.2.5/util/logger.c	Wed Feb 11 14:21:08 1998
+++ g10-0.2.6/util/logger.c	Fri Feb 13 17:57:03 1998
@@ -26,9 +26,27 @@
 #include "util.h"
 
 static char pidstring[15];
+static char *pgm_name;
 static int errorcount;
 
 void
+log_set_name( const char *name )
+{
+    m_free(pgm_name);
+    if( name )
+	pgm_name = m_strdup(name);
+    else
+	pgm_name = NULL;
+}
+
+const char *
+log_get_name(void)
+{
+    return pgm_name? pgm_name : "";
+}
+
+
+void
 log_set_pid( int pid )
 {
     if( pid )
@@ -46,45 +64,21 @@
     return n;
 }
 
-
-/****************
- * General interface for printing a line
- * level 0 := print to /dev/null
- *	 1 := print to stdout
- *	 2 := print as info to stderr
- *	 3 := ditto but as error
- */
-void
-printstr( int level, const char *fmt, ... )
+static void
+print_prefix(const char *text)
 {
-    va_list arg_ptr ;
-
-    if( !level )
-	return;
-
-    if( !fmt ) {
-	putc('\n', level? stderr: stdout);
-	return;
-    }
-
-    va_start( arg_ptr, fmt ) ;
-    if( level < 2 ) {
-	vfprintf(stdout,fmt,arg_ptr) ;
-    }
-    else {
-	fprintf(stderr, level==2? "%s: ": "%s: error: ", strusage(13) ) ;
-	vfprintf(stderr,fmt,arg_ptr) ;
-    }
-    va_end(arg_ptr);
+    if( pgm_name )
+	fprintf(stderr, "%s%s: %s", pgm_name, pidstring, text );
+    else
+	fprintf(stderr, "?%s: %s", pidstring, text );
 }
 
-
 void
 log_info( const char *fmt, ... )
 {
     va_list arg_ptr ;
 
-    fprintf(stderr, "info%s: ", pidstring ) ;
+    print_prefix("");
     va_start( arg_ptr, fmt ) ;
     vfprintf(stderr,fmt,arg_ptr) ;
     va_end(arg_ptr);
@@ -95,7 +89,7 @@
 {
     va_list arg_ptr ;
 
-    fprintf(stderr, "error%s: ", pidstring  ) ;
+    print_prefix("");
     va_start( arg_ptr, fmt ) ;
     vfprintf(stderr,fmt,arg_ptr) ;
     va_end(arg_ptr);
@@ -107,7 +101,7 @@
 {
     va_list arg_ptr ;
 
-    fprintf(stderr, "Fatal%s: ", pidstring  ) ;
+    print_prefix("fatal: ");
     va_start( arg_ptr, fmt ) ;
     vfprintf(stderr,fmt,arg_ptr) ;
     va_end(arg_ptr);
@@ -120,7 +114,8 @@
 {
     va_list arg_ptr ;
 
-    fprintf(stderr, "\nInternal Error%s: ", pidstring  ) ;
+    putc('\n', stderr );
+    print_prefix("Ooops: ");
     va_start( arg_ptr, fmt ) ;
     vfprintf(stderr,fmt,arg_ptr) ;
     va_end(arg_ptr);
@@ -148,7 +143,7 @@
 {
     va_list arg_ptr ;
 
-    fprintf(stderr, "DBG%s: ", pidstring  ) ;
+    print_prefix("DBG: ");
     va_start( arg_ptr, fmt ) ;
     vfprintf(stderr,fmt,arg_ptr) ;
     va_end(arg_ptr);
@@ -161,7 +156,7 @@
 {
     int i;
 
-    fprintf(stderr, "DBG%s: %s", pidstring,  text );
+    print_prefix(text);
     for(i=0; i < len; i++ )
 	fprintf(stderr, " %02X", ((byte*)buf)[i] );
     fputc('\n', stderr);
@@ -171,7 +166,7 @@
 void
 log_mpidump( const char *text, MPI a )
 {
-    fprintf(stderr, "DBG%s: %s", pidstring, text );
+    print_prefix(text);
     mpi_print(stderr, a, 1 );
     fputc('\n', stderr);
 }
diff -urN g10-0.2.5/zlib/Makefile.am g10-0.2.6/zlib/Makefile.am
--- g10-0.2.5/zlib/Makefile.am	Thu Feb 12 13:02:01 1998
+++ g10-0.2.6/zlib/Makefile.am	Fri Feb 13 13:34:38 1998
@@ -6,15 +6,24 @@
 CFLAGS = -O -Wall
 
 EXTRA_DIST = README algorithm.doc ChangeLog example.c
+
+# I found no other easy way to use this only if zlib is neede
+# doing this with SUBDIR = @xxx@  in the top Makefile.am does not
+# work because automake doesn't scan this Makefile.am here.
+if ENABLE_LOCAL_ZLIB
 noinst_LIBRARIES = libzlib.a
+endif
 
 
 libzlib_a_SOURCES = adler32.c compress.c crc32.c gzio.c \
 		    uncompr.c deflate.c trees.c zutil.c \
 		    inflate.c infblock.c inftrees.c \
 		    infcodes.c infutil.c inffast.c \
-		    zlib.h zconf.h
+		    zlib.h zconf.h deflate.h infblock.h  \
+		    infcodes.h inffast.h inftrees.h infutil.h zutil.h
+
 
 CLEANFILES = example foo.gz
+
 
 
diff -urN g10-0.2.5/zlib/Makefile.in g10-0.2.6/zlib/Makefile.in
--- g10-0.2.5/zlib/Makefile.in	Thu Feb 12 14:35:04 1998
+++ g10-0.2.6/zlib/Makefile.in	Fri Feb 13 21:27:26 1998
@@ -90,18 +90,22 @@
 RANLIB = @RANLIB@
 VERSION = @VERSION@
 ZLIBS = @ZLIBS@
-ZLIB_SUBDIR = @ZLIB_SUBDIR@
 
 CFLAGS = -O -Wall
 
 EXTRA_DIST = README algorithm.doc ChangeLog example.c
-noinst_LIBRARIES = libzlib.a
+
+# I found no other easy way to use this only if zlib is neede
+# doing this with SUBDIR = @xxx@  in the top Makefile.am does not
+# work because automake doesn't scan this Makefile.am here.
+@ENABLE_LOCAL_ZLIB_TRUE@noinst_LIBRARIES = libzlib.a
 
 libzlib_a_SOURCES = adler32.c compress.c crc32.c gzio.c \
 		    uncompr.c deflate.c trees.c zutil.c \
 		    inflate.c infblock.c inftrees.c \
 		    infcodes.c infutil.c inffast.c \
-		    zlib.h zconf.h
+		    zlib.h zconf.h deflate.h infblock.h  \
+		    infcodes.h inffast.h inftrees.h infutil.h zutil.h
 
 CLEANFILES = example foo.gz
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
diff -urN g10-0.2.5/zlib/adler32.c g10-0.2.6/zlib/adler32.c
--- g10-0.2.5/zlib/adler32.c	Wed May 22 13:52:18 1996
+++ g10-0.2.6/zlib/adler32.c	Thu Feb 12 15:39:00 1998
@@ -3,7 +3,7 @@
  * For conditions of distribution and use, see copyright notice in zlib.h 
  */
 
-/* $Id: adler32.c,v 1.10 1996/05/22 11:52:18 me Exp $ */
+/* $Id: adler32.c,v 1.1 1998/02/12 14:39:00 wk Exp $ */
 
 #include "zlib.h"
 
diff -urN g10-0.2.5/zlib/compress.c g10-0.2.6/zlib/compress.c
--- g10-0.2.5/zlib/compress.c	Thu May 23 18:51:12 1996
+++ g10-0.2.6/zlib/compress.c	Thu Feb 12 15:39:00 1998
@@ -3,7 +3,7 @@
  * For conditions of distribution and use, see copyright notice in zlib.h 
  */
 
-/* $Id: compress.c,v 1.10 1996/05/23 16:51:12 me Exp $ */
+/* $Id: compress.c,v 1.1 1998/02/12 14:39:00 wk Exp $ */
 
 #include "zlib.h"
 
diff -urN g10-0.2.5/zlib/crc32.c g10-0.2.6/zlib/crc32.c
--- g10-0.2.5/zlib/crc32.c	Tue Jan 30 22:59:10 1996
+++ g10-0.2.6/zlib/crc32.c	Thu Feb 12 15:39:00 1998
@@ -3,7 +3,7 @@
  * For conditions of distribution and use, see copyright notice in zlib.h 
  */
 
-/* $Id: crc32.c,v 1.8 1996/01/30 21:59:10 me Exp $ */
+/* $Id: crc32.c,v 1.1 1998/02/12 14:39:00 wk Exp $ */
 
 #include "zlib.h"
 
diff -urN g10-0.2.5/zlib/deflate.c g10-0.2.6/zlib/deflate.c
--- g10-0.2.5/zlib/deflate.c	Wed Jul 24 15:40:58 1996
+++ g10-0.2.6/zlib/deflate.c	Thu Feb 12 15:39:01 1998
@@ -47,7 +47,7 @@
  *
  */
 
-/* $Id: deflate.c,v 1.15 1996/07/24 13:40:58 me Exp $ */
+/* $Id: deflate.c,v 1.1 1998/02/12 14:39:01 wk Exp $ */
 
 #include "deflate.h"
 
diff -urN g10-0.2.5/zlib/deflate.h g10-0.2.6/zlib/deflate.h
--- g10-0.2.5/zlib/deflate.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/zlib/deflate.h	Thu Feb 12 15:39:01 1998
@@ -0,0 +1,275 @@
+/* deflate.h -- internal compression state
+ * Copyright (C) 1995-1996 Jean-loup Gailly
+ * For conditions of distribution and use, see copyright notice in zlib.h 
+ */
+
+/* WARNING: this file should *not* be used by applications. It is
+   part of the implementation of the compression library and is
+   subject to change. Applications should only use zlib.h.
+ */
+
+/* $Id: deflate.h,v 1.1 1998/02/12 14:39:01 wk Exp $ */
+
+#ifndef _DEFLATE_H
+#define _DEFLATE_H
+
+#include "zutil.h"
+
+/* ===========================================================================
+ * Internal compression state.
+ */
+
+#define LENGTH_CODES 29
+/* number of length codes, not counting the special END_BLOCK code */
+
+#define LITERALS  256
+/* number of literal bytes 0..255 */
+
+#define L_CODES (LITERALS+1+LENGTH_CODES)
+/* number of Literal or Length codes, including the END_BLOCK code */
+
+#define D_CODES   30
+/* number of distance codes */
+
+#define BL_CODES  19
+/* number of codes used to transfer the bit lengths */
+
+#define HEAP_SIZE (2*L_CODES+1)
+/* maximum heap size */
+
+#define MAX_BITS 15
+/* All codes must not exceed MAX_BITS bits */
+
+#define INIT_STATE    42
+#define BUSY_STATE   113
+#define FINISH_STATE 666
+/* Stream status */
+
+
+/* Data structure describing a single value and its code string. */
+typedef struct ct_data_s {
+    union {
+        ush  freq;       /* frequency count */
+        ush  code;       /* bit string */
+    } fc;
+    union {
+        ush  dad;        /* father node in Huffman tree */
+        ush  len;        /* length of bit string */
+    } dl;
+} FAR ct_data;
+
+#define Freq fc.freq
+#define Code fc.code
+#define Dad  dl.dad
+#define Len  dl.len
+
+typedef struct static_tree_desc_s  static_tree_desc;
+
+typedef struct tree_desc_s {
+    ct_data *dyn_tree;           /* the dynamic tree */
+    int     max_code;            /* largest code with non zero frequency */
+    static_tree_desc *stat_desc; /* the corresponding static tree */
+} FAR tree_desc;
+
+typedef ush Pos;
+typedef Pos FAR Posf;
+typedef unsigned IPos;
+
+/* A Pos is an index in the character window. We use short instead of int to
+ * save space in the various tables. IPos is used only for parameter passing.
+ */
+
+typedef struct internal_state {
+    z_streamp strm;      /* pointer back to this zlib stream */
+    int   status;        /* as the name implies */
+    Bytef *pending_buf;  /* output still pending */
+    Bytef *pending_out;  /* next pending byte to output to the stream */
+    int   pending;       /* nb of bytes in the pending buffer */
+    int   noheader;      /* suppress zlib header and adler32 */
+    Byte  data_type;     /* UNKNOWN, BINARY or ASCII */
+    Byte  method;        /* STORED (for zip only) or DEFLATED */
+    int   last_flush;    /* value of flush param for previous deflate call */
+
+                /* used by deflate.c: */
+
+    uInt  w_size;        /* LZ77 window size (32K by default) */
+    uInt  w_bits;        /* log2(w_size)  (8..16) */
+    uInt  w_mask;        /* w_size - 1 */
+
+    Bytef *window;
+    /* Sliding window. Input bytes are read into the second half of the window,
+     * and move to the first half later to keep a dictionary of at least wSize
+     * bytes. With this organization, matches are limited to a distance of
+     * wSize-MAX_MATCH bytes, but this ensures that IO is always
+     * performed with a length multiple of the block size. Also, it limits
+     * the window size to 64K, which is quite useful on MSDOS.
+     * To do: use the user input buffer as sliding window.
+     */
+
+    ulg window_size;
+    /* Actual size of window: 2*wSize, except when the user input buffer
+     * is directly used as sliding window.
+     */
+
+    Posf *prev;
+    /* Link to older string with same hash index. To limit the size of this
+     * array to 64K, this link is maintained only for the last 32K strings.
+     * An index in this array is thus a window index modulo 32K.
+     */
+
+    Posf *head; /* Heads of the hash chains or NIL. */
+
+    uInt  ins_h;          /* hash index of string to be inserted */
+    uInt  hash_size;      /* number of elements in hash table */
+    uInt  hash_bits;      /* log2(hash_size) */
+    uInt  hash_mask;      /* hash_size-1 */
+
+    uInt  hash_shift;
+    /* Number of bits by which ins_h must be shifted at each input
+     * step. It must be such that after MIN_MATCH steps, the oldest
+     * byte no longer takes part in the hash key, that is:
+     *   hash_shift * MIN_MATCH >= hash_bits
+     */
+
+    long block_start;
+    /* Window position at the beginning of the current output block. Gets
+     * negative when the window is moved backwards.
+     */
+
+    uInt match_length;           /* length of best match */
+    IPos prev_match;             /* previous match */
+    int match_available;         /* set if previous match exists */
+    uInt strstart;               /* start of string to insert */
+    uInt match_start;            /* start of matching string */
+    uInt lookahead;              /* number of valid bytes ahead in window */
+
+    uInt prev_length;
+    /* Length of the best match at previous step. Matches not greater than this
+     * are discarded. This is used in the lazy match evaluation.
+     */
+
+    uInt max_chain_length;
+    /* To speed up deflation, hash chains are never searched beyond this
+     * length.  A higher limit improves compression ratio but degrades the
+     * speed.
+     */
+
+    uInt max_lazy_match;
+    /* Attempt to find a better match only when the current match is strictly
+     * smaller than this value. This mechanism is used only for compression
+     * levels >= 4.
+     */
+#   define max_insert_length  max_lazy_match
+    /* Insert new strings in the hash table only if the match length is not
+     * greater than this length. This saves time but degrades compression.
+     * max_insert_length is used only for compression levels <= 3.
+     */
+
+    int level;    /* compression level (1..9) */
+    int strategy; /* favor or force Huffman coding*/
+
+    uInt good_match;
+    /* Use a faster search when the previous match is longer than this */
+
+    int nice_match; /* Stop searching when current match exceeds this */
+
+                /* used by trees.c: */
+    /* Didn't use ct_data typedef below to supress compiler warning */
+    struct ct_data_s dyn_ltree[HEAP_SIZE];   /* literal and length tree */
+    struct ct_data_s dyn_dtree[2*D_CODES+1]; /* distance tree */
+    struct ct_data_s bl_tree[2*BL_CODES+1];  /* Huffman tree for bit lengths */
+
+    struct tree_desc_s l_desc;               /* desc. for literal tree */
+    struct tree_desc_s d_desc;               /* desc. for distance tree */
+    struct tree_desc_s bl_desc;              /* desc. for bit length tree */
+
+    ush bl_count[MAX_BITS+1];
+    /* number of codes at each bit length for an optimal tree */
+
+    int heap[2*L_CODES+1];      /* heap used to build the Huffman trees */
+    int heap_len;               /* number of elements in the heap */
+    int heap_max;               /* element of largest frequency */
+    /* The sons of heap[n] are heap[2*n] and heap[2*n+1]. heap[0] is not used.
+     * The same heap array is used to build all trees.
+     */
+
+    uch depth[2*L_CODES+1];
+    /* Depth of each subtree used as tie breaker for trees of equal frequency
+     */
+
+    uchf *l_buf;          /* buffer for literals or lengths */
+
+    uInt  lit_bufsize;
+    /* Size of match buffer for literals/lengths.  There are 4 reasons for
+     * limiting lit_bufsize to 64K:
+     *   - frequencies can be kept in 16 bit counters
+     *   - if compression is not successful for the first block, all input
+     *     data is still in the window so we can still emit a stored block even
+     *     when input comes from standard input.  (This can also be done for
+     *     all blocks if lit_bufsize is not greater than 32K.)
+     *   - if compression is not successful for a file smaller than 64K, we can
+     *     even emit a stored file instead of a stored block (saving 5 bytes).
+     *     This is applicable only for zip (not gzip or zlib).
+     *   - creating new Huffman trees less frequently may not provide fast
+     *     adaptation to changes in the input data statistics. (Take for
+     *     example a binary file with poorly compressible code followed by
+     *     a highly compressible string table.) Smaller buffer sizes give
+     *     fast adaptation but have of course the overhead of transmitting
+     *     trees more frequently.
+     *   - I can't count above 4
+     */
+
+    uInt last_lit;      /* running index in l_buf */
+
+    ushf *d_buf;
+    /* Buffer for distances. To simplify the code, d_buf and l_buf have
+     * the same number of elements. To use different lengths, an extra flag
+     * array would be necessary.
+     */
+
+    ulg opt_len;        /* bit length of current block with optimal trees */
+    ulg static_len;     /* bit length of current block with static trees */
+    ulg compressed_len; /* total bit length of compressed file */
+    uInt matches;       /* number of string matches in current block */
+    int last_eob_len;   /* bit length of EOB code for last block */
+
+#ifdef DEBUG
+    ulg bits_sent;      /* bit length of the compressed data */
+#endif
+
+    ush bi_buf;
+    /* Output buffer. bits are inserted starting at the bottom (least
+     * significant bits).
+     */
+    int bi_valid;
+    /* Number of valid bits in bi_buf.  All bits above the last valid bit
+     * are always zero.
+     */
+
+} FAR deflate_state;
+
+/* Output a byte on the stream.
+ * IN assertion: there is enough room in pending_buf.
+ */
+#define put_byte(s, c) {s->pending_buf[s->pending++] = (c);}
+
+
+#define MIN_LOOKAHEAD (MAX_MATCH+MIN_MATCH+1)
+/* Minimum amount of lookahead, except at the end of the input file.
+ * See deflate.c for comments about the MIN_MATCH+1.
+ */
+
+#define MAX_DIST(s)  ((s)->w_size-MIN_LOOKAHEAD)
+/* In order to simplify the code, particularly on 16 bit machines, match
+ * distances are limited to MAX_DIST instead of WSIZE.
+ */
+
+        /* in trees.c */
+void _tr_init         OF((deflate_state *s));
+int  _tr_tally        OF((deflate_state *s, unsigned dist, unsigned lc));
+ulg  _tr_flush_block  OF((deflate_state *s, charf *buf, ulg stored_len,
+			  int eof));
+void _tr_align        OF((deflate_state *s));
+void _tr_stored_block OF((deflate_state *s, charf *buf, ulg stored_len,
+                          int eof));
+#endif
diff -urN g10-0.2.5/zlib/example.c g10-0.2.6/zlib/example.c
--- g10-0.2.5/zlib/example.c	Thu May 23 19:11:28 1996
+++ g10-0.2.6/zlib/example.c	Thu Feb 12 15:39:01 1998
@@ -3,7 +3,7 @@
  * For conditions of distribution and use, see copyright notice in zlib.h 
  */
 
-/* $Id: example.c,v 1.16 1996/05/23 17:11:28 me Exp $ */
+/* $Id: example.c,v 1.1 1998/02/12 14:39:01 wk Exp $ */
 
 #include <stdio.h>
 #include "zlib.h"
diff -urN g10-0.2.5/zlib/gzio.c g10-0.2.6/zlib/gzio.c
--- g10-0.2.5/zlib/gzio.c	Wed Jul 24 15:41:01 1996
+++ g10-0.2.6/zlib/gzio.c	Thu Feb 12 15:39:01 1998
@@ -3,7 +3,7 @@
  * For conditions of distribution and use, see copyright notice in zlib.h
  */
 
-/* $Id: gzio.c,v 1.14 1996/07/24 13:41:01 me Exp $ */
+/* $Id: gzio.c,v 1.1 1998/02/12 14:39:01 wk Exp $ */
 
 #include <stdio.h>
 
diff -urN g10-0.2.5/zlib/infblock.h g10-0.2.6/zlib/infblock.h
--- g10-0.2.5/zlib/infblock.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/zlib/infblock.h	Fri Jun 28 16:01:24 1996
@@ -0,0 +1,37 @@
+/* infblock.h -- header to use infblock.c
+ * Copyright (C) 1995-1996 Mark Adler
+ * For conditions of distribution and use, see copyright notice in zlib.h 
+ */
+
+/* WARNING: this file should *not* be used by applications. It is
+   part of the implementation of the compression library and is
+   subject to change. Applications should only use zlib.h.
+ */
+
+struct inflate_blocks_state;
+typedef struct inflate_blocks_state FAR inflate_blocks_statef;
+
+extern inflate_blocks_statef * inflate_blocks_new OF((
+    z_streamp z,
+    check_func c,               /* check function */
+    uInt w));                   /* window size */
+
+extern int inflate_blocks OF((
+    inflate_blocks_statef *,
+    z_streamp ,
+    int));                      /* initial return code */
+
+extern void inflate_blocks_reset OF((
+    inflate_blocks_statef *,
+    z_streamp ,
+    uLongf *));                  /* check value on output */
+
+extern int inflate_blocks_free OF((
+    inflate_blocks_statef *,
+    z_streamp ,
+    uLongf *));                  /* check value on output */
+
+extern void inflate_set_dictionary OF((
+    inflate_blocks_statef *s,
+    const Bytef *d,  /* dictionary */
+    uInt  n));       /* dictionary length */
diff -urN g10-0.2.5/zlib/infcodes.h g10-0.2.6/zlib/infcodes.h
--- g10-0.2.5/zlib/infcodes.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/zlib/infcodes.h	Fri Jun 28 16:01:25 1996
@@ -0,0 +1,27 @@
+/* infcodes.h -- header to use infcodes.c
+ * Copyright (C) 1995-1996 Mark Adler
+ * For conditions of distribution and use, see copyright notice in zlib.h 
+ */
+
+/* WARNING: this file should *not* be used by applications. It is
+   part of the implementation of the compression library and is
+   subject to change. Applications should only use zlib.h.
+ */
+
+struct inflate_codes_state;
+typedef struct inflate_codes_state FAR inflate_codes_statef;
+
+extern inflate_codes_statef *inflate_codes_new OF((
+    uInt, uInt,
+    inflate_huft *, inflate_huft *,
+    z_streamp ));
+
+extern int inflate_codes OF((
+    inflate_blocks_statef *,
+    z_streamp ,
+    int));
+
+extern void inflate_codes_free OF((
+    inflate_codes_statef *,
+    z_streamp ));
+
diff -urN g10-0.2.5/zlib/inffast.h g10-0.2.6/zlib/inffast.h
--- g10-0.2.5/zlib/inffast.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/zlib/inffast.h	Fri Jun 28 16:01:25 1996
@@ -0,0 +1,17 @@
+/* inffast.h -- header to use inffast.c
+ * Copyright (C) 1995-1996 Mark Adler
+ * For conditions of distribution and use, see copyright notice in zlib.h 
+ */
+
+/* WARNING: this file should *not* be used by applications. It is
+   part of the implementation of the compression library and is
+   subject to change. Applications should only use zlib.h.
+ */
+
+extern int inflate_fast OF((
+    uInt,
+    uInt,
+    inflate_huft *,
+    inflate_huft *,
+    inflate_blocks_statef *,
+    z_streamp ));
diff -urN g10-0.2.5/zlib/inftrees.h g10-0.2.6/zlib/inftrees.h
--- g10-0.2.5/zlib/inftrees.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/zlib/inftrees.h	Fri Jun 28 16:01:25 1996
@@ -0,0 +1,59 @@
+/* inftrees.h -- header to use inftrees.c
+ * Copyright (C) 1995-1996 Mark Adler
+ * For conditions of distribution and use, see copyright notice in zlib.h 
+ */
+
+/* WARNING: this file should *not* be used by applications. It is
+   part of the implementation of the compression library and is
+   subject to change. Applications should only use zlib.h.
+ */
+
+/* Huffman code lookup table entry--this entry is four bytes for machines
+   that have 16-bit pointers (e.g. PC's in the small or medium model). */
+
+typedef struct inflate_huft_s FAR inflate_huft;
+
+struct inflate_huft_s {
+  union {
+    struct {
+      Byte Exop;        /* number of extra bits or operation */
+      Byte Bits;        /* number of bits in this code or subcode */
+    } what;
+    Bytef *pad;         /* pad structure to a power of 2 (4 bytes for */
+  } word;               /*  16-bit, 8 bytes for 32-bit machines) */
+  union {
+    uInt Base;          /* literal, length base, or distance base */
+    inflate_huft *Next; /* pointer to next level of table */
+  } more;
+};
+
+#ifdef DEBUG
+  extern uInt inflate_hufts;
+#endif
+
+extern int inflate_trees_bits OF((
+    uIntf *,                    /* 19 code lengths */
+    uIntf *,                    /* bits tree desired/actual depth */
+    inflate_huft * FAR *,       /* bits tree result */
+    z_streamp ));               /* for zalloc, zfree functions */
+
+extern int inflate_trees_dynamic OF((
+    uInt,                       /* number of literal/length codes */
+    uInt,                       /* number of distance codes */
+    uIntf *,                    /* that many (total) code lengths */
+    uIntf *,                    /* literal desired/actual bit depth */
+    uIntf *,                    /* distance desired/actual bit depth */
+    inflate_huft * FAR *,       /* literal/length tree result */
+    inflate_huft * FAR *,       /* distance tree result */
+    z_streamp ));               /* for zalloc, zfree functions */
+
+extern int inflate_trees_fixed OF((
+    uIntf *,                    /* literal desired/actual bit depth */
+    uIntf *,                    /* distance desired/actual bit depth */
+    inflate_huft * FAR *,       /* literal/length tree result */
+    inflate_huft * FAR *));     /* distance tree result */
+
+extern int inflate_trees_free OF((
+    inflate_huft *,             /* tables to free */
+    z_streamp ));               /* for zfree function */
+
diff -urN g10-0.2.5/zlib/infutil.h g10-0.2.6/zlib/infutil.h
--- g10-0.2.5/zlib/infutil.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/zlib/infutil.h	Fri Jun 28 16:01:25 1996
@@ -0,0 +1,99 @@
+/* infutil.h -- types and macros common to blocks and codes
+ * Copyright (C) 1995-1996 Mark Adler
+ * For conditions of distribution and use, see copyright notice in zlib.h 
+ */
+
+/* WARNING: this file should *not* be used by applications. It is
+   part of the implementation of the compression library and is
+   subject to change. Applications should only use zlib.h.
+ */
+
+#ifndef _INFUTIL_H
+#define _INFUTIL_H
+
+typedef enum {
+      TYPE,     /* get type bits (3, including end bit) */
+      LENS,     /* get lengths for stored */
+      STORED,   /* processing stored block */
+      TABLE,    /* get table lengths */
+      BTREE,    /* get bit lengths tree for a dynamic block */
+      DTREE,    /* get length, distance trees for a dynamic block */
+      CODES,    /* processing fixed or dynamic block */
+      DRY,      /* output remaining window bytes */
+      DONE,     /* finished last block, done */
+      BAD}      /* got a data error--stuck here */
+inflate_block_mode;
+
+/* inflate blocks semi-private state */
+struct inflate_blocks_state {
+
+  /* mode */
+  inflate_block_mode  mode;     /* current inflate_block mode */
+
+  /* mode dependent information */
+  union {
+    uInt left;          /* if STORED, bytes left to copy */
+    struct {
+      uInt table;               /* table lengths (14 bits) */
+      uInt index;               /* index into blens (or border) */
+      uIntf *blens;             /* bit lengths of codes */
+      uInt bb;                  /* bit length tree depth */
+      inflate_huft *tb;         /* bit length decoding tree */
+    } trees;            /* if DTREE, decoding info for trees */
+    struct {
+      inflate_huft *tl;
+      inflate_huft *td;         /* trees to free */
+      inflate_codes_statef 
+         *codes;
+    } decode;           /* if CODES, current state */
+  } sub;                /* submode */
+  uInt last;            /* true if this block is the last block */
+
+  /* mode independent information */
+  uInt bitk;            /* bits in bit buffer */
+  uLong bitb;           /* bit buffer */
+  Bytef *window;        /* sliding window */
+  Bytef *end;           /* one byte after sliding window */
+  Bytef *read;          /* window read pointer */
+  Bytef *write;         /* window write pointer */
+  check_func checkfn;   /* check function */
+  uLong check;          /* check on output */
+
+};
+
+
+/* defines for inflate input/output */
+/*   update pointers and return */
+#define UPDBITS {s->bitb=b;s->bitk=k;}
+#define UPDIN {z->avail_in=n;z->total_in+=p-z->next_in;z->next_in=p;}
+#define UPDOUT {s->write=q;}
+#define UPDATE {UPDBITS UPDIN UPDOUT}
+#define LEAVE {UPDATE return inflate_flush(s,z,r);}
+/*   get bytes and bits */
+#define LOADIN {p=z->next_in;n=z->avail_in;b=s->bitb;k=s->bitk;}
+#define NEEDBYTE {if(n)r=Z_OK;else LEAVE}
+#define NEXTBYTE (n--,*p++)
+#define NEEDBITS(j) {while(k<(j)){NEEDBYTE;b|=((uLong)NEXTBYTE)<<k;k+=8;}}
+#define DUMPBITS(j) {b>>=(j);k-=(j);}
+/*   output bytes */
+#define WAVAIL (uInt)(q<s->read?s->read-q-1:s->end-q)
+#define LOADOUT {q=s->write;m=(uInt)WAVAIL;}
+#define WRAP {if(q==s->end&&s->read!=s->window){q=s->window;m=(uInt)WAVAIL;}}
+#define FLUSH {UPDOUT r=inflate_flush(s,z,r); LOADOUT}
+#define NEEDOUT {if(m==0){WRAP if(m==0){FLUSH WRAP if(m==0) LEAVE}}r=Z_OK;}
+#define OUTBYTE(a) {*q++=(Byte)(a);m--;}
+/*   load local pointers */
+#define LOAD {LOADIN LOADOUT}
+
+/* masks for lower bits (size given to avoid silly warnings with Visual C++) */
+extern uInt inflate_mask[17];
+
+/* copy as much as possible from the sliding window to the output area */
+extern int inflate_flush OF((
+    inflate_blocks_statef *,
+    z_streamp ,
+    int));
+
+struct internal_state      {int dummy;}; /* for buggy compilers */
+
+#endif
diff -urN g10-0.2.5/zlib/trees.c g10-0.2.6/zlib/trees.c
--- g10-0.2.5/zlib/trees.c	Wed Jul 24 15:41:06 1996
+++ g10-0.2.6/zlib/trees.c	Thu Feb 12 15:39:03 1998
@@ -29,7 +29,7 @@
  *          Addison-Wesley, 1983. ISBN 0-201-06672-6.
  */
 
-/* $Id: trees.c,v 1.11 1996/07/24 13:41:06 me Exp $ */
+/* $Id: trees.c,v 1.1 1998/02/12 14:39:03 wk Exp $ */
 
 #include "deflate.h"
 
diff -urN g10-0.2.5/zlib/uncompr.c g10-0.2.6/zlib/uncompr.c
--- g10-0.2.5/zlib/uncompr.c	Tue Jan 30 22:59:26 1996
+++ g10-0.2.6/zlib/uncompr.c	Thu Feb 12 15:39:03 1998
@@ -3,7 +3,7 @@
  * For conditions of distribution and use, see copyright notice in zlib.h 
  */
 
-/* $Id: uncompr.c,v 1.8 1996/01/30 21:59:26 me Exp $ */
+/* $Id: uncompr.c,v 1.1 1998/02/12 14:39:03 wk Exp $ */
 
 #include "zlib.h"
 
diff -urN g10-0.2.5/zlib/zconf.h g10-0.2.6/zlib/zconf.h
--- g10-0.2.5/zlib/zconf.h	Thu Feb 12 14:09:03 1998
+++ g10-0.2.6/zlib/zconf.h	Thu Feb 12 15:39:03 1998
@@ -3,7 +3,7 @@
  * For conditions of distribution and use, see copyright notice in zlib.h
  */
 
-/* $Id: zconf.h,v 1.20 1996/07/02 15:09:28 me Exp $ */
+/* $Id: zconf.h,v 1.1 1998/02/12 14:39:03 wk Exp $ */
 
 #ifndef _ZCONF_H
 #define _ZCONF_H
diff -urN g10-0.2.5/zlib/zutil.c g10-0.2.6/zlib/zutil.c
--- g10-0.2.5/zlib/zutil.c	Wed Jul 24 15:41:12 1996
+++ g10-0.2.6/zlib/zutil.c	Thu Feb 12 15:39:08 1998
@@ -3,7 +3,7 @@
  * For conditions of distribution and use, see copyright notice in zlib.h 
  */
 
-/* $Id: zutil.c,v 1.17 1996/07/24 13:41:12 me Exp $ */
+/* $Id: zutil.c,v 1.1 1998/02/12 14:39:08 wk Exp $ */
 
 #include <stdio.h>
 
diff -urN g10-0.2.5/zlib/zutil.h g10-0.2.6/zlib/zutil.h
--- g10-0.2.5/zlib/zutil.h	Thu Jan  1 01:00:00 1970
+++ g10-0.2.6/zlib/zutil.h	Thu Feb 12 15:39:08 1998
@@ -0,0 +1,203 @@
+/* zutil.h -- internal interface and configuration of the compression library
+ * Copyright (C) 1995-1996 Jean-loup Gailly.
+ * For conditions of distribution and use, see copyright notice in zlib.h
+ */
+
+/* WARNING: this file should *not* be used by applications. It is
+   part of the implementation of the compression library and is
+   subject to change. Applications should only use zlib.h.
+ */
+
+/* $Id: zutil.h,v 1.1 1998/02/12 14:39:08 wk Exp $ */
+
+#ifndef _Z_UTIL_H
+#define _Z_UTIL_H
+
+#include "zlib.h"
+
+#if defined(MSDOS)||defined(VMS)||defined(CRAY)||defined(WIN32)||defined(RISCOS)
+#   include <stddef.h>
+#   include <errno.h>
+#else
+    extern int errno;
+#endif
+#ifdef STDC
+#  include <string.h>
+#  include <stdlib.h>
+#endif
+
+#ifndef local
+#  define local static
+#endif
+/* compile with -Dlocal if your debugger can't find static symbols */
+
+typedef unsigned char  uch;
+typedef uch FAR uchf;
+typedef unsigned short ush;
+typedef ush FAR ushf;
+typedef unsigned long  ulg;
+
+extern const char *z_errmsg[10]; /* indexed by 2-zlib_error */
+/* (size given to avoid silly warnings with Visual C++) */
+
+#define ERR_MSG(err) z_errmsg[Z_NEED_DICT-(err)]
+
+#define ERR_RETURN(strm,err) \
+  return (strm->msg = (char*)ERR_MSG(err), (err))
+/* To be used only when the state is known to be valid */
+
+        /* common constants */
+
+#ifndef DEF_WBITS
+#  define DEF_WBITS MAX_WBITS
+#endif
+/* default windowBits for decompression. MAX_WBITS is for compression only */
+
+#if MAX_MEM_LEVEL >= 8
+#  define DEF_MEM_LEVEL 8
+#else
+#  define DEF_MEM_LEVEL  MAX_MEM_LEVEL
+#endif
+/* default memLevel */
+
+#define STORED_BLOCK 0
+#define STATIC_TREES 1
+#define DYN_TREES    2
+/* The three kinds of block type */
+
+#define MIN_MATCH  3
+#define MAX_MATCH  258
+/* The minimum and maximum match lengths */
+
+#define PRESET_DICT 0x20 /* preset dictionary flag in zlib header */
+
+        /* target dependencies */
+
+#ifdef MSDOS
+#  define OS_CODE  0x00
+#  ifdef __TURBOC__
+#    include <alloc.h>
+#  else /* MSC or DJGPP */
+#    include <malloc.h>
+#  endif
+#endif
+
+#ifdef OS2
+#  define OS_CODE  0x06
+#endif
+
+#ifdef WIN32 /* Window 95 & Windows NT */
+#  define OS_CODE  0x0b
+#endif
+
+#if defined(VAXC) || defined(VMS)
+#  define OS_CODE  0x02
+#  define FOPEN(name, mode) \
+     fopen((name), (mode), "mbc=60", "ctx=stm", "rfm=fix", "mrs=512")
+#endif
+
+#ifdef AMIGA
+#  define OS_CODE  0x01
+#endif
+
+#if defined(ATARI) || defined(atarist)
+#  define OS_CODE  0x05
+#endif
+
+#ifdef MACOS
+#  define OS_CODE  0x07
+#endif
+
+#ifdef __50SERIES /* Prime/PRIMOS */
+#  define OS_CODE  0x0F
+#endif
+
+#ifdef TOPS20
+#  define OS_CODE  0x0a
+#endif
+
+#if defined(_BEOS_) || defined(RISCOS)
+#  define fdopen(fd,mode) NULL /* No fdopen() */
+#endif
+
+        /* Common defaults */
+
+#ifndef OS_CODE
+#  define OS_CODE  0x03  /* assume Unix */
+#endif
+
+#ifndef FOPEN
+#  define FOPEN(name, mode) fopen((name), (mode))
+#endif
+
+         /* functions */
+
+#ifdef HAVE_STRERROR
+   extern char *strerror OF((int));
+#  define zstrerror(errnum) strerror(errnum)
+#else
+#  define zstrerror(errnum) ""
+#endif
+
+#if defined(pyr)
+#  define NO_MEMCPY
+#endif
+#if (defined(M_I86SM) || defined(M_I86MM)) && !defined(_MSC_VER)
+ /* Use our own functions for small and medium model with MSC <= 5.0.
+  * You may have to use the same strategy for Borland C (untested).
+  */
+#  define NO_MEMCPY
+#endif
+#if defined(STDC) && !defined(HAVE_MEMCPY) && !defined(NO_MEMCPY)
+#  define HAVE_MEMCPY
+#endif
+#ifdef HAVE_MEMCPY
+#  ifdef SMALL_MEDIUM /* MSDOS small or medium model */
+#    define zmemcpy _fmemcpy
+#    define zmemcmp _fmemcmp
+#    define zmemzero(dest, len) _fmemset(dest, 0, len)
+#  else
+#    define zmemcpy memcpy
+#    define zmemcmp memcmp
+#    define zmemzero(dest, len) memset(dest, 0, len)
+#  endif
+#else
+   extern void zmemcpy  OF((Bytef* dest, Bytef* source, uInt len));
+   extern int  zmemcmp  OF((Bytef* s1,   Bytef* s2, uInt len));
+   extern void zmemzero OF((Bytef* dest, uInt len));
+#endif
+
+/* Diagnostic functions */
+#ifdef DEBUG
+#  include <stdio.h>
+#  ifndef verbose
+#    define verbose 0
+#  endif
+   extern void z_error    OF((char *m));
+#  define Assert(cond,msg) {if(!(cond)) z_error(msg);}
+#  define Trace(x) fprintf x
+#  define Tracev(x) {if (verbose) fprintf x ;}
+#  define Tracevv(x) {if (verbose>1) fprintf x ;}
+#  define Tracec(c,x) {if (verbose && (c)) fprintf x ;}
+#  define Tracecv(c,x) {if (verbose>1 && (c)) fprintf x ;}
+#else
+#  define Assert(cond,msg)
+#  define Trace(x)
+#  define Tracev(x)
+#  define Tracevv(x)
+#  define Tracec(c,x)
+#  define Tracecv(c,x)
+#endif
+
+
+typedef uLong (*check_func) OF((uLong check, const Bytef *buf, uInt len));
+
+voidpf zcalloc OF((voidpf opaque, unsigned items, unsigned size));
+void   zcfree  OF((voidpf opaque, voidpf ptr));
+
+#define ZALLOC(strm, items, size) \
+           (*((strm)->zalloc))((strm)->opaque, (items), (size))
+#define ZFREE(strm, addr)  (*((strm)->zfree))((strm)->opaque, (voidpf)(addr))
+#define TRY_FREE(s, p) {if (p) ZFREE(s, p);}
+
+#endif /* _Z_UTIL_H */
